# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_hdmap_msgs/Routing.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_hdmap_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class Routing(genpy.Message):
  _md5sum = "e7f46f497d0d65259d09484ba48d7a66"
  _type = "ad_hdmap_msgs/Routing"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp(last node pub time), and frame_id
std_msgs/Header header

# Time cost of routing process in nanosecond
uint64 process_time_ns
# Name of trigger source for debug
string trigger_src

# Routing info
RoutingNode[] node_list
RoutingLine[] navigation_line
# Response point info
geometry_msgs/Point departure_enu
geometry_msgs/Point destination_enu

# Debug info
string debug_info

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_hdmap_msgs/RoutingNode
# Node type and ID
string node_id
uint8 node_type

string lane_id
string road_id
float64 accu_length

# Section inherit
string from_section
string to_section

# Lane inherit
string from_lane
string to_lane

================================================================================
MSG: ad_hdmap_msgs/RoutingLine
# LLA coordinate
MapCoordLLA lla

# ENU points
geometry_msgs/Point enu

================================================================================
MSG: ad_hdmap_msgs/MapCoordLLA
# LLA coordinate
float64 longitude
float64 latitude
float64 altitude

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['header','process_time_ns','trigger_src','node_list','navigation_line','departure_enu','destination_enu','debug_info']
  _slot_types = ['std_msgs/Header','uint64','string','ad_hdmap_msgs/RoutingNode[]','ad_hdmap_msgs/RoutingLine[]','geometry_msgs/Point','geometry_msgs/Point','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,process_time_ns,trigger_src,node_list,navigation_line,departure_enu,destination_enu,debug_info

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Routing, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.process_time_ns is None:
        self.process_time_ns = 0
      if self.trigger_src is None:
        self.trigger_src = ''
      if self.node_list is None:
        self.node_list = []
      if self.navigation_line is None:
        self.navigation_line = []
      if self.departure_enu is None:
        self.departure_enu = geometry_msgs.msg.Point()
      if self.destination_enu is None:
        self.destination_enu = geometry_msgs.msg.Point()
      if self.debug_info is None:
        self.debug_info = ''
    else:
      self.header = std_msgs.msg.Header()
      self.process_time_ns = 0
      self.trigger_src = ''
      self.node_list = []
      self.navigation_line = []
      self.departure_enu = geometry_msgs.msg.Point()
      self.destination_enu = geometry_msgs.msg.Point()
      self.debug_info = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.process_time_ns
      buff.write(_get_struct_Q().pack(_x))
      _x = self.trigger_src
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.node_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.node_list:
        _x = val1.node_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_type
        buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.road_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.accu_length
        buff.write(_get_struct_d().pack(_x))
        _x = val1.from_section
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.to_section
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.from_lane
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.to_lane
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.navigation_line)
      buff.write(_struct_I.pack(length))
      for val1 in self.navigation_line:
        _v1 = val1.lla
        _x = _v1
        buff.write(_get_struct_3d().pack(_x.longitude, _x.latitude, _x.altitude))
        _v2 = val1.enu
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_6d().pack(_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z))
      _x = self.debug_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.node_list is None:
        self.node_list = None
      if self.navigation_line is None:
        self.navigation_line = None
      if self.departure_enu is None:
        self.departure_enu = geometry_msgs.msg.Point()
      if self.destination_enu is None:
        self.destination_enu = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 8
      (self.process_time_ns,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.trigger_src = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.trigger_src = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.node_list = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.RoutingNode()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.node_id = str[start:end]
        start = end
        end += 1
        (val1.node_type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.lane_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.lane_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.road_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.road_id = str[start:end]
        start = end
        end += 8
        (val1.accu_length,) = _get_struct_d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.from_section = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.from_section = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.to_section = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.to_section = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.from_lane = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.from_lane = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.to_lane = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.to_lane = str[start:end]
        self.node_list.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.navigation_line = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.RoutingLine()
        _v3 = val1.lla
        _x = _v3
        start = end
        end += 24
        (_x.longitude, _x.latitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
        _v4 = val1.enu
        _x = _v4
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.navigation_line.append(val1)
      _x = self
      start = end
      end += 48
      (_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.debug_info = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.process_time_ns
      buff.write(_get_struct_Q().pack(_x))
      _x = self.trigger_src
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.node_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.node_list:
        _x = val1.node_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_type
        buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.road_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.accu_length
        buff.write(_get_struct_d().pack(_x))
        _x = val1.from_section
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.to_section
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.from_lane
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.to_lane
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.navigation_line)
      buff.write(_struct_I.pack(length))
      for val1 in self.navigation_line:
        _v5 = val1.lla
        _x = _v5
        buff.write(_get_struct_3d().pack(_x.longitude, _x.latitude, _x.altitude))
        _v6 = val1.enu
        _x = _v6
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_6d().pack(_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z))
      _x = self.debug_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.node_list is None:
        self.node_list = None
      if self.navigation_line is None:
        self.navigation_line = None
      if self.departure_enu is None:
        self.departure_enu = geometry_msgs.msg.Point()
      if self.destination_enu is None:
        self.destination_enu = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 8
      (self.process_time_ns,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.trigger_src = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.trigger_src = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.node_list = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.RoutingNode()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.node_id = str[start:end]
        start = end
        end += 1
        (val1.node_type,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.lane_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.lane_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.road_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.road_id = str[start:end]
        start = end
        end += 8
        (val1.accu_length,) = _get_struct_d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.from_section = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.from_section = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.to_section = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.to_section = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.from_lane = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.from_lane = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.to_lane = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.to_lane = str[start:end]
        self.node_list.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.navigation_line = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.RoutingLine()
        _v7 = val1.lla
        _x = _v7
        start = end
        end += 24
        (_x.longitude, _x.latitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
        _v8 = val1.enu
        _x = _v8
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.navigation_line.append(val1)
      _x = self
      start = end
      end += 48
      (_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.debug_info = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_6d = None
def _get_struct_6d():
    global _struct_6d
    if _struct_6d is None:
        _struct_6d = struct.Struct("<6d")
    return _struct_6d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
