# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_hdmap_msgs/RerouteByENURequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class RerouteByENURequest(genpy.Message):
  _md5sum = "80477dd8fdfd30e63d11688783824540"
  _type = "ad_hdmap_msgs/RerouteByENURequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Target point
geometry_msgs/Point departure_enu
geometry_msgs/Point destination_enu
# Points ENU
geometry_msgs/Point[] mid_points_enu
geometry_msgs/Point[] blacklist_points_enu
# Pull over at destination
# if set true, will use the rightest lane at destination
bool destination_pull_over

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['departure_enu','destination_enu','mid_points_enu','blacklist_points_enu','destination_pull_over']
  _slot_types = ['geometry_msgs/Point','geometry_msgs/Point','geometry_msgs/Point[]','geometry_msgs/Point[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       departure_enu,destination_enu,mid_points_enu,blacklist_points_enu,destination_pull_over

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RerouteByENURequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.departure_enu is None:
        self.departure_enu = geometry_msgs.msg.Point()
      if self.destination_enu is None:
        self.destination_enu = geometry_msgs.msg.Point()
      if self.mid_points_enu is None:
        self.mid_points_enu = []
      if self.blacklist_points_enu is None:
        self.blacklist_points_enu = []
      if self.destination_pull_over is None:
        self.destination_pull_over = False
    else:
      self.departure_enu = geometry_msgs.msg.Point()
      self.destination_enu = geometry_msgs.msg.Point()
      self.mid_points_enu = []
      self.blacklist_points_enu = []
      self.destination_pull_over = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_6d().pack(_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z))
      length = len(self.mid_points_enu)
      buff.write(_struct_I.pack(length))
      for val1 in self.mid_points_enu:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      length = len(self.blacklist_points_enu)
      buff.write(_struct_I.pack(length))
      for val1 in self.blacklist_points_enu:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self.destination_pull_over
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.departure_enu is None:
        self.departure_enu = geometry_msgs.msg.Point()
      if self.destination_enu is None:
        self.destination_enu = geometry_msgs.msg.Point()
      if self.mid_points_enu is None:
        self.mid_points_enu = None
      if self.blacklist_points_enu is None:
        self.blacklist_points_enu = None
      end = 0
      _x = self
      start = end
      end += 48
      (_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mid_points_enu = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.mid_points_enu.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.blacklist_points_enu = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.blacklist_points_enu.append(val1)
      start = end
      end += 1
      (self.destination_pull_over,) = _get_struct_B().unpack(str[start:end])
      self.destination_pull_over = bool(self.destination_pull_over)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_6d().pack(_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z))
      length = len(self.mid_points_enu)
      buff.write(_struct_I.pack(length))
      for val1 in self.mid_points_enu:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      length = len(self.blacklist_points_enu)
      buff.write(_struct_I.pack(length))
      for val1 in self.blacklist_points_enu:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self.destination_pull_over
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.departure_enu is None:
        self.departure_enu = geometry_msgs.msg.Point()
      if self.destination_enu is None:
        self.destination_enu = geometry_msgs.msg.Point()
      if self.mid_points_enu is None:
        self.mid_points_enu = None
      if self.blacklist_points_enu is None:
        self.blacklist_points_enu = None
      end = 0
      _x = self
      start = end
      end += 48
      (_x.departure_enu.x, _x.departure_enu.y, _x.departure_enu.z, _x.destination_enu.x, _x.destination_enu.y, _x.destination_enu.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mid_points_enu = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.mid_points_enu.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.blacklist_points_enu = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.blacklist_points_enu.append(val1)
      start = end
      end += 1
      (self.destination_pull_over,) = _get_struct_B().unpack(str[start:end])
      self.destination_pull_over = bool(self.destination_pull_over)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_6d = None
def _get_struct_6d():
    global _struct_6d
    if _struct_6d is None:
        _struct_6d = struct.Struct("<6d")
    return _struct_6d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_hdmap_msgs/RerouteByENUResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RerouteByENUResponse(genpy.Message):
  _md5sum = "937c9679a518e3a18d831e57125ea522"
  _type = "ad_hdmap_msgs/RerouteByENUResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Response result info
bool success
string message

"""
  __slots__ = ['success','message']
  _slot_types = ['bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       success,message

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RerouteByENUResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.message is None:
        self.message = ''
    else:
      self.success = False
      self.message = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class RerouteByENU(object):
  _type          = 'ad_hdmap_msgs/RerouteByENU'
  _md5sum = '2996421b07db29d61f90f4ad1becd237'
  _request_class  = RerouteByENURequest
  _response_class = RerouteByENUResponse
