# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_hdmap_msgs/RerouteByLLARequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_hdmap_msgs.msg

class RerouteByLLARequest(genpy.Message):
  _md5sum = "c602f008641df70a381698c34e09678b"
  _type = "ad_hdmap_msgs/RerouteByLLARequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Target point
MapCoordLLA departure_lla
MapCoordLLA destination_lla
# Points LLA
MapCoordLLA[] mid_points_lla
MapCoordLLA[] blacklist_points_lla
# Pull over at destination
# if set true, will use the rightest lane at destination
bool destination_pull_over

================================================================================
MSG: ad_hdmap_msgs/MapCoordLLA
# LLA coordinate
float64 longitude
float64 latitude
float64 altitude
"""
  __slots__ = ['departure_lla','destination_lla','mid_points_lla','blacklist_points_lla','destination_pull_over']
  _slot_types = ['ad_hdmap_msgs/MapCoordLLA','ad_hdmap_msgs/MapCoordLLA','ad_hdmap_msgs/MapCoordLLA[]','ad_hdmap_msgs/MapCoordLLA[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       departure_lla,destination_lla,mid_points_lla,blacklist_points_lla,destination_pull_over

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RerouteByLLARequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.departure_lla is None:
        self.departure_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      if self.destination_lla is None:
        self.destination_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      if self.mid_points_lla is None:
        self.mid_points_lla = []
      if self.blacklist_points_lla is None:
        self.blacklist_points_lla = []
      if self.destination_pull_over is None:
        self.destination_pull_over = False
    else:
      self.departure_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      self.destination_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      self.mid_points_lla = []
      self.blacklist_points_lla = []
      self.destination_pull_over = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_6d().pack(_x.departure_lla.longitude, _x.departure_lla.latitude, _x.departure_lla.altitude, _x.destination_lla.longitude, _x.destination_lla.latitude, _x.destination_lla.altitude))
      length = len(self.mid_points_lla)
      buff.write(_struct_I.pack(length))
      for val1 in self.mid_points_lla:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.longitude, _x.latitude, _x.altitude))
      length = len(self.blacklist_points_lla)
      buff.write(_struct_I.pack(length))
      for val1 in self.blacklist_points_lla:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.longitude, _x.latitude, _x.altitude))
      _x = self.destination_pull_over
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.departure_lla is None:
        self.departure_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      if self.destination_lla is None:
        self.destination_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      if self.mid_points_lla is None:
        self.mid_points_lla = None
      if self.blacklist_points_lla is None:
        self.blacklist_points_lla = None
      end = 0
      _x = self
      start = end
      end += 48
      (_x.departure_lla.longitude, _x.departure_lla.latitude, _x.departure_lla.altitude, _x.destination_lla.longitude, _x.destination_lla.latitude, _x.destination_lla.altitude,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mid_points_lla = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.MapCoordLLA()
        _x = val1
        start = end
        end += 24
        (_x.longitude, _x.latitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
        self.mid_points_lla.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.blacklist_points_lla = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.MapCoordLLA()
        _x = val1
        start = end
        end += 24
        (_x.longitude, _x.latitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
        self.blacklist_points_lla.append(val1)
      start = end
      end += 1
      (self.destination_pull_over,) = _get_struct_B().unpack(str[start:end])
      self.destination_pull_over = bool(self.destination_pull_over)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_6d().pack(_x.departure_lla.longitude, _x.departure_lla.latitude, _x.departure_lla.altitude, _x.destination_lla.longitude, _x.destination_lla.latitude, _x.destination_lla.altitude))
      length = len(self.mid_points_lla)
      buff.write(_struct_I.pack(length))
      for val1 in self.mid_points_lla:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.longitude, _x.latitude, _x.altitude))
      length = len(self.blacklist_points_lla)
      buff.write(_struct_I.pack(length))
      for val1 in self.blacklist_points_lla:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.longitude, _x.latitude, _x.altitude))
      _x = self.destination_pull_over
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.departure_lla is None:
        self.departure_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      if self.destination_lla is None:
        self.destination_lla = ad_hdmap_msgs.msg.MapCoordLLA()
      if self.mid_points_lla is None:
        self.mid_points_lla = None
      if self.blacklist_points_lla is None:
        self.blacklist_points_lla = None
      end = 0
      _x = self
      start = end
      end += 48
      (_x.departure_lla.longitude, _x.departure_lla.latitude, _x.departure_lla.altitude, _x.destination_lla.longitude, _x.destination_lla.latitude, _x.destination_lla.altitude,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.mid_points_lla = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.MapCoordLLA()
        _x = val1
        start = end
        end += 24
        (_x.longitude, _x.latitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
        self.mid_points_lla.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.blacklist_points_lla = []
      for i in range(0, length):
        val1 = ad_hdmap_msgs.msg.MapCoordLLA()
        _x = val1
        start = end
        end += 24
        (_x.longitude, _x.latitude, _x.altitude,) = _get_struct_3d().unpack(str[start:end])
        self.blacklist_points_lla.append(val1)
      start = end
      end += 1
      (self.destination_pull_over,) = _get_struct_B().unpack(str[start:end])
      self.destination_pull_over = bool(self.destination_pull_over)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_6d = None
def _get_struct_6d():
    global _struct_6d
    if _struct_6d is None:
        _struct_6d = struct.Struct("<6d")
    return _struct_6d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_hdmap_msgs/RerouteByLLAResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RerouteByLLAResponse(genpy.Message):
  _md5sum = "937c9679a518e3a18d831e57125ea522"
  _type = "ad_hdmap_msgs/RerouteByLLAResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Response result info
bool success
string message

"""
  __slots__ = ['success','message']
  _slot_types = ['bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       success,message

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RerouteByLLAResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.message is None:
        self.message = ''
    else:
      self.success = False
      self.message = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.success
      buff.write(_get_struct_B().pack(_x))
      _x = self.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class RerouteByLLA(object):
  _type          = 'ad_hdmap_msgs/RerouteByLLA'
  _md5sum = 'ade2dd172cd2e831ab0f9bb1a1a7a798'
  _request_class  = RerouteByLLARequest
  _response_class = RerouteByLLAResponse
