# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_localization_msgs/NavStateInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class NavStateInfo(genpy.Message):
  _md5sum = "2e98b301f452bfe9d8755b6a278e5777"
  _type = "ad_localization_msgs/NavStateInfo"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp(last node pub time), and frame_id(sensor model)
std_msgs/Header header

# The time of pose measurement, in nano second.
uint64 measurement_time_ns

# Report localization status
# when INVALID or CONVERGING, localization result is not reliable and should not be used.
string status_info

# For debug
string debug_info

# Position of the Vehicle Reference Point(VRP) in the Map reference frame(East/North/Up).
# The VRP is the car center(Forward/Left/Up).
# x for East, y for North, z for Up Height, in meters.
geometry_msgs/Point position_enu
# Position uncertainty(standard deviation in meters)
geometry_msgs/Point position_enu_std_dev

# Position of the Vehicle Reference Point(VRP) in the WGS84 reference ellipsoid coordinate system.
# longitude in degrees, ranging from -180 to 180.
# latitude in degrees, ranging from -90 to 90.
# ellipsoid height in meters.
float64 longitude
float64 latitude
float64 altitude

# Attitude in euler angle form to describe the orientation of a VRP frame with respect to a Map reference frame(ENU).
# The roll, in (-pi/2, pi/2), corresponds to a rotation around the Vehicle Forward-axis.
# The pitch, in [-pi, pi), corresponds to a rotation around the Vehicle Left-axis.
# The yaw, in [-pi, pi), corresponds to a rotation around the Vehicle Up-axis.
# The yaw is the angle of the Vehicle head w.r.t the ENU reference frame, East = 0, North = pi/2, anti-clockwise in radius.
# The direction of rotation follows the right-hand rule.
float64 roll
float64 pitch
float64 yaw

# Attitude uncertainty(standard deviation in radians)
geometry_msgs/Point attitude_std_dev

# Linear velocity of the VRP in the Vehicle reference frame
# x for Forward, y for Left, z for Up, in meters per second
geometry_msgs/Vector3 linear_velocity

# Linear velocity of the VRP in the ENU reference frame
# x for East, y for North, z for Up, in meters per second
geometry_msgs/Vector3 linear_velocity_global

# Linear acceleration of the VRP in the Vehicle reference frame
# x for Forward, y for Left, z for Up, in meters per power second
geometry_msgs/Vector3 linear_acceleration

# Linear acceleration of the VRP in the ENU reference frame
# x for East, y for North, z for Up, in meters per power second
geometry_msgs/Vector3 linear_acceleration_global

# Angular velocity of the VRP in the Vehicle reference frame
# x across Forward axes, y across Left axes,
# z across Up axes, in radians per second
geometry_msgs/Point angular_velocity

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['header','measurement_time_ns','status_info','debug_info','position_enu','position_enu_std_dev','longitude','latitude','altitude','roll','pitch','yaw','attitude_std_dev','linear_velocity','linear_velocity_global','linear_acceleration','linear_acceleration_global','angular_velocity']
  _slot_types = ['std_msgs/Header','uint64','string','string','geometry_msgs/Point','geometry_msgs/Point','float64','float64','float64','float64','float64','float64','geometry_msgs/Point','geometry_msgs/Vector3','geometry_msgs/Vector3','geometry_msgs/Vector3','geometry_msgs/Vector3','geometry_msgs/Point']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,measurement_time_ns,status_info,debug_info,position_enu,position_enu_std_dev,longitude,latitude,altitude,roll,pitch,yaw,attitude_std_dev,linear_velocity,linear_velocity_global,linear_acceleration,linear_acceleration_global,angular_velocity

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NavStateInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.measurement_time_ns is None:
        self.measurement_time_ns = 0
      if self.status_info is None:
        self.status_info = ''
      if self.debug_info is None:
        self.debug_info = ''
      if self.position_enu is None:
        self.position_enu = geometry_msgs.msg.Point()
      if self.position_enu_std_dev is None:
        self.position_enu_std_dev = geometry_msgs.msg.Point()
      if self.longitude is None:
        self.longitude = 0.
      if self.latitude is None:
        self.latitude = 0.
      if self.altitude is None:
        self.altitude = 0.
      if self.roll is None:
        self.roll = 0.
      if self.pitch is None:
        self.pitch = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.attitude_std_dev is None:
        self.attitude_std_dev = geometry_msgs.msg.Point()
      if self.linear_velocity is None:
        self.linear_velocity = geometry_msgs.msg.Vector3()
      if self.linear_velocity_global is None:
        self.linear_velocity_global = geometry_msgs.msg.Vector3()
      if self.linear_acceleration is None:
        self.linear_acceleration = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_global is None:
        self.linear_acceleration_global = geometry_msgs.msg.Vector3()
      if self.angular_velocity is None:
        self.angular_velocity = geometry_msgs.msg.Point()
    else:
      self.header = std_msgs.msg.Header()
      self.measurement_time_ns = 0
      self.status_info = ''
      self.debug_info = ''
      self.position_enu = geometry_msgs.msg.Point()
      self.position_enu_std_dev = geometry_msgs.msg.Point()
      self.longitude = 0.
      self.latitude = 0.
      self.altitude = 0.
      self.roll = 0.
      self.pitch = 0.
      self.yaw = 0.
      self.attitude_std_dev = geometry_msgs.msg.Point()
      self.linear_velocity = geometry_msgs.msg.Vector3()
      self.linear_velocity_global = geometry_msgs.msg.Vector3()
      self.linear_acceleration = geometry_msgs.msg.Vector3()
      self.linear_acceleration_global = geometry_msgs.msg.Vector3()
      self.angular_velocity = geometry_msgs.msg.Point()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.measurement_time_ns
      buff.write(_get_struct_Q().pack(_x))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.debug_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_30d().pack(_x.position_enu.x, _x.position_enu.y, _x.position_enu.z, _x.position_enu_std_dev.x, _x.position_enu_std_dev.y, _x.position_enu_std_dev.z, _x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.attitude_std_dev.x, _x.attitude_std_dev.y, _x.attitude_std_dev.z, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z, _x.linear_velocity_global.x, _x.linear_velocity_global.y, _x.linear_velocity_global.z, _x.linear_acceleration.x, _x.linear_acceleration.y, _x.linear_acceleration.z, _x.linear_acceleration_global.x, _x.linear_acceleration_global.y, _x.linear_acceleration_global.z, _x.angular_velocity.x, _x.angular_velocity.y, _x.angular_velocity.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.position_enu is None:
        self.position_enu = geometry_msgs.msg.Point()
      if self.position_enu_std_dev is None:
        self.position_enu_std_dev = geometry_msgs.msg.Point()
      if self.attitude_std_dev is None:
        self.attitude_std_dev = geometry_msgs.msg.Point()
      if self.linear_velocity is None:
        self.linear_velocity = geometry_msgs.msg.Vector3()
      if self.linear_velocity_global is None:
        self.linear_velocity_global = geometry_msgs.msg.Vector3()
      if self.linear_acceleration is None:
        self.linear_acceleration = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_global is None:
        self.linear_acceleration_global = geometry_msgs.msg.Vector3()
      if self.angular_velocity is None:
        self.angular_velocity = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 8
      (self.measurement_time_ns,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.debug_info = str[start:end]
      _x = self
      start = end
      end += 240
      (_x.position_enu.x, _x.position_enu.y, _x.position_enu.z, _x.position_enu_std_dev.x, _x.position_enu_std_dev.y, _x.position_enu_std_dev.z, _x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.attitude_std_dev.x, _x.attitude_std_dev.y, _x.attitude_std_dev.z, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z, _x.linear_velocity_global.x, _x.linear_velocity_global.y, _x.linear_velocity_global.z, _x.linear_acceleration.x, _x.linear_acceleration.y, _x.linear_acceleration.z, _x.linear_acceleration_global.x, _x.linear_acceleration_global.y, _x.linear_acceleration_global.z, _x.angular_velocity.x, _x.angular_velocity.y, _x.angular_velocity.z,) = _get_struct_30d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.measurement_time_ns
      buff.write(_get_struct_Q().pack(_x))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.debug_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_30d().pack(_x.position_enu.x, _x.position_enu.y, _x.position_enu.z, _x.position_enu_std_dev.x, _x.position_enu_std_dev.y, _x.position_enu_std_dev.z, _x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.attitude_std_dev.x, _x.attitude_std_dev.y, _x.attitude_std_dev.z, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z, _x.linear_velocity_global.x, _x.linear_velocity_global.y, _x.linear_velocity_global.z, _x.linear_acceleration.x, _x.linear_acceleration.y, _x.linear_acceleration.z, _x.linear_acceleration_global.x, _x.linear_acceleration_global.y, _x.linear_acceleration_global.z, _x.angular_velocity.x, _x.angular_velocity.y, _x.angular_velocity.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.position_enu is None:
        self.position_enu = geometry_msgs.msg.Point()
      if self.position_enu_std_dev is None:
        self.position_enu_std_dev = geometry_msgs.msg.Point()
      if self.attitude_std_dev is None:
        self.attitude_std_dev = geometry_msgs.msg.Point()
      if self.linear_velocity is None:
        self.linear_velocity = geometry_msgs.msg.Vector3()
      if self.linear_velocity_global is None:
        self.linear_velocity_global = geometry_msgs.msg.Vector3()
      if self.linear_acceleration is None:
        self.linear_acceleration = geometry_msgs.msg.Vector3()
      if self.linear_acceleration_global is None:
        self.linear_acceleration_global = geometry_msgs.msg.Vector3()
      if self.angular_velocity is None:
        self.angular_velocity = geometry_msgs.msg.Point()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 8
      (self.measurement_time_ns,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.debug_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.debug_info = str[start:end]
      _x = self
      start = end
      end += 240
      (_x.position_enu.x, _x.position_enu.y, _x.position_enu.z, _x.position_enu_std_dev.x, _x.position_enu_std_dev.y, _x.position_enu_std_dev.z, _x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.attitude_std_dev.x, _x.attitude_std_dev.y, _x.attitude_std_dev.z, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z, _x.linear_velocity_global.x, _x.linear_velocity_global.y, _x.linear_velocity_global.z, _x.linear_acceleration.x, _x.linear_acceleration.y, _x.linear_acceleration.z, _x.linear_acceleration_global.x, _x.linear_acceleration_global.y, _x.linear_acceleration_global.z, _x.angular_velocity.x, _x.angular_velocity.y, _x.angular_velocity.z,) = _get_struct_30d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_30d = None
def _get_struct_30d():
    global _struct_30d
    if _struct_30d is None:
        _struct_30d = struct.Struct("<30d")
    return _struct_30d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
