# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_perception_msgs/LidarDangerousZoneFrame.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_perception_msgs.msg
import std_msgs.msg

class LidarDangerousZoneFrame(genpy.Message):
  _md5sum = "b9d4ff3c61a9e25ec3e5a1f331030bce"
  _type = "ad_perception_msgs/LidarDangerousZoneFrame"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp, and frame_id
std_msgs/Header header

uint64 frame_timestamp_ns

# enum SensorID
int16 sensor_id

float64 height

# enum DangerousZoneType
int16 type

LidarDangerousZone[] dzones
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_perception_msgs/LidarDangerousZone
Point2f[] polygon

# enum dangerous zone level
int16 dangerous_level

uint64 dzone_id

uint64[] pre_dzone_ids
uint64[] occluder_ids
uint64[] shadow_ids
float32 height

# enum DzoneType
int16 type

================================================================================
MSG: ad_perception_msgs/Point2f
float32 x
float32 y"""
  __slots__ = ['header','frame_timestamp_ns','sensor_id','height','type','dzones']
  _slot_types = ['std_msgs/Header','uint64','int16','float64','int16','ad_perception_msgs/LidarDangerousZone[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,frame_timestamp_ns,sensor_id,height,type,dzones

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LidarDangerousZoneFrame, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.frame_timestamp_ns is None:
        self.frame_timestamp_ns = 0
      if self.sensor_id is None:
        self.sensor_id = 0
      if self.height is None:
        self.height = 0.
      if self.type is None:
        self.type = 0
      if self.dzones is None:
        self.dzones = []
    else:
      self.header = std_msgs.msg.Header()
      self.frame_timestamp_ns = 0
      self.sensor_id = 0
      self.height = 0.
      self.type = 0
      self.dzones = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Qhdh().pack(_x.frame_timestamp_ns, _x.sensor_id, _x.height, _x.type))
      length = len(self.dzones)
      buff.write(_struct_I.pack(length))
      for val1 in self.dzones:
        length = len(val1.polygon)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygon:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_hQ().pack(_x.dangerous_level, _x.dzone_id))
        length = len(val1.pre_dzone_ids)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*val1.pre_dzone_ids))
        length = len(val1.occluder_ids)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*val1.occluder_ids))
        length = len(val1.shadow_ids)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*val1.shadow_ids))
        _x = val1
        buff.write(_get_struct_fh().pack(_x.height, _x.type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.dzones is None:
        self.dzones = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.frame_timestamp_ns, _x.sensor_id, _x.height, _x.type,) = _get_struct_Qhdh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.dzones = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.LidarDangerousZone()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygon = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.polygon.append(val2)
        _x = val1
        start = end
        end += 10
        (_x.dangerous_level, _x.dzone_id,) = _get_struct_hQ().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.pre_dzone_ids = s.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.occluder_ids = s.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.shadow_ids = s.unpack(str[start:end])
        _x = val1
        start = end
        end += 6
        (_x.height, _x.type,) = _get_struct_fh().unpack(str[start:end])
        self.dzones.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Qhdh().pack(_x.frame_timestamp_ns, _x.sensor_id, _x.height, _x.type))
      length = len(self.dzones)
      buff.write(_struct_I.pack(length))
      for val1 in self.dzones:
        length = len(val1.polygon)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygon:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_hQ().pack(_x.dangerous_level, _x.dzone_id))
        length = len(val1.pre_dzone_ids)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(val1.pre_dzone_ids.tostring())
        length = len(val1.occluder_ids)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(val1.occluder_ids.tostring())
        length = len(val1.shadow_ids)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(val1.shadow_ids.tostring())
        _x = val1
        buff.write(_get_struct_fh().pack(_x.height, _x.type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.dzones is None:
        self.dzones = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.frame_timestamp_ns, _x.sensor_id, _x.height, _x.type,) = _get_struct_Qhdh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.dzones = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.LidarDangerousZone()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygon = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.polygon.append(val2)
        _x = val1
        start = end
        end += 10
        (_x.dangerous_level, _x.dzone_id,) = _get_struct_hQ().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.pre_dzone_ids = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.occluder_ids = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.shadow_ids = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = val1
        start = end
        end += 6
        (_x.height, _x.type,) = _get_struct_fh().unpack(str[start:end])
        self.dzones.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_Qhdh = None
def _get_struct_Qhdh():
    global _struct_Qhdh
    if _struct_Qhdh is None:
        _struct_Qhdh = struct.Struct("<Qhdh")
    return _struct_Qhdh
_struct_fh = None
def _get_struct_fh():
    global _struct_fh
    if _struct_fh is None:
        _struct_fh = struct.Struct("<fh")
    return _struct_fh
_struct_hQ = None
def _get_struct_hQ():
    global _struct_hQ
    if _struct_hQ is None:
        _struct_hQ = struct.Struct("<hQ")
    return _struct_hQ
