# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_perception_msgs/Object.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_perception_msgs.msg

class Object(genpy.Message):
  _md5sum = "86547c805858c998b78d0f02f388691f"
  _type = "ad_perception_msgs/Object"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """## BaseObject

# enum SensorID
int16 sensor_id
# enum ObjectLabel
int16 label
float32 type_confidence
float32 existence_confidence
# enum ObjectLabel
int16 sub_type

# ObjectLabel
int16 UNKNOWN=0
int16 PEDESTRIAN=1
int16 VEHICLE=2
int16 VEHICLE_CAR=3
int16 VEHICLE_SUV=4
int16 VEHICLE_VAN=5
int16 VEHICLE_TRUCK=6
int16 VEHICLE_PICKUP_TRUCK=7
int16 VEHICLE_BUS=8
int16 VEHICLE_TAXI=9
int16 VEHICLE_EMERGENCY=10
int16 VEHICLE_SCHOOL_BUS=11
int16 VEHICLE_OTHERS=12
int16 VEHICLE_END=13
int16 BIKE=14
int16 NO_PERSON_VEHICLE=15
int16 BIKE_BICYCLE=16
int16 BIKE_BIKEBIG=17
int16 BIKE_BIKESMALL=18
int16 BIKE_END=19
int16 TRAFFICLIGHT_ALL=20
int16 TRAFFICLIGHT_END=64
int16 TRAFFICSIGN_ALL=65
int16 TRAFFICSIGN_END=135
int16 OBSTACLE_ALL=136
int16 OBSTACLE_END=150
int16 ROADMARKER_ALL=151
int16 ROADMARKER_END=162

float32[] sub_type_probs
int32 track_id
float32 track_age_time_second
uint64 last_measure_update_timestamp_ns
uint64 current_prediction_timestamp_ns

SizeInfo size_info
PolygonBox polygon_box
DirectionInfo direction_info
MotionInfo motion_info
int16 motion_status
float32 motion_static_score

# enum MaintenanceStatus
int16 maintenance_status
# enum OcclusionStatus
int16 occlusion_status

# ModelOutputFeatures
ModelOutputFeature[] feature

# CameraBBox2DInfo
CameraBBox2DInfo camera_bbox_info

# Derived object type : used only between ros nodes to determine dynamic type of object
uint8 derived_type
# Derived types
uint8 CAMERA_NON_VEHICLE=1
uint8 CAMERA_PEDESTRIAN=2
uint8 CAMERA_VEHICLE=3
uint8 CAMERA_STATIC_OBSTACLE=4
uint8 LIDAR_OBJECT=5
uint8 RADAR_OBJECT=6
uint8 FUSION_OBJECT=7

## Shared: NonAutomobileVehicle Pedestrian Automobile
BaseCameraAttribute attribute

## Shared: Automobile FusionObject
AutomobileLightStatus automobile_light_status

## Static Obstacle Specific
bool is_right_edge_detected
Vector4i right_edge_line

## NonAutomobileVehicle Specific
# enum NonAutomobileVehicleLightStatus
NonAutomobileVehicleLightStatus non_automobile_vehicle_light_status
bool is_with_ped

## Pedestrian Specific
# action enum AttrBool
int8 umbrella
int8 call
int8 phone
int8 wave
int8 standing
# direction
Point2f upper_body_direction
Point2f lower_body_direction
Point2f face_direction
# intention
PedestrianIntention intention
bool is_on_bike

## Automobile Specific
DepthDetPoint depth_point

## LidarObject Specific
uint64 point_cloud_timestamp_ns

## RadarObject Specific
float64 track_range
float64 track_range_rate
float64 track_range_accel_rate
float64 track_lat_rate

## FusionObject Specific
MatchedSensorObjectInfo[] matched_sensor_object_info
================================================================================
MSG: ad_perception_msgs/SizeInfo
bool is_valid

Vector3f size
Matrix3f size_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3f
float32 x
float32 y
float32 z
================================================================================
MSG: ad_perception_msgs/Matrix3f
Vector3f x
Vector3f y
Vector3f z

================================================================================
MSG: ad_perception_msgs/PolygonBox
bool is_valid
Point2f[] polygon_contour
float32 height_lower_surface
float32 height_upper_surface
================================================================================
MSG: ad_perception_msgs/Point2f
float32 x
float32 y
================================================================================
MSG: ad_perception_msgs/DirectionInfo
bool is_valid

Vector3f direction_ypr
Matrix3f direction_ypr_uncertainty
float32 yaw
float32 yaw_uncertainty
float32 yaw_rate
float32 yaw_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/MotionInfo
bool is_valid

# enum MotionStatus
int16 motion_status

Vector3d center
Matrix3f center_uncertainty
Vector3f velocity
Matrix3f velocity_uncertainty
Vector3f acceleration
Matrix3f acceleration_uncertainty
Vector3f jerk
Matrix3f jerk_uncertainty
float32 velocity_heading
float32 velocity_heading_uncertainty
float32 velocity_heading_rate
float32 velocity_heading_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3d
float64 x
float64 y
float64 z

================================================================================
MSG: ad_perception_msgs/ModelOutputFeature
string key
float32[] value
================================================================================
MSG: ad_perception_msgs/CameraBBox2DInfo
Bbox2D raw_detection_box
Bbox2D tracked_box
================================================================================
MSG: ad_perception_msgs/Bbox2D
bool initialized
float32 top_left_x
float32 top_left_y
float32 bottom_right_x
float32 bottom_right_y
float32 confidence
================================================================================
MSG: ad_perception_msgs/BaseCameraAttribute
bool is_landmark_valid
Point2f[] landmark
float32[] landmark_scores

bool is_direction_valid
Point2f viewport_direction

================================================================================
MSG: ad_perception_msgs/AutomobileLightStatus
int16 left_turn
int16 right_turn
int16 hazard
int16 brake
================================================================================
MSG: ad_perception_msgs/Vector4i
int32 x
int32 y
int32 z
int32 w

================================================================================
MSG: ad_perception_msgs/NonAutomobileVehicleLightStatus
int16 left_turn
int16 right_turn
int16 brake
================================================================================
MSG: ad_perception_msgs/PedestrianIntention
# enum Intention
int16 crossing
# enum AttentionBool
int16 attention_to_ego_car
================================================================================
MSG: ad_perception_msgs/DepthDetPoint
float32 nearest_point_x
float32 depth_point_x
float32 depth_point_y
int32 orientation
# enum DepthFineOriLabel
int16 label
================================================================================
MSG: ad_perception_msgs/MatchedSensorObjectInfo
# enum SensorID
int16 sensor_id

uint64 frame_timestamp_ns
uint64 object_id"""
  # Pseudo-constants
  UNKNOWN = 0
  PEDESTRIAN = 1
  VEHICLE = 2
  VEHICLE_CAR = 3
  VEHICLE_SUV = 4
  VEHICLE_VAN = 5
  VEHICLE_TRUCK = 6
  VEHICLE_PICKUP_TRUCK = 7
  VEHICLE_BUS = 8
  VEHICLE_TAXI = 9
  VEHICLE_EMERGENCY = 10
  VEHICLE_SCHOOL_BUS = 11
  VEHICLE_OTHERS = 12
  VEHICLE_END = 13
  BIKE = 14
  NO_PERSON_VEHICLE = 15
  BIKE_BICYCLE = 16
  BIKE_BIKEBIG = 17
  BIKE_BIKESMALL = 18
  BIKE_END = 19
  TRAFFICLIGHT_ALL = 20
  TRAFFICLIGHT_END = 64
  TRAFFICSIGN_ALL = 65
  TRAFFICSIGN_END = 135
  OBSTACLE_ALL = 136
  OBSTACLE_END = 150
  ROADMARKER_ALL = 151
  ROADMARKER_END = 162
  CAMERA_NON_VEHICLE = 1
  CAMERA_PEDESTRIAN = 2
  CAMERA_VEHICLE = 3
  CAMERA_STATIC_OBSTACLE = 4
  LIDAR_OBJECT = 5
  RADAR_OBJECT = 6
  FUSION_OBJECT = 7

  __slots__ = ['sensor_id','label','type_confidence','existence_confidence','sub_type','sub_type_probs','track_id','track_age_time_second','last_measure_update_timestamp_ns','current_prediction_timestamp_ns','size_info','polygon_box','direction_info','motion_info','motion_status','motion_static_score','maintenance_status','occlusion_status','feature','camera_bbox_info','derived_type','attribute','automobile_light_status','is_right_edge_detected','right_edge_line','non_automobile_vehicle_light_status','is_with_ped','umbrella','call','phone','wave','standing','upper_body_direction','lower_body_direction','face_direction','intention','is_on_bike','depth_point','point_cloud_timestamp_ns','track_range','track_range_rate','track_range_accel_rate','track_lat_rate','matched_sensor_object_info']
  _slot_types = ['int16','int16','float32','float32','int16','float32[]','int32','float32','uint64','uint64','ad_perception_msgs/SizeInfo','ad_perception_msgs/PolygonBox','ad_perception_msgs/DirectionInfo','ad_perception_msgs/MotionInfo','int16','float32','int16','int16','ad_perception_msgs/ModelOutputFeature[]','ad_perception_msgs/CameraBBox2DInfo','uint8','ad_perception_msgs/BaseCameraAttribute','ad_perception_msgs/AutomobileLightStatus','bool','ad_perception_msgs/Vector4i','ad_perception_msgs/NonAutomobileVehicleLightStatus','bool','int8','int8','int8','int8','int8','ad_perception_msgs/Point2f','ad_perception_msgs/Point2f','ad_perception_msgs/Point2f','ad_perception_msgs/PedestrianIntention','bool','ad_perception_msgs/DepthDetPoint','uint64','float64','float64','float64','float64','ad_perception_msgs/MatchedSensorObjectInfo[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       sensor_id,label,type_confidence,existence_confidence,sub_type,sub_type_probs,track_id,track_age_time_second,last_measure_update_timestamp_ns,current_prediction_timestamp_ns,size_info,polygon_box,direction_info,motion_info,motion_status,motion_static_score,maintenance_status,occlusion_status,feature,camera_bbox_info,derived_type,attribute,automobile_light_status,is_right_edge_detected,right_edge_line,non_automobile_vehicle_light_status,is_with_ped,umbrella,call,phone,wave,standing,upper_body_direction,lower_body_direction,face_direction,intention,is_on_bike,depth_point,point_cloud_timestamp_ns,track_range,track_range_rate,track_range_accel_rate,track_lat_rate,matched_sensor_object_info

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Object, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.sensor_id is None:
        self.sensor_id = 0
      if self.label is None:
        self.label = 0
      if self.type_confidence is None:
        self.type_confidence = 0.
      if self.existence_confidence is None:
        self.existence_confidence = 0.
      if self.sub_type is None:
        self.sub_type = 0
      if self.sub_type_probs is None:
        self.sub_type_probs = []
      if self.track_id is None:
        self.track_id = 0
      if self.track_age_time_second is None:
        self.track_age_time_second = 0.
      if self.last_measure_update_timestamp_ns is None:
        self.last_measure_update_timestamp_ns = 0
      if self.current_prediction_timestamp_ns is None:
        self.current_prediction_timestamp_ns = 0
      if self.size_info is None:
        self.size_info = ad_perception_msgs.msg.SizeInfo()
      if self.polygon_box is None:
        self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      if self.direction_info is None:
        self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      if self.motion_info is None:
        self.motion_info = ad_perception_msgs.msg.MotionInfo()
      if self.motion_status is None:
        self.motion_status = 0
      if self.motion_static_score is None:
        self.motion_static_score = 0.
      if self.maintenance_status is None:
        self.maintenance_status = 0
      if self.occlusion_status is None:
        self.occlusion_status = 0
      if self.feature is None:
        self.feature = []
      if self.camera_bbox_info is None:
        self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()
      if self.derived_type is None:
        self.derived_type = 0
      if self.attribute is None:
        self.attribute = ad_perception_msgs.msg.BaseCameraAttribute()
      if self.automobile_light_status is None:
        self.automobile_light_status = ad_perception_msgs.msg.AutomobileLightStatus()
      if self.is_right_edge_detected is None:
        self.is_right_edge_detected = False
      if self.right_edge_line is None:
        self.right_edge_line = ad_perception_msgs.msg.Vector4i()
      if self.non_automobile_vehicle_light_status is None:
        self.non_automobile_vehicle_light_status = ad_perception_msgs.msg.NonAutomobileVehicleLightStatus()
      if self.is_with_ped is None:
        self.is_with_ped = False
      if self.umbrella is None:
        self.umbrella = 0
      if self.call is None:
        self.call = 0
      if self.phone is None:
        self.phone = 0
      if self.wave is None:
        self.wave = 0
      if self.standing is None:
        self.standing = 0
      if self.upper_body_direction is None:
        self.upper_body_direction = ad_perception_msgs.msg.Point2f()
      if self.lower_body_direction is None:
        self.lower_body_direction = ad_perception_msgs.msg.Point2f()
      if self.face_direction is None:
        self.face_direction = ad_perception_msgs.msg.Point2f()
      if self.intention is None:
        self.intention = ad_perception_msgs.msg.PedestrianIntention()
      if self.is_on_bike is None:
        self.is_on_bike = False
      if self.depth_point is None:
        self.depth_point = ad_perception_msgs.msg.DepthDetPoint()
      if self.point_cloud_timestamp_ns is None:
        self.point_cloud_timestamp_ns = 0
      if self.track_range is None:
        self.track_range = 0.
      if self.track_range_rate is None:
        self.track_range_rate = 0.
      if self.track_range_accel_rate is None:
        self.track_range_accel_rate = 0.
      if self.track_lat_rate is None:
        self.track_lat_rate = 0.
      if self.matched_sensor_object_info is None:
        self.matched_sensor_object_info = []
    else:
      self.sensor_id = 0
      self.label = 0
      self.type_confidence = 0.
      self.existence_confidence = 0.
      self.sub_type = 0
      self.sub_type_probs = []
      self.track_id = 0
      self.track_age_time_second = 0.
      self.last_measure_update_timestamp_ns = 0
      self.current_prediction_timestamp_ns = 0
      self.size_info = ad_perception_msgs.msg.SizeInfo()
      self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      self.motion_info = ad_perception_msgs.msg.MotionInfo()
      self.motion_status = 0
      self.motion_static_score = 0.
      self.maintenance_status = 0
      self.occlusion_status = 0
      self.feature = []
      self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()
      self.derived_type = 0
      self.attribute = ad_perception_msgs.msg.BaseCameraAttribute()
      self.automobile_light_status = ad_perception_msgs.msg.AutomobileLightStatus()
      self.is_right_edge_detected = False
      self.right_edge_line = ad_perception_msgs.msg.Vector4i()
      self.non_automobile_vehicle_light_status = ad_perception_msgs.msg.NonAutomobileVehicleLightStatus()
      self.is_with_ped = False
      self.umbrella = 0
      self.call = 0
      self.phone = 0
      self.wave = 0
      self.standing = 0
      self.upper_body_direction = ad_perception_msgs.msg.Point2f()
      self.lower_body_direction = ad_perception_msgs.msg.Point2f()
      self.face_direction = ad_perception_msgs.msg.Point2f()
      self.intention = ad_perception_msgs.msg.PedestrianIntention()
      self.is_on_bike = False
      self.depth_point = ad_perception_msgs.msg.DepthDetPoint()
      self.point_cloud_timestamp_ns = 0
      self.track_range = 0.
      self.track_range_rate = 0.
      self.track_range_accel_rate = 0.
      self.track_lat_rate = 0.
      self.matched_sensor_object_info = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
      length = len(self.sub_type_probs)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.sub_type_probs))
      _x = self
      buff.write(_get_struct_if2QB12fB().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid))
      length = len(self.polygon_box.polygon_contour)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon_box.polygon_contour:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_2fB16fBh3d49fhf2h().pack(_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
      length = len(self.feature)
      buff.write(_struct_I.pack(length))
      for val1 in self.feature:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      _x = self
      buff.write(_get_struct_B5fB5f2B().pack(_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence, _x.derived_type, _x.attribute.is_landmark_valid))
      length = len(self.attribute.landmark)
      buff.write(_struct_I.pack(length))
      for val1 in self.attribute.landmark:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
      length = len(self.attribute.landmark_scores)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.attribute.landmark_scores))
      _x = self
      buff.write(_get_struct_B2f4hB4i3hB5b6f2hB3fihQ4d().pack(_x.attribute.is_direction_valid, _x.attribute.viewport_direction.x, _x.attribute.viewport_direction.y, _x.automobile_light_status.left_turn, _x.automobile_light_status.right_turn, _x.automobile_light_status.hazard, _x.automobile_light_status.brake, _x.is_right_edge_detected, _x.right_edge_line.x, _x.right_edge_line.y, _x.right_edge_line.z, _x.right_edge_line.w, _x.non_automobile_vehicle_light_status.left_turn, _x.non_automobile_vehicle_light_status.right_turn, _x.non_automobile_vehicle_light_status.brake, _x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing, _x.upper_body_direction.x, _x.upper_body_direction.y, _x.lower_body_direction.x, _x.lower_body_direction.y, _x.face_direction.x, _x.face_direction.y, _x.intention.crossing, _x.intention.attention_to_ego_car, _x.is_on_bike, _x.depth_point.nearest_point_x, _x.depth_point.depth_point_x, _x.depth_point.depth_point_y, _x.depth_point.orientation, _x.depth_point.label, _x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate))
      length = len(self.matched_sensor_object_info)
      buff.write(_struct_I.pack(length))
      for val1 in self.matched_sensor_object_info:
        _x = val1
        buff.write(_get_struct_h2Q().pack(_x.sensor_id, _x.frame_timestamp_ns, _x.object_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.size_info is None:
        self.size_info = ad_perception_msgs.msg.SizeInfo()
      if self.polygon_box is None:
        self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      if self.direction_info is None:
        self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      if self.motion_info is None:
        self.motion_info = ad_perception_msgs.msg.MotionInfo()
      if self.feature is None:
        self.feature = None
      if self.camera_bbox_info is None:
        self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()
      if self.attribute is None:
        self.attribute = ad_perception_msgs.msg.BaseCameraAttribute()
      if self.automobile_light_status is None:
        self.automobile_light_status = ad_perception_msgs.msg.AutomobileLightStatus()
      if self.right_edge_line is None:
        self.right_edge_line = ad_perception_msgs.msg.Vector4i()
      if self.non_automobile_vehicle_light_status is None:
        self.non_automobile_vehicle_light_status = ad_perception_msgs.msg.NonAutomobileVehicleLightStatus()
      if self.upper_body_direction is None:
        self.upper_body_direction = ad_perception_msgs.msg.Point2f()
      if self.lower_body_direction is None:
        self.lower_body_direction = ad_perception_msgs.msg.Point2f()
      if self.face_direction is None:
        self.face_direction = ad_perception_msgs.msg.Point2f()
      if self.intention is None:
        self.intention = ad_perception_msgs.msg.PedestrianIntention()
      if self.depth_point is None:
        self.depth_point = ad_perception_msgs.msg.DepthDetPoint()
      if self.matched_sensor_object_info is None:
        self.matched_sensor_object_info = None
      end = 0
      _x = self
      start = end
      end += 14
      (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.sub_type_probs = s.unpack(str[start:end])
      _x = self
      start = end
      end += 74
      (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid,) = _get_struct_if2QB12fB().unpack(str[start:end])
      self.size_info.is_valid = bool(self.size_info.is_valid)
      self.polygon_box.is_valid = bool(self.polygon_box.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon_box.polygon_contour = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Point2f()
        _x = val1
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        self.polygon_box.polygon_contour.append(val1)
      _x = self
      start = end
      end += 306
      (_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_2fB16fBh3d49fhf2h().unpack(str[start:end])
      self.direction_info.is_valid = bool(self.direction_info.is_valid)
      self.motion_info.is_valid = bool(self.motion_info.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.feature = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.ModelOutputFeature()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.feature.append(val1)
      _x = self
      start = end
      end += 44
      (_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence, _x.derived_type, _x.attribute.is_landmark_valid,) = _get_struct_B5fB5f2B().unpack(str[start:end])
      self.camera_bbox_info.raw_detection_box.initialized = bool(self.camera_bbox_info.raw_detection_box.initialized)
      self.camera_bbox_info.tracked_box.initialized = bool(self.camera_bbox_info.tracked_box.initialized)
      self.attribute.is_landmark_valid = bool(self.attribute.is_landmark_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attribute.landmark = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Point2f()
        _x = val1
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        self.attribute.landmark.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.attribute.landmark_scores = s.unpack(str[start:end])
      _x = self
      start = end
      end += 133
      (_x.attribute.is_direction_valid, _x.attribute.viewport_direction.x, _x.attribute.viewport_direction.y, _x.automobile_light_status.left_turn, _x.automobile_light_status.right_turn, _x.automobile_light_status.hazard, _x.automobile_light_status.brake, _x.is_right_edge_detected, _x.right_edge_line.x, _x.right_edge_line.y, _x.right_edge_line.z, _x.right_edge_line.w, _x.non_automobile_vehicle_light_status.left_turn, _x.non_automobile_vehicle_light_status.right_turn, _x.non_automobile_vehicle_light_status.brake, _x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing, _x.upper_body_direction.x, _x.upper_body_direction.y, _x.lower_body_direction.x, _x.lower_body_direction.y, _x.face_direction.x, _x.face_direction.y, _x.intention.crossing, _x.intention.attention_to_ego_car, _x.is_on_bike, _x.depth_point.nearest_point_x, _x.depth_point.depth_point_x, _x.depth_point.depth_point_y, _x.depth_point.orientation, _x.depth_point.label, _x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate,) = _get_struct_B2f4hB4i3hB5b6f2hB3fihQ4d().unpack(str[start:end])
      self.attribute.is_direction_valid = bool(self.attribute.is_direction_valid)
      self.is_right_edge_detected = bool(self.is_right_edge_detected)
      self.is_with_ped = bool(self.is_with_ped)
      self.is_on_bike = bool(self.is_on_bike)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.matched_sensor_object_info = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.MatchedSensorObjectInfo()
        _x = val1
        start = end
        end += 18
        (_x.sensor_id, _x.frame_timestamp_ns, _x.object_id,) = _get_struct_h2Q().unpack(str[start:end])
        self.matched_sensor_object_info.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
      length = len(self.sub_type_probs)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.sub_type_probs.tostring())
      _x = self
      buff.write(_get_struct_if2QB12fB().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid))
      length = len(self.polygon_box.polygon_contour)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon_box.polygon_contour:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_2fB16fBh3d49fhf2h().pack(_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
      length = len(self.feature)
      buff.write(_struct_I.pack(length))
      for val1 in self.feature:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      _x = self
      buff.write(_get_struct_B5fB5f2B().pack(_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence, _x.derived_type, _x.attribute.is_landmark_valid))
      length = len(self.attribute.landmark)
      buff.write(_struct_I.pack(length))
      for val1 in self.attribute.landmark:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
      length = len(self.attribute.landmark_scores)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.attribute.landmark_scores.tostring())
      _x = self
      buff.write(_get_struct_B2f4hB4i3hB5b6f2hB3fihQ4d().pack(_x.attribute.is_direction_valid, _x.attribute.viewport_direction.x, _x.attribute.viewport_direction.y, _x.automobile_light_status.left_turn, _x.automobile_light_status.right_turn, _x.automobile_light_status.hazard, _x.automobile_light_status.brake, _x.is_right_edge_detected, _x.right_edge_line.x, _x.right_edge_line.y, _x.right_edge_line.z, _x.right_edge_line.w, _x.non_automobile_vehicle_light_status.left_turn, _x.non_automobile_vehicle_light_status.right_turn, _x.non_automobile_vehicle_light_status.brake, _x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing, _x.upper_body_direction.x, _x.upper_body_direction.y, _x.lower_body_direction.x, _x.lower_body_direction.y, _x.face_direction.x, _x.face_direction.y, _x.intention.crossing, _x.intention.attention_to_ego_car, _x.is_on_bike, _x.depth_point.nearest_point_x, _x.depth_point.depth_point_x, _x.depth_point.depth_point_y, _x.depth_point.orientation, _x.depth_point.label, _x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate))
      length = len(self.matched_sensor_object_info)
      buff.write(_struct_I.pack(length))
      for val1 in self.matched_sensor_object_info:
        _x = val1
        buff.write(_get_struct_h2Q().pack(_x.sensor_id, _x.frame_timestamp_ns, _x.object_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.size_info is None:
        self.size_info = ad_perception_msgs.msg.SizeInfo()
      if self.polygon_box is None:
        self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      if self.direction_info is None:
        self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      if self.motion_info is None:
        self.motion_info = ad_perception_msgs.msg.MotionInfo()
      if self.feature is None:
        self.feature = None
      if self.camera_bbox_info is None:
        self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()
      if self.attribute is None:
        self.attribute = ad_perception_msgs.msg.BaseCameraAttribute()
      if self.automobile_light_status is None:
        self.automobile_light_status = ad_perception_msgs.msg.AutomobileLightStatus()
      if self.right_edge_line is None:
        self.right_edge_line = ad_perception_msgs.msg.Vector4i()
      if self.non_automobile_vehicle_light_status is None:
        self.non_automobile_vehicle_light_status = ad_perception_msgs.msg.NonAutomobileVehicleLightStatus()
      if self.upper_body_direction is None:
        self.upper_body_direction = ad_perception_msgs.msg.Point2f()
      if self.lower_body_direction is None:
        self.lower_body_direction = ad_perception_msgs.msg.Point2f()
      if self.face_direction is None:
        self.face_direction = ad_perception_msgs.msg.Point2f()
      if self.intention is None:
        self.intention = ad_perception_msgs.msg.PedestrianIntention()
      if self.depth_point is None:
        self.depth_point = ad_perception_msgs.msg.DepthDetPoint()
      if self.matched_sensor_object_info is None:
        self.matched_sensor_object_info = None
      end = 0
      _x = self
      start = end
      end += 14
      (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.sub_type_probs = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 74
      (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid,) = _get_struct_if2QB12fB().unpack(str[start:end])
      self.size_info.is_valid = bool(self.size_info.is_valid)
      self.polygon_box.is_valid = bool(self.polygon_box.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon_box.polygon_contour = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Point2f()
        _x = val1
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        self.polygon_box.polygon_contour.append(val1)
      _x = self
      start = end
      end += 306
      (_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_2fB16fBh3d49fhf2h().unpack(str[start:end])
      self.direction_info.is_valid = bool(self.direction_info.is_valid)
      self.motion_info.is_valid = bool(self.motion_info.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.feature = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.ModelOutputFeature()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.feature.append(val1)
      _x = self
      start = end
      end += 44
      (_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence, _x.derived_type, _x.attribute.is_landmark_valid,) = _get_struct_B5fB5f2B().unpack(str[start:end])
      self.camera_bbox_info.raw_detection_box.initialized = bool(self.camera_bbox_info.raw_detection_box.initialized)
      self.camera_bbox_info.tracked_box.initialized = bool(self.camera_bbox_info.tracked_box.initialized)
      self.attribute.is_landmark_valid = bool(self.attribute.is_landmark_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attribute.landmark = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Point2f()
        _x = val1
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        self.attribute.landmark.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.attribute.landmark_scores = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 133
      (_x.attribute.is_direction_valid, _x.attribute.viewport_direction.x, _x.attribute.viewport_direction.y, _x.automobile_light_status.left_turn, _x.automobile_light_status.right_turn, _x.automobile_light_status.hazard, _x.automobile_light_status.brake, _x.is_right_edge_detected, _x.right_edge_line.x, _x.right_edge_line.y, _x.right_edge_line.z, _x.right_edge_line.w, _x.non_automobile_vehicle_light_status.left_turn, _x.non_automobile_vehicle_light_status.right_turn, _x.non_automobile_vehicle_light_status.brake, _x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing, _x.upper_body_direction.x, _x.upper_body_direction.y, _x.lower_body_direction.x, _x.lower_body_direction.y, _x.face_direction.x, _x.face_direction.y, _x.intention.crossing, _x.intention.attention_to_ego_car, _x.is_on_bike, _x.depth_point.nearest_point_x, _x.depth_point.depth_point_x, _x.depth_point.depth_point_y, _x.depth_point.orientation, _x.depth_point.label, _x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate,) = _get_struct_B2f4hB4i3hB5b6f2hB3fihQ4d().unpack(str[start:end])
      self.attribute.is_direction_valid = bool(self.attribute.is_direction_valid)
      self.is_right_edge_detected = bool(self.is_right_edge_detected)
      self.is_with_ped = bool(self.is_with_ped)
      self.is_on_bike = bool(self.is_on_bike)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.matched_sensor_object_info = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.MatchedSensorObjectInfo()
        _x = val1
        start = end
        end += 18
        (_x.sensor_id, _x.frame_timestamp_ns, _x.object_id,) = _get_struct_h2Q().unpack(str[start:end])
        self.matched_sensor_object_info.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_2fB16fBh3d49fhf2h = None
def _get_struct_2fB16fBh3d49fhf2h():
    global _struct_2fB16fBh3d49fhf2h
    if _struct_2fB16fBh3d49fhf2h is None:
        _struct_2fB16fBh3d49fhf2h = struct.Struct("<2fB16fBh3d49fhf2h")
    return _struct_2fB16fBh3d49fhf2h
_struct_2h2fh = None
def _get_struct_2h2fh():
    global _struct_2h2fh
    if _struct_2h2fh is None:
        _struct_2h2fh = struct.Struct("<2h2fh")
    return _struct_2h2fh
_struct_B2f4hB4i3hB5b6f2hB3fihQ4d = None
def _get_struct_B2f4hB4i3hB5b6f2hB3fihQ4d():
    global _struct_B2f4hB4i3hB5b6f2hB3fihQ4d
    if _struct_B2f4hB4i3hB5b6f2hB3fihQ4d is None:
        _struct_B2f4hB4i3hB5b6f2hB3fihQ4d = struct.Struct("<B2f4hB4i3hB5b6f2hB3fihQ4d")
    return _struct_B2f4hB4i3hB5b6f2hB3fihQ4d
_struct_B5fB5f2B = None
def _get_struct_B5fB5f2B():
    global _struct_B5fB5f2B
    if _struct_B5fB5f2B is None:
        _struct_B5fB5f2B = struct.Struct("<B5fB5f2B")
    return _struct_B5fB5f2B
_struct_h2Q = None
def _get_struct_h2Q():
    global _struct_h2Q
    if _struct_h2Q is None:
        _struct_h2Q = struct.Struct("<h2Q")
    return _struct_h2Q
_struct_if2QB12fB = None
def _get_struct_if2QB12fB():
    global _struct_if2QB12fB
    if _struct_if2QB12fB is None:
        _struct_if2QB12fB = struct.Struct("<if2QB12fB")
    return _struct_if2QB12fB
