# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_perception_msgs/ObjectFrame.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_perception_msgs.msg
import std_msgs.msg

class ObjectFrame(genpy.Message):
  _md5sum = "9f82da4ca3d31860081b6a80ede1d8c2"
  _type = "ad_perception_msgs/ObjectFrame"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp, and frame_id
std_msgs/Header header

uint64 frame_timestamp_ns

# enum SensorID
int16 sensor_id

Object[] perception_object_list

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_perception_msgs/Object
## BaseObject

# enum SensorID
int16 sensor_id
# enum ObjectLabel
int16 label
float32 type_confidence
float32 existence_confidence
# enum ObjectLabel
int16 sub_type

# ObjectLabel
int16 UNKNOWN=0
int16 PEDESTRIAN=1
int16 VEHICLE=2
int16 VEHICLE_CAR=3
int16 VEHICLE_SUV=4
int16 VEHICLE_VAN=5
int16 VEHICLE_TRUCK=6
int16 VEHICLE_PICKUP_TRUCK=7
int16 VEHICLE_BUS=8
int16 VEHICLE_TAXI=9
int16 VEHICLE_EMERGENCY=10
int16 VEHICLE_SCHOOL_BUS=11
int16 VEHICLE_OTHERS=12
int16 VEHICLE_END=13
int16 BIKE=14
int16 NO_PERSON_VEHICLE=15
int16 BIKE_BICYCLE=16
int16 BIKE_BIKEBIG=17
int16 BIKE_BIKESMALL=18
int16 BIKE_END=19
int16 TRAFFICLIGHT_ALL=20
int16 TRAFFICLIGHT_END=64
int16 TRAFFICSIGN_ALL=65
int16 TRAFFICSIGN_END=135
int16 OBSTACLE_ALL=136
int16 OBSTACLE_END=150
int16 ROADMARKER_ALL=151
int16 ROADMARKER_END=162

float32[] sub_type_probs
int32 track_id
float32 track_age_time_second
uint64 last_measure_update_timestamp_ns
uint64 current_prediction_timestamp_ns

SizeInfo size_info
PolygonBox polygon_box
DirectionInfo direction_info
MotionInfo motion_info
int16 motion_status
float32 motion_static_score

# enum MaintenanceStatus
int16 maintenance_status
# enum OcclusionStatus
int16 occlusion_status

# ModelOutputFeatures
ModelOutputFeature[] feature

# CameraBBox2DInfo
CameraBBox2DInfo camera_bbox_info

# Derived object type : used only between ros nodes to determine dynamic type of object
uint8 derived_type
# Derived types
uint8 CAMERA_NON_VEHICLE=1
uint8 CAMERA_PEDESTRIAN=2
uint8 CAMERA_VEHICLE=3
uint8 CAMERA_STATIC_OBSTACLE=4
uint8 LIDAR_OBJECT=5
uint8 RADAR_OBJECT=6
uint8 FUSION_OBJECT=7

## Shared: NonAutomobileVehicle Pedestrian Automobile
BaseCameraAttribute attribute

## Shared: Automobile FusionObject
AutomobileLightStatus automobile_light_status

## Static Obstacle Specific
bool is_right_edge_detected
Vector4i right_edge_line

## NonAutomobileVehicle Specific
# enum NonAutomobileVehicleLightStatus
NonAutomobileVehicleLightStatus non_automobile_vehicle_light_status
bool is_with_ped

## Pedestrian Specific
# action enum AttrBool
int8 umbrella
int8 call
int8 phone
int8 wave
int8 standing
# direction
Point2f upper_body_direction
Point2f lower_body_direction
Point2f face_direction
# intention
PedestrianIntention intention
bool is_on_bike

## Automobile Specific
DepthDetPoint depth_point

## LidarObject Specific
uint64 point_cloud_timestamp_ns

## RadarObject Specific
float64 track_range
float64 track_range_rate
float64 track_range_accel_rate
float64 track_lat_rate

## FusionObject Specific
MatchedSensorObjectInfo[] matched_sensor_object_info
================================================================================
MSG: ad_perception_msgs/SizeInfo
bool is_valid

Vector3f size
Matrix3f size_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3f
float32 x
float32 y
float32 z
================================================================================
MSG: ad_perception_msgs/Matrix3f
Vector3f x
Vector3f y
Vector3f z

================================================================================
MSG: ad_perception_msgs/PolygonBox
bool is_valid
Point2f[] polygon_contour
float32 height_lower_surface
float32 height_upper_surface
================================================================================
MSG: ad_perception_msgs/Point2f
float32 x
float32 y
================================================================================
MSG: ad_perception_msgs/DirectionInfo
bool is_valid

Vector3f direction_ypr
Matrix3f direction_ypr_uncertainty
float32 yaw
float32 yaw_uncertainty
float32 yaw_rate
float32 yaw_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/MotionInfo
bool is_valid

# enum MotionStatus
int16 motion_status

Vector3d center
Matrix3f center_uncertainty
Vector3f velocity
Matrix3f velocity_uncertainty
Vector3f acceleration
Matrix3f acceleration_uncertainty
Vector3f jerk
Matrix3f jerk_uncertainty
float32 velocity_heading
float32 velocity_heading_uncertainty
float32 velocity_heading_rate
float32 velocity_heading_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3d
float64 x
float64 y
float64 z

================================================================================
MSG: ad_perception_msgs/ModelOutputFeature
string key
float32[] value
================================================================================
MSG: ad_perception_msgs/CameraBBox2DInfo
Bbox2D raw_detection_box
Bbox2D tracked_box
================================================================================
MSG: ad_perception_msgs/Bbox2D
bool initialized
float32 top_left_x
float32 top_left_y
float32 bottom_right_x
float32 bottom_right_y
float32 confidence
================================================================================
MSG: ad_perception_msgs/BaseCameraAttribute
bool is_landmark_valid
Point2f[] landmark
float32[] landmark_scores

bool is_direction_valid
Point2f viewport_direction

================================================================================
MSG: ad_perception_msgs/AutomobileLightStatus
int16 left_turn
int16 right_turn
int16 hazard
int16 brake
================================================================================
MSG: ad_perception_msgs/Vector4i
int32 x
int32 y
int32 z
int32 w

================================================================================
MSG: ad_perception_msgs/NonAutomobileVehicleLightStatus
int16 left_turn
int16 right_turn
int16 brake
================================================================================
MSG: ad_perception_msgs/PedestrianIntention
# enum Intention
int16 crossing
# enum AttentionBool
int16 attention_to_ego_car
================================================================================
MSG: ad_perception_msgs/DepthDetPoint
float32 nearest_point_x
float32 depth_point_x
float32 depth_point_y
int32 orientation
# enum DepthFineOriLabel
int16 label
================================================================================
MSG: ad_perception_msgs/MatchedSensorObjectInfo
# enum SensorID
int16 sensor_id

uint64 frame_timestamp_ns
uint64 object_id"""
  __slots__ = ['header','frame_timestamp_ns','sensor_id','perception_object_list']
  _slot_types = ['std_msgs/Header','uint64','int16','ad_perception_msgs/Object[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,frame_timestamp_ns,sensor_id,perception_object_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ObjectFrame, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.frame_timestamp_ns is None:
        self.frame_timestamp_ns = 0
      if self.sensor_id is None:
        self.sensor_id = 0
      if self.perception_object_list is None:
        self.perception_object_list = []
    else:
      self.header = std_msgs.msg.Header()
      self.frame_timestamp_ns = 0
      self.sensor_id = 0
      self.perception_object_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Qh().pack(_x.frame_timestamp_ns, _x.sensor_id))
      length = len(self.perception_object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.perception_object_list:
        _x = val1
        buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
        length = len(val1.sub_type_probs)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.sub_type_probs))
        _x = val1
        buff.write(_get_struct_if2Q().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns))
        _v1 = val1.size_info
        _x = _v1.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v2 = _v1.size
        _x = _v2
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v3 = _v1.size_uncertainty
        _v4 = _v3.x
        _x = _v4
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v5 = _v3.y
        _x = _v5
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v6 = _v3.z
        _x = _v6
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v7 = val1.polygon_box
        _x = _v7.is_valid
        buff.write(_get_struct_B().pack(_x))
        length = len(_v7.polygon_contour)
        buff.write(_struct_I.pack(length))
        for val3 in _v7.polygon_contour:
          _x = val3
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = _v7
        buff.write(_get_struct_2f().pack(_x.height_lower_surface, _x.height_upper_surface))
        _v8 = val1.direction_info
        _x = _v8.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v9 = _v8.direction_ypr
        _x = _v9
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v10 = _v8.direction_ypr_uncertainty
        _v11 = _v10.x
        _x = _v11
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v12 = _v10.y
        _x = _v12
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v13 = _v10.z
        _x = _v13
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v8
        buff.write(_get_struct_4f().pack(_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty))
        _v14 = val1.motion_info
        _x = _v14
        buff.write(_get_struct_Bh().pack(_x.is_valid, _x.motion_status))
        _v15 = _v14.center
        _x = _v15
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v16 = _v14.center_uncertainty
        _v17 = _v16.x
        _x = _v17
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v18 = _v16.y
        _x = _v18
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v19 = _v16.z
        _x = _v19
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v20 = _v14.velocity
        _x = _v20
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v21 = _v14.velocity_uncertainty
        _v22 = _v21.x
        _x = _v22
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v23 = _v21.y
        _x = _v23
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v24 = _v21.z
        _x = _v24
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v25 = _v14.acceleration
        _x = _v25
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v26 = _v14.acceleration_uncertainty
        _v27 = _v26.x
        _x = _v27
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v28 = _v26.y
        _x = _v28
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v29 = _v26.z
        _x = _v29
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v30 = _v14.jerk
        _x = _v30
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v31 = _v14.jerk_uncertainty
        _v32 = _v31.x
        _x = _v32
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v33 = _v31.y
        _x = _v33
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v34 = _v31.z
        _x = _v34
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v14
        buff.write(_get_struct_4f().pack(_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty))
        _x = val1
        buff.write(_get_struct_hf2h().pack(_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
        length = len(val1.feature)
        buff.write(_struct_I.pack(length))
        for val2 in val1.feature:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(val2.value)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.Struct(pattern).pack(*val2.value))
        _v35 = val1.camera_bbox_info
        _v36 = _v35.raw_detection_box
        _x = _v36
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
        _v37 = _v35.tracked_box
        _x = _v37
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
        _x = val1.derived_type
        buff.write(_get_struct_B().pack(_x))
        _v38 = val1.attribute
        _x = _v38.is_landmark_valid
        buff.write(_get_struct_B().pack(_x))
        length = len(_v38.landmark)
        buff.write(_struct_I.pack(length))
        for val3 in _v38.landmark:
          _x = val3
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(_v38.landmark_scores)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*_v38.landmark_scores))
        _x = _v38.is_direction_valid
        buff.write(_get_struct_B().pack(_x))
        _v39 = _v38.viewport_direction
        _x = _v39
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v40 = val1.automobile_light_status
        _x = _v40
        buff.write(_get_struct_4h().pack(_x.left_turn, _x.right_turn, _x.hazard, _x.brake))
        _x = val1.is_right_edge_detected
        buff.write(_get_struct_B().pack(_x))
        _v41 = val1.right_edge_line
        _x = _v41
        buff.write(_get_struct_4i().pack(_x.x, _x.y, _x.z, _x.w))
        _v42 = val1.non_automobile_vehicle_light_status
        _x = _v42
        buff.write(_get_struct_3h().pack(_x.left_turn, _x.right_turn, _x.brake))
        _x = val1
        buff.write(_get_struct_B5b().pack(_x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing))
        _v43 = val1.upper_body_direction
        _x = _v43
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v44 = val1.lower_body_direction
        _x = _v44
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v45 = val1.face_direction
        _x = _v45
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v46 = val1.intention
        _x = _v46
        buff.write(_get_struct_2h().pack(_x.crossing, _x.attention_to_ego_car))
        _x = val1.is_on_bike
        buff.write(_get_struct_B().pack(_x))
        _v47 = val1.depth_point
        _x = _v47
        buff.write(_get_struct_3fih().pack(_x.nearest_point_x, _x.depth_point_x, _x.depth_point_y, _x.orientation, _x.label))
        _x = val1
        buff.write(_get_struct_Q4d().pack(_x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate))
        length = len(val1.matched_sensor_object_info)
        buff.write(_struct_I.pack(length))
        for val2 in val1.matched_sensor_object_info:
          _x = val2
          buff.write(_get_struct_h2Q().pack(_x.sensor_id, _x.frame_timestamp_ns, _x.object_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.perception_object_list is None:
        self.perception_object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.frame_timestamp_ns, _x.sensor_id,) = _get_struct_Qh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.perception_object_list = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Object()
        _x = val1
        start = end
        end += 14
        (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.sub_type_probs = s.unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns,) = _get_struct_if2Q().unpack(str[start:end])
        _v48 = val1.size_info
        start = end
        end += 1
        (_v48.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v48.is_valid = bool(_v48.is_valid)
        _v49 = _v48.size
        _x = _v49
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v50 = _v48.size_uncertainty
        _v51 = _v50.x
        _x = _v51
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v52 = _v50.y
        _x = _v52
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v53 = _v50.z
        _x = _v53
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v54 = val1.polygon_box
        start = end
        end += 1
        (_v54.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v54.is_valid = bool(_v54.is_valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v54.polygon_contour = []
        for i in range(0, length):
          val3 = ad_perception_msgs.msg.Point2f()
          _x = val3
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          _v54.polygon_contour.append(val3)
        _x = _v54
        start = end
        end += 8
        (_x.height_lower_surface, _x.height_upper_surface,) = _get_struct_2f().unpack(str[start:end])
        _v55 = val1.direction_info
        start = end
        end += 1
        (_v55.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v55.is_valid = bool(_v55.is_valid)
        _v56 = _v55.direction_ypr
        _x = _v56
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v57 = _v55.direction_ypr_uncertainty
        _v58 = _v57.x
        _x = _v58
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v59 = _v57.y
        _x = _v59
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v60 = _v57.z
        _x = _v60
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v55
        start = end
        end += 16
        (_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _v61 = val1.motion_info
        _x = _v61
        start = end
        end += 3
        (_x.is_valid, _x.motion_status,) = _get_struct_Bh().unpack(str[start:end])
        _v61.is_valid = bool(_v61.is_valid)
        _v62 = _v61.center
        _x = _v62
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v63 = _v61.center_uncertainty
        _v64 = _v63.x
        _x = _v64
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v65 = _v63.y
        _x = _v65
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v66 = _v63.z
        _x = _v66
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v67 = _v61.velocity
        _x = _v67
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v68 = _v61.velocity_uncertainty
        _v69 = _v68.x
        _x = _v69
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v70 = _v68.y
        _x = _v70
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v71 = _v68.z
        _x = _v71
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v72 = _v61.acceleration
        _x = _v72
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v73 = _v61.acceleration_uncertainty
        _v74 = _v73.x
        _x = _v74
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v75 = _v73.y
        _x = _v75
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v76 = _v73.z
        _x = _v76
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v77 = _v61.jerk
        _x = _v77
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v78 = _v61.jerk_uncertainty
        _v79 = _v78.x
        _x = _v79
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v80 = _v78.y
        _x = _v80
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v81 = _v78.z
        _x = _v81
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v61
        start = end
        end += 16
        (_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_hf2h().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.feature = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.ModelOutputFeature()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.value = s.unpack(str[start:end])
          val1.feature.append(val2)
        _v82 = val1.camera_bbox_info
        _v83 = _v82.raw_detection_box
        _x = _v83
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v83.initialized = bool(_v83.initialized)
        _v84 = _v82.tracked_box
        _x = _v84
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v84.initialized = bool(_v84.initialized)
        start = end
        end += 1
        (val1.derived_type,) = _get_struct_B().unpack(str[start:end])
        _v85 = val1.attribute
        start = end
        end += 1
        (_v85.is_landmark_valid,) = _get_struct_B().unpack(str[start:end])
        _v85.is_landmark_valid = bool(_v85.is_landmark_valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v85.landmark = []
        for i in range(0, length):
          val3 = ad_perception_msgs.msg.Point2f()
          _x = val3
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          _v85.landmark.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v85.landmark_scores = s.unpack(str[start:end])
        start = end
        end += 1
        (_v85.is_direction_valid,) = _get_struct_B().unpack(str[start:end])
        _v85.is_direction_valid = bool(_v85.is_direction_valid)
        _v86 = _v85.viewport_direction
        _x = _v86
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v87 = val1.automobile_light_status
        _x = _v87
        start = end
        end += 8
        (_x.left_turn, _x.right_turn, _x.hazard, _x.brake,) = _get_struct_4h().unpack(str[start:end])
        start = end
        end += 1
        (val1.is_right_edge_detected,) = _get_struct_B().unpack(str[start:end])
        val1.is_right_edge_detected = bool(val1.is_right_edge_detected)
        _v88 = val1.right_edge_line
        _x = _v88
        start = end
        end += 16
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4i().unpack(str[start:end])
        _v89 = val1.non_automobile_vehicle_light_status
        _x = _v89
        start = end
        end += 6
        (_x.left_turn, _x.right_turn, _x.brake,) = _get_struct_3h().unpack(str[start:end])
        _x = val1
        start = end
        end += 6
        (_x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing,) = _get_struct_B5b().unpack(str[start:end])
        val1.is_with_ped = bool(val1.is_with_ped)
        _v90 = val1.upper_body_direction
        _x = _v90
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v91 = val1.lower_body_direction
        _x = _v91
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v92 = val1.face_direction
        _x = _v92
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v93 = val1.intention
        _x = _v93
        start = end
        end += 4
        (_x.crossing, _x.attention_to_ego_car,) = _get_struct_2h().unpack(str[start:end])
        start = end
        end += 1
        (val1.is_on_bike,) = _get_struct_B().unpack(str[start:end])
        val1.is_on_bike = bool(val1.is_on_bike)
        _v94 = val1.depth_point
        _x = _v94
        start = end
        end += 18
        (_x.nearest_point_x, _x.depth_point_x, _x.depth_point_y, _x.orientation, _x.label,) = _get_struct_3fih().unpack(str[start:end])
        _x = val1
        start = end
        end += 40
        (_x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate,) = _get_struct_Q4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.matched_sensor_object_info = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.MatchedSensorObjectInfo()
          _x = val2
          start = end
          end += 18
          (_x.sensor_id, _x.frame_timestamp_ns, _x.object_id,) = _get_struct_h2Q().unpack(str[start:end])
          val1.matched_sensor_object_info.append(val2)
        self.perception_object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Qh().pack(_x.frame_timestamp_ns, _x.sensor_id))
      length = len(self.perception_object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.perception_object_list:
        _x = val1
        buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
        length = len(val1.sub_type_probs)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.sub_type_probs.tostring())
        _x = val1
        buff.write(_get_struct_if2Q().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns))
        _v95 = val1.size_info
        _x = _v95.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v96 = _v95.size
        _x = _v96
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v97 = _v95.size_uncertainty
        _v98 = _v97.x
        _x = _v98
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v99 = _v97.y
        _x = _v99
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v100 = _v97.z
        _x = _v100
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v101 = val1.polygon_box
        _x = _v101.is_valid
        buff.write(_get_struct_B().pack(_x))
        length = len(_v101.polygon_contour)
        buff.write(_struct_I.pack(length))
        for val3 in _v101.polygon_contour:
          _x = val3
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = _v101
        buff.write(_get_struct_2f().pack(_x.height_lower_surface, _x.height_upper_surface))
        _v102 = val1.direction_info
        _x = _v102.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v103 = _v102.direction_ypr
        _x = _v103
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v104 = _v102.direction_ypr_uncertainty
        _v105 = _v104.x
        _x = _v105
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v106 = _v104.y
        _x = _v106
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v107 = _v104.z
        _x = _v107
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v102
        buff.write(_get_struct_4f().pack(_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty))
        _v108 = val1.motion_info
        _x = _v108
        buff.write(_get_struct_Bh().pack(_x.is_valid, _x.motion_status))
        _v109 = _v108.center
        _x = _v109
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v110 = _v108.center_uncertainty
        _v111 = _v110.x
        _x = _v111
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v112 = _v110.y
        _x = _v112
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v113 = _v110.z
        _x = _v113
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v114 = _v108.velocity
        _x = _v114
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v115 = _v108.velocity_uncertainty
        _v116 = _v115.x
        _x = _v116
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v117 = _v115.y
        _x = _v117
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v118 = _v115.z
        _x = _v118
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v119 = _v108.acceleration
        _x = _v119
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v120 = _v108.acceleration_uncertainty
        _v121 = _v120.x
        _x = _v121
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v122 = _v120.y
        _x = _v122
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v123 = _v120.z
        _x = _v123
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v124 = _v108.jerk
        _x = _v124
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v125 = _v108.jerk_uncertainty
        _v126 = _v125.x
        _x = _v126
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v127 = _v125.y
        _x = _v127
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v128 = _v125.z
        _x = _v128
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v108
        buff.write(_get_struct_4f().pack(_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty))
        _x = val1
        buff.write(_get_struct_hf2h().pack(_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
        length = len(val1.feature)
        buff.write(_struct_I.pack(length))
        for val2 in val1.feature:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(val2.value)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val2.value.tostring())
        _v129 = val1.camera_bbox_info
        _v130 = _v129.raw_detection_box
        _x = _v130
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
        _v131 = _v129.tracked_box
        _x = _v131
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
        _x = val1.derived_type
        buff.write(_get_struct_B().pack(_x))
        _v132 = val1.attribute
        _x = _v132.is_landmark_valid
        buff.write(_get_struct_B().pack(_x))
        length = len(_v132.landmark)
        buff.write(_struct_I.pack(length))
        for val3 in _v132.landmark:
          _x = val3
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(_v132.landmark_scores)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(_v132.landmark_scores.tostring())
        _x = _v132.is_direction_valid
        buff.write(_get_struct_B().pack(_x))
        _v133 = _v132.viewport_direction
        _x = _v133
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v134 = val1.automobile_light_status
        _x = _v134
        buff.write(_get_struct_4h().pack(_x.left_turn, _x.right_turn, _x.hazard, _x.brake))
        _x = val1.is_right_edge_detected
        buff.write(_get_struct_B().pack(_x))
        _v135 = val1.right_edge_line
        _x = _v135
        buff.write(_get_struct_4i().pack(_x.x, _x.y, _x.z, _x.w))
        _v136 = val1.non_automobile_vehicle_light_status
        _x = _v136
        buff.write(_get_struct_3h().pack(_x.left_turn, _x.right_turn, _x.brake))
        _x = val1
        buff.write(_get_struct_B5b().pack(_x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing))
        _v137 = val1.upper_body_direction
        _x = _v137
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v138 = val1.lower_body_direction
        _x = _v138
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v139 = val1.face_direction
        _x = _v139
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _v140 = val1.intention
        _x = _v140
        buff.write(_get_struct_2h().pack(_x.crossing, _x.attention_to_ego_car))
        _x = val1.is_on_bike
        buff.write(_get_struct_B().pack(_x))
        _v141 = val1.depth_point
        _x = _v141
        buff.write(_get_struct_3fih().pack(_x.nearest_point_x, _x.depth_point_x, _x.depth_point_y, _x.orientation, _x.label))
        _x = val1
        buff.write(_get_struct_Q4d().pack(_x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate))
        length = len(val1.matched_sensor_object_info)
        buff.write(_struct_I.pack(length))
        for val2 in val1.matched_sensor_object_info:
          _x = val2
          buff.write(_get_struct_h2Q().pack(_x.sensor_id, _x.frame_timestamp_ns, _x.object_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.perception_object_list is None:
        self.perception_object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.frame_timestamp_ns, _x.sensor_id,) = _get_struct_Qh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.perception_object_list = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Object()
        _x = val1
        start = end
        end += 14
        (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.sub_type_probs = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        _x = val1
        start = end
        end += 24
        (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns,) = _get_struct_if2Q().unpack(str[start:end])
        _v142 = val1.size_info
        start = end
        end += 1
        (_v142.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v142.is_valid = bool(_v142.is_valid)
        _v143 = _v142.size
        _x = _v143
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v144 = _v142.size_uncertainty
        _v145 = _v144.x
        _x = _v145
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v146 = _v144.y
        _x = _v146
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v147 = _v144.z
        _x = _v147
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v148 = val1.polygon_box
        start = end
        end += 1
        (_v148.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v148.is_valid = bool(_v148.is_valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v148.polygon_contour = []
        for i in range(0, length):
          val3 = ad_perception_msgs.msg.Point2f()
          _x = val3
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          _v148.polygon_contour.append(val3)
        _x = _v148
        start = end
        end += 8
        (_x.height_lower_surface, _x.height_upper_surface,) = _get_struct_2f().unpack(str[start:end])
        _v149 = val1.direction_info
        start = end
        end += 1
        (_v149.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v149.is_valid = bool(_v149.is_valid)
        _v150 = _v149.direction_ypr
        _x = _v150
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v151 = _v149.direction_ypr_uncertainty
        _v152 = _v151.x
        _x = _v152
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v153 = _v151.y
        _x = _v153
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v154 = _v151.z
        _x = _v154
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v149
        start = end
        end += 16
        (_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _v155 = val1.motion_info
        _x = _v155
        start = end
        end += 3
        (_x.is_valid, _x.motion_status,) = _get_struct_Bh().unpack(str[start:end])
        _v155.is_valid = bool(_v155.is_valid)
        _v156 = _v155.center
        _x = _v156
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v157 = _v155.center_uncertainty
        _v158 = _v157.x
        _x = _v158
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v159 = _v157.y
        _x = _v159
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v160 = _v157.z
        _x = _v160
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v161 = _v155.velocity
        _x = _v161
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v162 = _v155.velocity_uncertainty
        _v163 = _v162.x
        _x = _v163
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v164 = _v162.y
        _x = _v164
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v165 = _v162.z
        _x = _v165
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v166 = _v155.acceleration
        _x = _v166
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v167 = _v155.acceleration_uncertainty
        _v168 = _v167.x
        _x = _v168
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v169 = _v167.y
        _x = _v169
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v170 = _v167.z
        _x = _v170
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v171 = _v155.jerk
        _x = _v171
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v172 = _v155.jerk_uncertainty
        _v173 = _v172.x
        _x = _v173
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v174 = _v172.y
        _x = _v174
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v175 = _v172.z
        _x = _v175
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v155
        start = end
        end += 16
        (_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_hf2h().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.feature = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.ModelOutputFeature()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          val1.feature.append(val2)
        _v176 = val1.camera_bbox_info
        _v177 = _v176.raw_detection_box
        _x = _v177
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v177.initialized = bool(_v177.initialized)
        _v178 = _v176.tracked_box
        _x = _v178
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v178.initialized = bool(_v178.initialized)
        start = end
        end += 1
        (val1.derived_type,) = _get_struct_B().unpack(str[start:end])
        _v179 = val1.attribute
        start = end
        end += 1
        (_v179.is_landmark_valid,) = _get_struct_B().unpack(str[start:end])
        _v179.is_landmark_valid = bool(_v179.is_landmark_valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v179.landmark = []
        for i in range(0, length):
          val3 = ad_perception_msgs.msg.Point2f()
          _x = val3
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          _v179.landmark.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v179.landmark_scores = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 1
        (_v179.is_direction_valid,) = _get_struct_B().unpack(str[start:end])
        _v179.is_direction_valid = bool(_v179.is_direction_valid)
        _v180 = _v179.viewport_direction
        _x = _v180
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v181 = val1.automobile_light_status
        _x = _v181
        start = end
        end += 8
        (_x.left_turn, _x.right_turn, _x.hazard, _x.brake,) = _get_struct_4h().unpack(str[start:end])
        start = end
        end += 1
        (val1.is_right_edge_detected,) = _get_struct_B().unpack(str[start:end])
        val1.is_right_edge_detected = bool(val1.is_right_edge_detected)
        _v182 = val1.right_edge_line
        _x = _v182
        start = end
        end += 16
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4i().unpack(str[start:end])
        _v183 = val1.non_automobile_vehicle_light_status
        _x = _v183
        start = end
        end += 6
        (_x.left_turn, _x.right_turn, _x.brake,) = _get_struct_3h().unpack(str[start:end])
        _x = val1
        start = end
        end += 6
        (_x.is_with_ped, _x.umbrella, _x.call, _x.phone, _x.wave, _x.standing,) = _get_struct_B5b().unpack(str[start:end])
        val1.is_with_ped = bool(val1.is_with_ped)
        _v184 = val1.upper_body_direction
        _x = _v184
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v185 = val1.lower_body_direction
        _x = _v185
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v186 = val1.face_direction
        _x = _v186
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        _v187 = val1.intention
        _x = _v187
        start = end
        end += 4
        (_x.crossing, _x.attention_to_ego_car,) = _get_struct_2h().unpack(str[start:end])
        start = end
        end += 1
        (val1.is_on_bike,) = _get_struct_B().unpack(str[start:end])
        val1.is_on_bike = bool(val1.is_on_bike)
        _v188 = val1.depth_point
        _x = _v188
        start = end
        end += 18
        (_x.nearest_point_x, _x.depth_point_x, _x.depth_point_y, _x.orientation, _x.label,) = _get_struct_3fih().unpack(str[start:end])
        _x = val1
        start = end
        end += 40
        (_x.point_cloud_timestamp_ns, _x.track_range, _x.track_range_rate, _x.track_range_accel_rate, _x.track_lat_rate,) = _get_struct_Q4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.matched_sensor_object_info = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.MatchedSensorObjectInfo()
          _x = val2
          start = end
          end += 18
          (_x.sensor_id, _x.frame_timestamp_ns, _x.object_id,) = _get_struct_h2Q().unpack(str[start:end])
          val1.matched_sensor_object_info.append(val2)
        self.perception_object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_2h = None
def _get_struct_2h():
    global _struct_2h
    if _struct_2h is None:
        _struct_2h = struct.Struct("<2h")
    return _struct_2h
_struct_2h2fh = None
def _get_struct_2h2fh():
    global _struct_2h2fh
    if _struct_2h2fh is None:
        _struct_2h2fh = struct.Struct("<2h2fh")
    return _struct_2h2fh
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_3fih = None
def _get_struct_3fih():
    global _struct_3fih
    if _struct_3fih is None:
        _struct_3fih = struct.Struct("<3fih")
    return _struct_3fih
_struct_3h = None
def _get_struct_3h():
    global _struct_3h
    if _struct_3h is None:
        _struct_3h = struct.Struct("<3h")
    return _struct_3h
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_4h = None
def _get_struct_4h():
    global _struct_4h
    if _struct_4h is None:
        _struct_4h = struct.Struct("<4h")
    return _struct_4h
_struct_4i = None
def _get_struct_4i():
    global _struct_4i
    if _struct_4i is None:
        _struct_4i = struct.Struct("<4i")
    return _struct_4i
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_B5b = None
def _get_struct_B5b():
    global _struct_B5b
    if _struct_B5b is None:
        _struct_B5b = struct.Struct("<B5b")
    return _struct_B5b
_struct_B5f = None
def _get_struct_B5f():
    global _struct_B5f
    if _struct_B5f is None:
        _struct_B5f = struct.Struct("<B5f")
    return _struct_B5f
_struct_Bh = None
def _get_struct_Bh():
    global _struct_Bh
    if _struct_Bh is None:
        _struct_Bh = struct.Struct("<Bh")
    return _struct_Bh
_struct_Q4d = None
def _get_struct_Q4d():
    global _struct_Q4d
    if _struct_Q4d is None:
        _struct_Q4d = struct.Struct("<Q4d")
    return _struct_Q4d
_struct_Qh = None
def _get_struct_Qh():
    global _struct_Qh
    if _struct_Qh is None:
        _struct_Qh = struct.Struct("<Qh")
    return _struct_Qh
_struct_h2Q = None
def _get_struct_h2Q():
    global _struct_h2Q
    if _struct_h2Q is None:
        _struct_h2Q = struct.Struct("<h2Q")
    return _struct_h2Q
_struct_hf2h = None
def _get_struct_hf2h():
    global _struct_hf2h
    if _struct_hf2h is None:
        _struct_hf2h = struct.Struct("<hf2h")
    return _struct_hf2h
_struct_if2Q = None
def _get_struct_if2Q():
    global _struct_if2Q
    if _struct_if2Q is None:
        _struct_if2Q = struct.Struct("<if2Q")
    return _struct_if2Q
