# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_perception_msgs/RoadFrame.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_perception_msgs.msg
import std_msgs.msg

class RoadFrame(genpy.Message):
  _md5sum = "31fdfda2d9470693f9de40d3cb68f67f"
  _type = "ad_perception_msgs/RoadFrame"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp, and frame_id
std_msgs/Header header

int64 frame_timestamp_ns

# enum SensorID
int16 sensor_id

RoadStruct road_struct

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_perception_msgs/RoadStruct
LaneLine[] laneline_results
StopLine[] stopline_results
Boundary[] boundary_results
Freespace[] freespace_results

================================================================================
MSG: ad_perception_msgs/LaneLine
Point2f[] image_points
Point2f[] world_points
Point2f[] world_points_reproj
float32 lane_confidence
float32 color_confidence
float32 line_confidence
float32 edge_confidence
bool fitting_on_img_plane
# enum LaneType
int16 id
int32 track_id
int32 track_age
float32 distance_to_left_bumper
float32 distance_to_right_bumper
# enum LaneCategory
int16 lane_category
# enum ColorType
int16 color_id
# enum LineType
int16 line_id
# enum EdgeType
int16 edge_id

================================================================================
MSG: ad_perception_msgs/Point2f
float32 x
float32 y
================================================================================
MSG: ad_perception_msgs/StopLine
Point2f[] image_points
Point2f[] world_points
float32[] confidence
int32 id
================================================================================
MSG: ad_perception_msgs/Boundary
Point2f[] image_points
Point2f[] world_points

float32 direction_x
float32 direction_y

float32 confidence

bool is_line
int32 id
================================================================================
MSG: ad_perception_msgs/Freespace
int32 id

Point2f[] image_points
Point2f[] world_points

uint16 width
uint16 height

bool[] bit_map

float32[] confidence"""
  __slots__ = ['header','frame_timestamp_ns','sensor_id','road_struct']
  _slot_types = ['std_msgs/Header','int64','int16','ad_perception_msgs/RoadStruct']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,frame_timestamp_ns,sensor_id,road_struct

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RoadFrame, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.frame_timestamp_ns is None:
        self.frame_timestamp_ns = 0
      if self.sensor_id is None:
        self.sensor_id = 0
      if self.road_struct is None:
        self.road_struct = ad_perception_msgs.msg.RoadStruct()
    else:
      self.header = std_msgs.msg.Header()
      self.frame_timestamp_ns = 0
      self.sensor_id = 0
      self.road_struct = ad_perception_msgs.msg.RoadStruct()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_qh().pack(_x.frame_timestamp_ns, _x.sensor_id))
      length = len(self.road_struct.laneline_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.laneline_results:
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points_reproj)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points_reproj:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_4fBh2i2f4h().pack(_x.lane_confidence, _x.color_confidence, _x.line_confidence, _x.edge_confidence, _x.fitting_on_img_plane, _x.id, _x.track_id, _x.track_age, _x.distance_to_left_bumper, _x.distance_to_right_bumper, _x.lane_category, _x.color_id, _x.line_id, _x.edge_id))
      length = len(self.road_struct.stopline_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.stopline_results:
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.confidence)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.confidence))
        _x = val1.id
        buff.write(_get_struct_i().pack(_x))
      length = len(self.road_struct.boundary_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.boundary_results:
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_3fBi().pack(_x.direction_x, _x.direction_y, _x.confidence, _x.is_line, _x.id))
      length = len(self.road_struct.freespace_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.freespace_results:
        _x = val1.id
        buff.write(_get_struct_i().pack(_x))
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2H().pack(_x.width, _x.height))
        length = len(val1.bit_map)
        buff.write(_struct_I.pack(length))
        pattern = '<%sB'%length
        buff.write(struct.Struct(pattern).pack(*val1.bit_map))
        length = len(val1.confidence)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.confidence))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.road_struct is None:
        self.road_struct = ad_perception_msgs.msg.RoadStruct()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.frame_timestamp_ns, _x.sensor_id,) = _get_struct_qh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.laneline_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.LaneLine()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points_reproj = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points_reproj.append(val2)
        _x = val1
        start = end
        end += 43
        (_x.lane_confidence, _x.color_confidence, _x.line_confidence, _x.edge_confidence, _x.fitting_on_img_plane, _x.id, _x.track_id, _x.track_age, _x.distance_to_left_bumper, _x.distance_to_right_bumper, _x.lane_category, _x.color_id, _x.line_id, _x.edge_id,) = _get_struct_4fBh2i2f4h().unpack(str[start:end])
        val1.fitting_on_img_plane = bool(val1.fitting_on_img_plane)
        self.road_struct.laneline_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.stopline_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.StopLine()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.confidence = s.unpack(str[start:end])
        start = end
        end += 4
        (val1.id,) = _get_struct_i().unpack(str[start:end])
        self.road_struct.stopline_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.boundary_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Boundary()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        _x = val1
        start = end
        end += 17
        (_x.direction_x, _x.direction_y, _x.confidence, _x.is_line, _x.id,) = _get_struct_3fBi().unpack(str[start:end])
        val1.is_line = bool(val1.is_line)
        self.road_struct.boundary_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.freespace_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Freespace()
        start = end
        end += 4
        (val1.id,) = _get_struct_i().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        _x = val1
        start = end
        end += 4
        (_x.width, _x.height,) = _get_struct_2H().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sB'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.bit_map = s.unpack(str[start:end])
        val1.bit_map = list(map(bool, val1.bit_map))
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.confidence = s.unpack(str[start:end])
        self.road_struct.freespace_results.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_qh().pack(_x.frame_timestamp_ns, _x.sensor_id))
      length = len(self.road_struct.laneline_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.laneline_results:
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points_reproj)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points_reproj:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_4fBh2i2f4h().pack(_x.lane_confidence, _x.color_confidence, _x.line_confidence, _x.edge_confidence, _x.fitting_on_img_plane, _x.id, _x.track_id, _x.track_age, _x.distance_to_left_bumper, _x.distance_to_right_bumper, _x.lane_category, _x.color_id, _x.line_id, _x.edge_id))
      length = len(self.road_struct.stopline_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.stopline_results:
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.confidence)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.confidence.tostring())
        _x = val1.id
        buff.write(_get_struct_i().pack(_x))
      length = len(self.road_struct.boundary_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.boundary_results:
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_3fBi().pack(_x.direction_x, _x.direction_y, _x.confidence, _x.is_line, _x.id))
      length = len(self.road_struct.freespace_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.road_struct.freespace_results:
        _x = val1.id
        buff.write(_get_struct_i().pack(_x))
        length = len(val1.image_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.image_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        length = len(val1.world_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.world_points:
          _x = val2
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = val1
        buff.write(_get_struct_2H().pack(_x.width, _x.height))
        length = len(val1.bit_map)
        buff.write(_struct_I.pack(length))
        pattern = '<%sB'%length
        buff.write(val1.bit_map.tostring())
        length = len(val1.confidence)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.confidence.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.road_struct is None:
        self.road_struct = ad_perception_msgs.msg.RoadStruct()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.frame_timestamp_ns, _x.sensor_id,) = _get_struct_qh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.laneline_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.LaneLine()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points_reproj = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points_reproj.append(val2)
        _x = val1
        start = end
        end += 43
        (_x.lane_confidence, _x.color_confidence, _x.line_confidence, _x.edge_confidence, _x.fitting_on_img_plane, _x.id, _x.track_id, _x.track_age, _x.distance_to_left_bumper, _x.distance_to_right_bumper, _x.lane_category, _x.color_id, _x.line_id, _x.edge_id,) = _get_struct_4fBh2i2f4h().unpack(str[start:end])
        val1.fitting_on_img_plane = bool(val1.fitting_on_img_plane)
        self.road_struct.laneline_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.stopline_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.StopLine()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.confidence = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (val1.id,) = _get_struct_i().unpack(str[start:end])
        self.road_struct.stopline_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.boundary_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Boundary()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        _x = val1
        start = end
        end += 17
        (_x.direction_x, _x.direction_y, _x.confidence, _x.is_line, _x.id,) = _get_struct_3fBi().unpack(str[start:end])
        val1.is_line = bool(val1.is_line)
        self.road_struct.boundary_results.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.road_struct.freespace_results = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Freespace()
        start = end
        end += 4
        (val1.id,) = _get_struct_i().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.image_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.image_points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.world_points = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.Point2f()
          _x = val2
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          val1.world_points.append(val2)
        _x = val1
        start = end
        end += 4
        (_x.width, _x.height,) = _get_struct_2H().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sB'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.bit_map = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
        val1.bit_map = list(map(bool, val1.bit_map))
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.confidence = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.road_struct.freespace_results.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2H = None
def _get_struct_2H():
    global _struct_2H
    if _struct_2H is None:
        _struct_2H = struct.Struct("<2H")
    return _struct_2H
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3fBi = None
def _get_struct_3fBi():
    global _struct_3fBi
    if _struct_3fBi is None:
        _struct_3fBi = struct.Struct("<3fBi")
    return _struct_3fBi
_struct_4fBh2i2f4h = None
def _get_struct_4fBh2i2f4h():
    global _struct_4fBh2i2f4h
    if _struct_4fBh2i2f4h is None:
        _struct_4fBh2i2f4h = struct.Struct("<4fBh2i2f4h")
    return _struct_4fBh2i2f4h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
_struct_qh = None
def _get_struct_qh():
    global _struct_qh
    if _struct_qh is None:
        _struct_qh = struct.Struct("<qh")
    return _struct_qh
