# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_perception_msgs/TrafficLightSignFrame.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_perception_msgs.msg
import std_msgs.msg

class TrafficLightSignFrame(genpy.Message):
  _md5sum = "733f986f43ced8c9d7a1a8cd9cc1a1e0"
  _type = "ad_perception_msgs/TrafficLightSignFrame"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp, and frame_id
std_msgs/Header header

int64 frame_timestamp_ns

# enum SensorID
int16 sensor_id

# traffic sign
TrafficSign[] traffic_sign

# traffic light
TrafficLightGroup[] traffic_light_group_list
string[] camera_name_list
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_perception_msgs/TrafficSign
## BaseObject

# enum SensorID
int16 sensor_id
# enum ObjectLabel
int16 label
float32 type_confidence
float32 existence_confidence
# enum ObjectLabel
int16 sub_type

float32[] sub_type_probs
int32 track_id
float32 track_age_time_second
uint64 last_measure_update_timestamp_ns
uint64 current_prediction_timestamp_ns

SizeInfo size_info
PolygonBox polygon_box
DirectionInfo direction_info
MotionInfo motion_info
int16 motion_status
float32 motion_static_score

# enum MaintenanceStatus
int16 maintenance_status
# enum OcclusionStatus
int16 occlusion_status

# ModelOutputFeatures
ModelOutputFeature[] feature

## TrafficSign Specific

# CameraBBox2DInfo
CameraBBox2DInfo camera_bbox_info

================================================================================
MSG: ad_perception_msgs/SizeInfo
bool is_valid

Vector3f size
Matrix3f size_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3f
float32 x
float32 y
float32 z
================================================================================
MSG: ad_perception_msgs/Matrix3f
Vector3f x
Vector3f y
Vector3f z

================================================================================
MSG: ad_perception_msgs/PolygonBox
bool is_valid
Point2f[] polygon_contour
float32 height_lower_surface
float32 height_upper_surface
================================================================================
MSG: ad_perception_msgs/Point2f
float32 x
float32 y
================================================================================
MSG: ad_perception_msgs/DirectionInfo
bool is_valid

Vector3f direction_ypr
Matrix3f direction_ypr_uncertainty
float32 yaw
float32 yaw_uncertainty
float32 yaw_rate
float32 yaw_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/MotionInfo
bool is_valid

# enum MotionStatus
int16 motion_status

Vector3d center
Matrix3f center_uncertainty
Vector3f velocity
Matrix3f velocity_uncertainty
Vector3f acceleration
Matrix3f acceleration_uncertainty
Vector3f jerk
Matrix3f jerk_uncertainty
float32 velocity_heading
float32 velocity_heading_uncertainty
float32 velocity_heading_rate
float32 velocity_heading_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3d
float64 x
float64 y
float64 z

================================================================================
MSG: ad_perception_msgs/ModelOutputFeature
string key
float32[] value
================================================================================
MSG: ad_perception_msgs/CameraBBox2DInfo
Bbox2D raw_detection_box
Bbox2D tracked_box
================================================================================
MSG: ad_perception_msgs/Bbox2D
bool initialized
float32 top_left_x
float32 top_left_y
float32 bottom_right_x
float32 bottom_right_y
float32 confidence
================================================================================
MSG: ad_perception_msgs/TrafficLightGroup
TrafficLight[] traffic_lights

string group_id

# TrafficSignal
TrafficSignal color_label

# TurnType
TurnType turn_type

float32 during_time
================================================================================
MSG: ad_perception_msgs/TrafficLight
uint64 timestamp_ns

Bbox2D detected_bbox
Bbox2D projected_bbox

string id
string group_id

# TrafficSignal
TrafficSignal color_label

# TurnType
TurnType turn_type

float32 during_time
================================================================================
MSG: ad_perception_msgs/TrafficSignal
# enum TrafficSignal
uint8 data

uint8 SIGNAL_NONE=0           #0x00
uint8 SIGNAL_GREEN=2          #0x02
uint8 SIGNAL_YELLOW=4         #0x04
uint8 SIGNAL_RED=8            #0x08
uint8 SIGNAL_GREEN_FLASH=16   #0x10
uint8 SIGNAL_YELLOW_FLASH=32  #0x20
uint8 SIGNAL_BLACK=48         #0x40
uint8 SIGNAL_GREEN_NUMBER=128 #0x80

================================================================================
MSG: ad_perception_msgs/TurnType
# enum TurnType
uint16 data

uint16 TURNTYPE_FREE=65535        #0xffff
uint16 TURNTYPE_TURN_LEFT=1       #0x0001
uint16 TURNTYPE_TURN_RIGHT=2      #0x0002
uint16 TURNTYPE_LEFT_AROUND=4     #0x0004
uint16 TURNTYPE_RIGHT_AROUND=8    #0x0008
uint16 TURNTYPE_STRAIGHT=16       #0x0010
"""
  __slots__ = ['header','frame_timestamp_ns','sensor_id','traffic_sign','traffic_light_group_list','camera_name_list']
  _slot_types = ['std_msgs/Header','int64','int16','ad_perception_msgs/TrafficSign[]','ad_perception_msgs/TrafficLightGroup[]','string[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,frame_timestamp_ns,sensor_id,traffic_sign,traffic_light_group_list,camera_name_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TrafficLightSignFrame, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.frame_timestamp_ns is None:
        self.frame_timestamp_ns = 0
      if self.sensor_id is None:
        self.sensor_id = 0
      if self.traffic_sign is None:
        self.traffic_sign = []
      if self.traffic_light_group_list is None:
        self.traffic_light_group_list = []
      if self.camera_name_list is None:
        self.camera_name_list = []
    else:
      self.header = std_msgs.msg.Header()
      self.frame_timestamp_ns = 0
      self.sensor_id = 0
      self.traffic_sign = []
      self.traffic_light_group_list = []
      self.camera_name_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_qh().pack(_x.frame_timestamp_ns, _x.sensor_id))
      length = len(self.traffic_sign)
      buff.write(_struct_I.pack(length))
      for val1 in self.traffic_sign:
        _x = val1
        buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
        length = len(val1.sub_type_probs)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.sub_type_probs))
        _x = val1
        buff.write(_get_struct_if2Q().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns))
        _v1 = val1.size_info
        _x = _v1.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v2 = _v1.size
        _x = _v2
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v3 = _v1.size_uncertainty
        _v4 = _v3.x
        _x = _v4
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v5 = _v3.y
        _x = _v5
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v6 = _v3.z
        _x = _v6
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v7 = val1.polygon_box
        _x = _v7.is_valid
        buff.write(_get_struct_B().pack(_x))
        length = len(_v7.polygon_contour)
        buff.write(_struct_I.pack(length))
        for val3 in _v7.polygon_contour:
          _x = val3
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = _v7
        buff.write(_get_struct_2f().pack(_x.height_lower_surface, _x.height_upper_surface))
        _v8 = val1.direction_info
        _x = _v8.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v9 = _v8.direction_ypr
        _x = _v9
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v10 = _v8.direction_ypr_uncertainty
        _v11 = _v10.x
        _x = _v11
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v12 = _v10.y
        _x = _v12
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v13 = _v10.z
        _x = _v13
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v8
        buff.write(_get_struct_4f().pack(_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty))
        _v14 = val1.motion_info
        _x = _v14
        buff.write(_get_struct_Bh().pack(_x.is_valid, _x.motion_status))
        _v15 = _v14.center
        _x = _v15
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v16 = _v14.center_uncertainty
        _v17 = _v16.x
        _x = _v17
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v18 = _v16.y
        _x = _v18
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v19 = _v16.z
        _x = _v19
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v20 = _v14.velocity
        _x = _v20
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v21 = _v14.velocity_uncertainty
        _v22 = _v21.x
        _x = _v22
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v23 = _v21.y
        _x = _v23
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v24 = _v21.z
        _x = _v24
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v25 = _v14.acceleration
        _x = _v25
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v26 = _v14.acceleration_uncertainty
        _v27 = _v26.x
        _x = _v27
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v28 = _v26.y
        _x = _v28
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v29 = _v26.z
        _x = _v29
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v30 = _v14.jerk
        _x = _v30
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v31 = _v14.jerk_uncertainty
        _v32 = _v31.x
        _x = _v32
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v33 = _v31.y
        _x = _v33
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v34 = _v31.z
        _x = _v34
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v14
        buff.write(_get_struct_4f().pack(_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty))
        _x = val1
        buff.write(_get_struct_hf2h().pack(_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
        length = len(val1.feature)
        buff.write(_struct_I.pack(length))
        for val2 in val1.feature:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(val2.value)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.Struct(pattern).pack(*val2.value))
        _v35 = val1.camera_bbox_info
        _v36 = _v35.raw_detection_box
        _x = _v36
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
        _v37 = _v35.tracked_box
        _x = _v37
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
      length = len(self.traffic_light_group_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.traffic_light_group_list:
        length = len(val1.traffic_lights)
        buff.write(_struct_I.pack(length))
        for val2 in val1.traffic_lights:
          _x = val2.timestamp_ns
          buff.write(_get_struct_Q().pack(_x))
          _v38 = val2.detected_bbox
          _x = _v38
          buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
          _v39 = val2.projected_bbox
          _x = _v39
          buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
          _x = val2.id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.group_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v40 = val2.color_label
          _x = _v40.data
          buff.write(_get_struct_B().pack(_x))
          _v41 = val2.turn_type
          _x = _v41.data
          buff.write(_get_struct_H().pack(_x))
          _x = val2.during_time
          buff.write(_get_struct_f().pack(_x))
        _x = val1.group_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v42 = val1.color_label
        _x = _v42.data
        buff.write(_get_struct_B().pack(_x))
        _v43 = val1.turn_type
        _x = _v43.data
        buff.write(_get_struct_H().pack(_x))
        _x = val1.during_time
        buff.write(_get_struct_f().pack(_x))
      length = len(self.camera_name_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.camera_name_list:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.traffic_sign is None:
        self.traffic_sign = None
      if self.traffic_light_group_list is None:
        self.traffic_light_group_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.frame_timestamp_ns, _x.sensor_id,) = _get_struct_qh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.traffic_sign = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.TrafficSign()
        _x = val1
        start = end
        end += 14
        (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.sub_type_probs = s.unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns,) = _get_struct_if2Q().unpack(str[start:end])
        _v44 = val1.size_info
        start = end
        end += 1
        (_v44.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v44.is_valid = bool(_v44.is_valid)
        _v45 = _v44.size
        _x = _v45
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v46 = _v44.size_uncertainty
        _v47 = _v46.x
        _x = _v47
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v48 = _v46.y
        _x = _v48
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v49 = _v46.z
        _x = _v49
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v50 = val1.polygon_box
        start = end
        end += 1
        (_v50.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v50.is_valid = bool(_v50.is_valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v50.polygon_contour = []
        for i in range(0, length):
          val3 = ad_perception_msgs.msg.Point2f()
          _x = val3
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          _v50.polygon_contour.append(val3)
        _x = _v50
        start = end
        end += 8
        (_x.height_lower_surface, _x.height_upper_surface,) = _get_struct_2f().unpack(str[start:end])
        _v51 = val1.direction_info
        start = end
        end += 1
        (_v51.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v51.is_valid = bool(_v51.is_valid)
        _v52 = _v51.direction_ypr
        _x = _v52
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v53 = _v51.direction_ypr_uncertainty
        _v54 = _v53.x
        _x = _v54
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v55 = _v53.y
        _x = _v55
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v56 = _v53.z
        _x = _v56
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v51
        start = end
        end += 16
        (_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _v57 = val1.motion_info
        _x = _v57
        start = end
        end += 3
        (_x.is_valid, _x.motion_status,) = _get_struct_Bh().unpack(str[start:end])
        _v57.is_valid = bool(_v57.is_valid)
        _v58 = _v57.center
        _x = _v58
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v59 = _v57.center_uncertainty
        _v60 = _v59.x
        _x = _v60
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v61 = _v59.y
        _x = _v61
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v62 = _v59.z
        _x = _v62
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v63 = _v57.velocity
        _x = _v63
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v64 = _v57.velocity_uncertainty
        _v65 = _v64.x
        _x = _v65
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v66 = _v64.y
        _x = _v66
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v67 = _v64.z
        _x = _v67
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v68 = _v57.acceleration
        _x = _v68
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v69 = _v57.acceleration_uncertainty
        _v70 = _v69.x
        _x = _v70
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v71 = _v69.y
        _x = _v71
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v72 = _v69.z
        _x = _v72
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v73 = _v57.jerk
        _x = _v73
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v74 = _v57.jerk_uncertainty
        _v75 = _v74.x
        _x = _v75
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v76 = _v74.y
        _x = _v76
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v77 = _v74.z
        _x = _v77
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v57
        start = end
        end += 16
        (_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_hf2h().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.feature = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.ModelOutputFeature()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.value = s.unpack(str[start:end])
          val1.feature.append(val2)
        _v78 = val1.camera_bbox_info
        _v79 = _v78.raw_detection_box
        _x = _v79
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v79.initialized = bool(_v79.initialized)
        _v80 = _v78.tracked_box
        _x = _v80
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v80.initialized = bool(_v80.initialized)
        self.traffic_sign.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.traffic_light_group_list = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.TrafficLightGroup()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.traffic_lights = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.TrafficLight()
          start = end
          end += 8
          (val2.timestamp_ns,) = _get_struct_Q().unpack(str[start:end])
          _v81 = val2.detected_bbox
          _x = _v81
          start = end
          end += 21
          (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
          _v81.initialized = bool(_v81.initialized)
          _v82 = val2.projected_bbox
          _x = _v82
          start = end
          end += 21
          (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
          _v82.initialized = bool(_v82.initialized)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.group_id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.group_id = str[start:end]
          _v83 = val2.color_label
          start = end
          end += 1
          (_v83.data,) = _get_struct_B().unpack(str[start:end])
          _v84 = val2.turn_type
          start = end
          end += 2
          (_v84.data,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 4
          (val2.during_time,) = _get_struct_f().unpack(str[start:end])
          val1.traffic_lights.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group_id = str[start:end]
        _v85 = val1.color_label
        start = end
        end += 1
        (_v85.data,) = _get_struct_B().unpack(str[start:end])
        _v86 = val1.turn_type
        start = end
        end += 2
        (_v86.data,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 4
        (val1.during_time,) = _get_struct_f().unpack(str[start:end])
        self.traffic_light_group_list.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.camera_name_list = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.camera_name_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_qh().pack(_x.frame_timestamp_ns, _x.sensor_id))
      length = len(self.traffic_sign)
      buff.write(_struct_I.pack(length))
      for val1 in self.traffic_sign:
        _x = val1
        buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
        length = len(val1.sub_type_probs)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.sub_type_probs.tostring())
        _x = val1
        buff.write(_get_struct_if2Q().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns))
        _v87 = val1.size_info
        _x = _v87.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v88 = _v87.size
        _x = _v88
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v89 = _v87.size_uncertainty
        _v90 = _v89.x
        _x = _v90
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v91 = _v89.y
        _x = _v91
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v92 = _v89.z
        _x = _v92
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v93 = val1.polygon_box
        _x = _v93.is_valid
        buff.write(_get_struct_B().pack(_x))
        length = len(_v93.polygon_contour)
        buff.write(_struct_I.pack(length))
        for val3 in _v93.polygon_contour:
          _x = val3
          buff.write(_get_struct_2f().pack(_x.x, _x.y))
        _x = _v93
        buff.write(_get_struct_2f().pack(_x.height_lower_surface, _x.height_upper_surface))
        _v94 = val1.direction_info
        _x = _v94.is_valid
        buff.write(_get_struct_B().pack(_x))
        _v95 = _v94.direction_ypr
        _x = _v95
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v96 = _v94.direction_ypr_uncertainty
        _v97 = _v96.x
        _x = _v97
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v98 = _v96.y
        _x = _v98
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v99 = _v96.z
        _x = _v99
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v94
        buff.write(_get_struct_4f().pack(_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty))
        _v100 = val1.motion_info
        _x = _v100
        buff.write(_get_struct_Bh().pack(_x.is_valid, _x.motion_status))
        _v101 = _v100.center
        _x = _v101
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v102 = _v100.center_uncertainty
        _v103 = _v102.x
        _x = _v103
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v104 = _v102.y
        _x = _v104
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v105 = _v102.z
        _x = _v105
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v106 = _v100.velocity
        _x = _v106
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v107 = _v100.velocity_uncertainty
        _v108 = _v107.x
        _x = _v108
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v109 = _v107.y
        _x = _v109
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v110 = _v107.z
        _x = _v110
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v111 = _v100.acceleration
        _x = _v111
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v112 = _v100.acceleration_uncertainty
        _v113 = _v112.x
        _x = _v113
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v114 = _v112.y
        _x = _v114
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v115 = _v112.z
        _x = _v115
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v116 = _v100.jerk
        _x = _v116
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v117 = _v100.jerk_uncertainty
        _v118 = _v117.x
        _x = _v118
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v119 = _v117.y
        _x = _v119
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _v120 = _v117.z
        _x = _v120
        buff.write(_get_struct_3f().pack(_x.x, _x.y, _x.z))
        _x = _v100
        buff.write(_get_struct_4f().pack(_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty))
        _x = val1
        buff.write(_get_struct_hf2h().pack(_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
        length = len(val1.feature)
        buff.write(_struct_I.pack(length))
        for val2 in val1.feature:
          _x = val2.key
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          length = len(val2.value)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val2.value.tostring())
        _v121 = val1.camera_bbox_info
        _v122 = _v121.raw_detection_box
        _x = _v122
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
        _v123 = _v121.tracked_box
        _x = _v123
        buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
      length = len(self.traffic_light_group_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.traffic_light_group_list:
        length = len(val1.traffic_lights)
        buff.write(_struct_I.pack(length))
        for val2 in val1.traffic_lights:
          _x = val2.timestamp_ns
          buff.write(_get_struct_Q().pack(_x))
          _v124 = val2.detected_bbox
          _x = _v124
          buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
          _v125 = val2.projected_bbox
          _x = _v125
          buff.write(_get_struct_B5f().pack(_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence))
          _x = val2.id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.group_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _v126 = val2.color_label
          _x = _v126.data
          buff.write(_get_struct_B().pack(_x))
          _v127 = val2.turn_type
          _x = _v127.data
          buff.write(_get_struct_H().pack(_x))
          _x = val2.during_time
          buff.write(_get_struct_f().pack(_x))
        _x = val1.group_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v128 = val1.color_label
        _x = _v128.data
        buff.write(_get_struct_B().pack(_x))
        _v129 = val1.turn_type
        _x = _v129.data
        buff.write(_get_struct_H().pack(_x))
        _x = val1.during_time
        buff.write(_get_struct_f().pack(_x))
      length = len(self.camera_name_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.camera_name_list:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.traffic_sign is None:
        self.traffic_sign = None
      if self.traffic_light_group_list is None:
        self.traffic_light_group_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.frame_timestamp_ns, _x.sensor_id,) = _get_struct_qh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.traffic_sign = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.TrafficSign()
        _x = val1
        start = end
        end += 14
        (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.sub_type_probs = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        _x = val1
        start = end
        end += 24
        (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns,) = _get_struct_if2Q().unpack(str[start:end])
        _v130 = val1.size_info
        start = end
        end += 1
        (_v130.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v130.is_valid = bool(_v130.is_valid)
        _v131 = _v130.size
        _x = _v131
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v132 = _v130.size_uncertainty
        _v133 = _v132.x
        _x = _v133
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v134 = _v132.y
        _x = _v134
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v135 = _v132.z
        _x = _v135
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v136 = val1.polygon_box
        start = end
        end += 1
        (_v136.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v136.is_valid = bool(_v136.is_valid)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v136.polygon_contour = []
        for i in range(0, length):
          val3 = ad_perception_msgs.msg.Point2f()
          _x = val3
          start = end
          end += 8
          (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
          _v136.polygon_contour.append(val3)
        _x = _v136
        start = end
        end += 8
        (_x.height_lower_surface, _x.height_upper_surface,) = _get_struct_2f().unpack(str[start:end])
        _v137 = val1.direction_info
        start = end
        end += 1
        (_v137.is_valid,) = _get_struct_B().unpack(str[start:end])
        _v137.is_valid = bool(_v137.is_valid)
        _v138 = _v137.direction_ypr
        _x = _v138
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v139 = _v137.direction_ypr_uncertainty
        _v140 = _v139.x
        _x = _v140
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v141 = _v139.y
        _x = _v141
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v142 = _v139.z
        _x = _v142
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v137
        start = end
        end += 16
        (_x.yaw, _x.yaw_uncertainty, _x.yaw_rate, _x.yaw_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _v143 = val1.motion_info
        _x = _v143
        start = end
        end += 3
        (_x.is_valid, _x.motion_status,) = _get_struct_Bh().unpack(str[start:end])
        _v143.is_valid = bool(_v143.is_valid)
        _v144 = _v143.center
        _x = _v144
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v145 = _v143.center_uncertainty
        _v146 = _v145.x
        _x = _v146
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v147 = _v145.y
        _x = _v147
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v148 = _v145.z
        _x = _v148
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v149 = _v143.velocity
        _x = _v149
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v150 = _v143.velocity_uncertainty
        _v151 = _v150.x
        _x = _v151
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v152 = _v150.y
        _x = _v152
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v153 = _v150.z
        _x = _v153
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v154 = _v143.acceleration
        _x = _v154
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v155 = _v143.acceleration_uncertainty
        _v156 = _v155.x
        _x = _v156
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v157 = _v155.y
        _x = _v157
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v158 = _v155.z
        _x = _v158
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v159 = _v143.jerk
        _x = _v159
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v160 = _v143.jerk_uncertainty
        _v161 = _v160.x
        _x = _v161
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v162 = _v160.y
        _x = _v162
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _v163 = _v160.z
        _x = _v163
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _get_struct_3f().unpack(str[start:end])
        _x = _v143
        start = end
        end += 16
        (_x.velocity_heading, _x.velocity_heading_uncertainty, _x.velocity_heading_rate, _x.velocity_heading_rate_uncertainty,) = _get_struct_4f().unpack(str[start:end])
        _x = val1
        start = end
        end += 10
        (_x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_hf2h().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.feature = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.ModelOutputFeature()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.key = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.key = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          val1.feature.append(val2)
        _v164 = val1.camera_bbox_info
        _v165 = _v164.raw_detection_box
        _x = _v165
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v165.initialized = bool(_v165.initialized)
        _v166 = _v164.tracked_box
        _x = _v166
        start = end
        end += 21
        (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
        _v166.initialized = bool(_v166.initialized)
        self.traffic_sign.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.traffic_light_group_list = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.TrafficLightGroup()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.traffic_lights = []
        for i in range(0, length):
          val2 = ad_perception_msgs.msg.TrafficLight()
          start = end
          end += 8
          (val2.timestamp_ns,) = _get_struct_Q().unpack(str[start:end])
          _v167 = val2.detected_bbox
          _x = _v167
          start = end
          end += 21
          (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
          _v167.initialized = bool(_v167.initialized)
          _v168 = val2.projected_bbox
          _x = _v168
          start = end
          end += 21
          (_x.initialized, _x.top_left_x, _x.top_left_y, _x.bottom_right_x, _x.bottom_right_y, _x.confidence,) = _get_struct_B5f().unpack(str[start:end])
          _v168.initialized = bool(_v168.initialized)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.group_id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.group_id = str[start:end]
          _v169 = val2.color_label
          start = end
          end += 1
          (_v169.data,) = _get_struct_B().unpack(str[start:end])
          _v170 = val2.turn_type
          start = end
          end += 2
          (_v170.data,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 4
          (val2.during_time,) = _get_struct_f().unpack(str[start:end])
          val1.traffic_lights.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group_id = str[start:end]
        _v171 = val1.color_label
        start = end
        end += 1
        (_v171.data,) = _get_struct_B().unpack(str[start:end])
        _v172 = val1.turn_type
        start = end
        end += 2
        (_v172.data,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 4
        (val1.during_time,) = _get_struct_f().unpack(str[start:end])
        self.traffic_light_group_list.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.camera_name_list = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.camera_name_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_2h2fh = None
def _get_struct_2h2fh():
    global _struct_2h2fh
    if _struct_2h2fh is None:
        _struct_2h2fh = struct.Struct("<2h2fh")
    return _struct_2h2fh
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
_struct_4f = None
def _get_struct_4f():
    global _struct_4f
    if _struct_4f is None:
        _struct_4f = struct.Struct("<4f")
    return _struct_4f
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_B5f = None
def _get_struct_B5f():
    global _struct_B5f
    if _struct_B5f is None:
        _struct_B5f = struct.Struct("<B5f")
    return _struct_B5f
_struct_Bh = None
def _get_struct_Bh():
    global _struct_Bh
    if _struct_Bh is None:
        _struct_Bh = struct.Struct("<Bh")
    return _struct_Bh
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
_struct_hf2h = None
def _get_struct_hf2h():
    global _struct_hf2h
    if _struct_hf2h is None:
        _struct_hf2h = struct.Struct("<hf2h")
    return _struct_hf2h
_struct_if2Q = None
def _get_struct_if2Q():
    global _struct_if2Q
    if _struct_if2Q is None:
        _struct_if2Q = struct.Struct("<if2Q")
    return _struct_if2Q
_struct_qh = None
def _get_struct_qh():
    global _struct_qh
    if _struct_qh is None:
        _struct_qh = struct.Struct("<qh")
    return _struct_qh
