# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_perception_msgs/TrafficSign.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_perception_msgs.msg

class TrafficSign(genpy.Message):
  _md5sum = "9ede531a13b296bb4051e2cea04c0681"
  _type = "ad_perception_msgs/TrafficSign"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """## BaseObject

# enum SensorID
int16 sensor_id
# enum ObjectLabel
int16 label
float32 type_confidence
float32 existence_confidence
# enum ObjectLabel
int16 sub_type

float32[] sub_type_probs
int32 track_id
float32 track_age_time_second
uint64 last_measure_update_timestamp_ns
uint64 current_prediction_timestamp_ns

SizeInfo size_info
PolygonBox polygon_box
DirectionInfo direction_info
MotionInfo motion_info
int16 motion_status
float32 motion_static_score

# enum MaintenanceStatus
int16 maintenance_status
# enum OcclusionStatus
int16 occlusion_status

# ModelOutputFeatures
ModelOutputFeature[] feature

## TrafficSign Specific

# CameraBBox2DInfo
CameraBBox2DInfo camera_bbox_info

================================================================================
MSG: ad_perception_msgs/SizeInfo
bool is_valid

Vector3f size
Matrix3f size_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3f
float32 x
float32 y
float32 z
================================================================================
MSG: ad_perception_msgs/Matrix3f
Vector3f x
Vector3f y
Vector3f z

================================================================================
MSG: ad_perception_msgs/PolygonBox
bool is_valid
Point2f[] polygon_contour
float32 height_lower_surface
float32 height_upper_surface
================================================================================
MSG: ad_perception_msgs/Point2f
float32 x
float32 y
================================================================================
MSG: ad_perception_msgs/DirectionInfo
bool is_valid

Vector3f direction_ypr
Matrix3f direction_ypr_uncertainty
float32 yaw
float32 yaw_uncertainty
float32 yaw_rate
float32 yaw_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/MotionInfo
bool is_valid

# enum MotionStatus
int16 motion_status

Vector3d center
Matrix3f center_uncertainty
Vector3f velocity
Matrix3f velocity_uncertainty
Vector3f acceleration
Matrix3f acceleration_uncertainty
Vector3f jerk
Matrix3f jerk_uncertainty
float32 velocity_heading
float32 velocity_heading_uncertainty
float32 velocity_heading_rate
float32 velocity_heading_rate_uncertainty

================================================================================
MSG: ad_perception_msgs/Vector3d
float64 x
float64 y
float64 z

================================================================================
MSG: ad_perception_msgs/ModelOutputFeature
string key
float32[] value
================================================================================
MSG: ad_perception_msgs/CameraBBox2DInfo
Bbox2D raw_detection_box
Bbox2D tracked_box
================================================================================
MSG: ad_perception_msgs/Bbox2D
bool initialized
float32 top_left_x
float32 top_left_y
float32 bottom_right_x
float32 bottom_right_y
float32 confidence"""
  __slots__ = ['sensor_id','label','type_confidence','existence_confidence','sub_type','sub_type_probs','track_id','track_age_time_second','last_measure_update_timestamp_ns','current_prediction_timestamp_ns','size_info','polygon_box','direction_info','motion_info','motion_status','motion_static_score','maintenance_status','occlusion_status','feature','camera_bbox_info']
  _slot_types = ['int16','int16','float32','float32','int16','float32[]','int32','float32','uint64','uint64','ad_perception_msgs/SizeInfo','ad_perception_msgs/PolygonBox','ad_perception_msgs/DirectionInfo','ad_perception_msgs/MotionInfo','int16','float32','int16','int16','ad_perception_msgs/ModelOutputFeature[]','ad_perception_msgs/CameraBBox2DInfo']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       sensor_id,label,type_confidence,existence_confidence,sub_type,sub_type_probs,track_id,track_age_time_second,last_measure_update_timestamp_ns,current_prediction_timestamp_ns,size_info,polygon_box,direction_info,motion_info,motion_status,motion_static_score,maintenance_status,occlusion_status,feature,camera_bbox_info

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TrafficSign, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.sensor_id is None:
        self.sensor_id = 0
      if self.label is None:
        self.label = 0
      if self.type_confidence is None:
        self.type_confidence = 0.
      if self.existence_confidence is None:
        self.existence_confidence = 0.
      if self.sub_type is None:
        self.sub_type = 0
      if self.sub_type_probs is None:
        self.sub_type_probs = []
      if self.track_id is None:
        self.track_id = 0
      if self.track_age_time_second is None:
        self.track_age_time_second = 0.
      if self.last_measure_update_timestamp_ns is None:
        self.last_measure_update_timestamp_ns = 0
      if self.current_prediction_timestamp_ns is None:
        self.current_prediction_timestamp_ns = 0
      if self.size_info is None:
        self.size_info = ad_perception_msgs.msg.SizeInfo()
      if self.polygon_box is None:
        self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      if self.direction_info is None:
        self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      if self.motion_info is None:
        self.motion_info = ad_perception_msgs.msg.MotionInfo()
      if self.motion_status is None:
        self.motion_status = 0
      if self.motion_static_score is None:
        self.motion_static_score = 0.
      if self.maintenance_status is None:
        self.maintenance_status = 0
      if self.occlusion_status is None:
        self.occlusion_status = 0
      if self.feature is None:
        self.feature = []
      if self.camera_bbox_info is None:
        self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()
    else:
      self.sensor_id = 0
      self.label = 0
      self.type_confidence = 0.
      self.existence_confidence = 0.
      self.sub_type = 0
      self.sub_type_probs = []
      self.track_id = 0
      self.track_age_time_second = 0.
      self.last_measure_update_timestamp_ns = 0
      self.current_prediction_timestamp_ns = 0
      self.size_info = ad_perception_msgs.msg.SizeInfo()
      self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      self.motion_info = ad_perception_msgs.msg.MotionInfo()
      self.motion_status = 0
      self.motion_static_score = 0.
      self.maintenance_status = 0
      self.occlusion_status = 0
      self.feature = []
      self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
      length = len(self.sub_type_probs)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.sub_type_probs))
      _x = self
      buff.write(_get_struct_if2QB12fB().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid))
      length = len(self.polygon_box.polygon_contour)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon_box.polygon_contour:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_2fB16fBh3d49fhf2h().pack(_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
      length = len(self.feature)
      buff.write(_struct_I.pack(length))
      for val1 in self.feature:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.Struct(pattern).pack(*val1.value))
      _x = self
      buff.write(_get_struct_B5fB5f().pack(_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.size_info is None:
        self.size_info = ad_perception_msgs.msg.SizeInfo()
      if self.polygon_box is None:
        self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      if self.direction_info is None:
        self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      if self.motion_info is None:
        self.motion_info = ad_perception_msgs.msg.MotionInfo()
      if self.feature is None:
        self.feature = None
      if self.camera_bbox_info is None:
        self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.sub_type_probs = s.unpack(str[start:end])
      _x = self
      start = end
      end += 74
      (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid,) = _get_struct_if2QB12fB().unpack(str[start:end])
      self.size_info.is_valid = bool(self.size_info.is_valid)
      self.polygon_box.is_valid = bool(self.polygon_box.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon_box.polygon_contour = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Point2f()
        _x = val1
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        self.polygon_box.polygon_contour.append(val1)
      _x = self
      start = end
      end += 306
      (_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_2fB16fBh3d49fhf2h().unpack(str[start:end])
      self.direction_info.is_valid = bool(self.direction_info.is_valid)
      self.motion_info.is_valid = bool(self.motion_info.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.feature = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.ModelOutputFeature()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = s.unpack(str[start:end])
        self.feature.append(val1)
      _x = self
      start = end
      end += 42
      (_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence,) = _get_struct_B5fB5f().unpack(str[start:end])
      self.camera_bbox_info.raw_detection_box.initialized = bool(self.camera_bbox_info.raw_detection_box.initialized)
      self.camera_bbox_info.tracked_box.initialized = bool(self.camera_bbox_info.tracked_box.initialized)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2h2fh().pack(_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type))
      length = len(self.sub_type_probs)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.sub_type_probs.tostring())
      _x = self
      buff.write(_get_struct_if2QB12fB().pack(_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid))
      length = len(self.polygon_box.polygon_contour)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon_box.polygon_contour:
        _x = val1
        buff.write(_get_struct_2f().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_2fB16fBh3d49fhf2h().pack(_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status))
      length = len(self.feature)
      buff.write(_struct_I.pack(length))
      for val1 in self.feature:
        _x = val1.key
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.value)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.value.tostring())
      _x = self
      buff.write(_get_struct_B5fB5f().pack(_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.size_info is None:
        self.size_info = ad_perception_msgs.msg.SizeInfo()
      if self.polygon_box is None:
        self.polygon_box = ad_perception_msgs.msg.PolygonBox()
      if self.direction_info is None:
        self.direction_info = ad_perception_msgs.msg.DirectionInfo()
      if self.motion_info is None:
        self.motion_info = ad_perception_msgs.msg.MotionInfo()
      if self.feature is None:
        self.feature = None
      if self.camera_bbox_info is None:
        self.camera_bbox_info = ad_perception_msgs.msg.CameraBBox2DInfo()
      end = 0
      _x = self
      start = end
      end += 14
      (_x.sensor_id, _x.label, _x.type_confidence, _x.existence_confidence, _x.sub_type,) = _get_struct_2h2fh().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.sub_type_probs = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 74
      (_x.track_id, _x.track_age_time_second, _x.last_measure_update_timestamp_ns, _x.current_prediction_timestamp_ns, _x.size_info.is_valid, _x.size_info.size.x, _x.size_info.size.y, _x.size_info.size.z, _x.size_info.size_uncertainty.x.x, _x.size_info.size_uncertainty.x.y, _x.size_info.size_uncertainty.x.z, _x.size_info.size_uncertainty.y.x, _x.size_info.size_uncertainty.y.y, _x.size_info.size_uncertainty.y.z, _x.size_info.size_uncertainty.z.x, _x.size_info.size_uncertainty.z.y, _x.size_info.size_uncertainty.z.z, _x.polygon_box.is_valid,) = _get_struct_if2QB12fB().unpack(str[start:end])
      self.size_info.is_valid = bool(self.size_info.is_valid)
      self.polygon_box.is_valid = bool(self.polygon_box.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon_box.polygon_contour = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.Point2f()
        _x = val1
        start = end
        end += 8
        (_x.x, _x.y,) = _get_struct_2f().unpack(str[start:end])
        self.polygon_box.polygon_contour.append(val1)
      _x = self
      start = end
      end += 306
      (_x.polygon_box.height_lower_surface, _x.polygon_box.height_upper_surface, _x.direction_info.is_valid, _x.direction_info.direction_ypr.x, _x.direction_info.direction_ypr.y, _x.direction_info.direction_ypr.z, _x.direction_info.direction_ypr_uncertainty.x.x, _x.direction_info.direction_ypr_uncertainty.x.y, _x.direction_info.direction_ypr_uncertainty.x.z, _x.direction_info.direction_ypr_uncertainty.y.x, _x.direction_info.direction_ypr_uncertainty.y.y, _x.direction_info.direction_ypr_uncertainty.y.z, _x.direction_info.direction_ypr_uncertainty.z.x, _x.direction_info.direction_ypr_uncertainty.z.y, _x.direction_info.direction_ypr_uncertainty.z.z, _x.direction_info.yaw, _x.direction_info.yaw_uncertainty, _x.direction_info.yaw_rate, _x.direction_info.yaw_rate_uncertainty, _x.motion_info.is_valid, _x.motion_info.motion_status, _x.motion_info.center.x, _x.motion_info.center.y, _x.motion_info.center.z, _x.motion_info.center_uncertainty.x.x, _x.motion_info.center_uncertainty.x.y, _x.motion_info.center_uncertainty.x.z, _x.motion_info.center_uncertainty.y.x, _x.motion_info.center_uncertainty.y.y, _x.motion_info.center_uncertainty.y.z, _x.motion_info.center_uncertainty.z.x, _x.motion_info.center_uncertainty.z.y, _x.motion_info.center_uncertainty.z.z, _x.motion_info.velocity.x, _x.motion_info.velocity.y, _x.motion_info.velocity.z, _x.motion_info.velocity_uncertainty.x.x, _x.motion_info.velocity_uncertainty.x.y, _x.motion_info.velocity_uncertainty.x.z, _x.motion_info.velocity_uncertainty.y.x, _x.motion_info.velocity_uncertainty.y.y, _x.motion_info.velocity_uncertainty.y.z, _x.motion_info.velocity_uncertainty.z.x, _x.motion_info.velocity_uncertainty.z.y, _x.motion_info.velocity_uncertainty.z.z, _x.motion_info.acceleration.x, _x.motion_info.acceleration.y, _x.motion_info.acceleration.z, _x.motion_info.acceleration_uncertainty.x.x, _x.motion_info.acceleration_uncertainty.x.y, _x.motion_info.acceleration_uncertainty.x.z, _x.motion_info.acceleration_uncertainty.y.x, _x.motion_info.acceleration_uncertainty.y.y, _x.motion_info.acceleration_uncertainty.y.z, _x.motion_info.acceleration_uncertainty.z.x, _x.motion_info.acceleration_uncertainty.z.y, _x.motion_info.acceleration_uncertainty.z.z, _x.motion_info.jerk.x, _x.motion_info.jerk.y, _x.motion_info.jerk.z, _x.motion_info.jerk_uncertainty.x.x, _x.motion_info.jerk_uncertainty.x.y, _x.motion_info.jerk_uncertainty.x.z, _x.motion_info.jerk_uncertainty.y.x, _x.motion_info.jerk_uncertainty.y.y, _x.motion_info.jerk_uncertainty.y.z, _x.motion_info.jerk_uncertainty.z.x, _x.motion_info.jerk_uncertainty.z.y, _x.motion_info.jerk_uncertainty.z.z, _x.motion_info.velocity_heading, _x.motion_info.velocity_heading_uncertainty, _x.motion_info.velocity_heading_rate, _x.motion_info.velocity_heading_rate_uncertainty, _x.motion_status, _x.motion_static_score, _x.maintenance_status, _x.occlusion_status,) = _get_struct_2fB16fBh3d49fhf2h().unpack(str[start:end])
      self.direction_info.is_valid = bool(self.direction_info.is_valid)
      self.motion_info.is_valid = bool(self.motion_info.is_valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.feature = []
      for i in range(0, length):
        val1 = ad_perception_msgs.msg.ModelOutputFeature()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.key = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.key = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.value = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.feature.append(val1)
      _x = self
      start = end
      end += 42
      (_x.camera_bbox_info.raw_detection_box.initialized, _x.camera_bbox_info.raw_detection_box.top_left_x, _x.camera_bbox_info.raw_detection_box.top_left_y, _x.camera_bbox_info.raw_detection_box.bottom_right_x, _x.camera_bbox_info.raw_detection_box.bottom_right_y, _x.camera_bbox_info.raw_detection_box.confidence, _x.camera_bbox_info.tracked_box.initialized, _x.camera_bbox_info.tracked_box.top_left_x, _x.camera_bbox_info.tracked_box.top_left_y, _x.camera_bbox_info.tracked_box.bottom_right_x, _x.camera_bbox_info.tracked_box.bottom_right_y, _x.camera_bbox_info.tracked_box.confidence,) = _get_struct_B5fB5f().unpack(str[start:end])
      self.camera_bbox_info.raw_detection_box.initialized = bool(self.camera_bbox_info.raw_detection_box.initialized)
      self.camera_bbox_info.tracked_box.initialized = bool(self.camera_bbox_info.tracked_box.initialized)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_2fB16fBh3d49fhf2h = None
def _get_struct_2fB16fBh3d49fhf2h():
    global _struct_2fB16fBh3d49fhf2h
    if _struct_2fB16fBh3d49fhf2h is None:
        _struct_2fB16fBh3d49fhf2h = struct.Struct("<2fB16fBh3d49fhf2h")
    return _struct_2fB16fBh3d49fhf2h
_struct_2h2fh = None
def _get_struct_2h2fh():
    global _struct_2h2fh
    if _struct_2h2fh is None:
        _struct_2h2fh = struct.Struct("<2h2fh")
    return _struct_2h2fh
_struct_B5fB5f = None
def _get_struct_B5fB5f():
    global _struct_B5fB5f
    if _struct_B5fB5f is None:
        _struct_B5fB5f = struct.Struct("<B5fB5f")
    return _struct_B5fB5f
_struct_if2QB12fB = None
def _get_struct_if2QB12fB():
    global _struct_if2QB12fB
    if _struct_if2QB12fB is None:
        _struct_if2QB12fB = struct.Struct("<if2QB12fB")
    return _struct_if2QB12fB
