# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_planning_msgs/PlanningDebug.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class PlanningDebug(genpy.Message):
  _md5sum = "db7f2c19c269e211b6a848c3d6f9f679"
  _type = "ad_planning_msgs/PlanningDebug"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header
uint64 timestamp
uint32 num
uint32 acc_num
uint64 predict_timestamp
float64 time_interval
float64[] x
float64[] y
float64[] v
float64[] yaw
float64[] a
float64[] jerk
float64 lateral_d
float64 lateral_v
float64 lateral_a
float64 lateral_jerk
float64 speed_limit
float64 stop_distance
float64 nbo_limit
float64 cutin_limit
float64 velocity
float64 acceleration
bool longi_dp_success
bool lat_dp_success
bool longi_solve_success
bool lat_solve_success
uint32 turn_signal
uint32 nudge_counter
uint32 speed_scene
uint32 planning_scenario
uint32 keep_onsite_counter
float64 lane_change_end_point
int32 leader_id
float64 leader_s
float64 leader_v
float64 leader_time
int32 near_leader_id
float64 near_leader_s
float64 near_leader_v
float64 near_leader_time
uint32 pre_lane_change_flag


# obstalce tags with serialization
string obstacle_tag
# lateral optimization lower bound
string lateral_lower_bound
# lateral optimization upper bound
string lateral_upper_bound
# lateral dp search result
string lateral_search_result
# lateral optimization r_ref
string lateral_r_ref
string frame_time_string


================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','timestamp','num','acc_num','predict_timestamp','time_interval','x','y','v','yaw','a','jerk','lateral_d','lateral_v','lateral_a','lateral_jerk','speed_limit','stop_distance','nbo_limit','cutin_limit','velocity','acceleration','longi_dp_success','lat_dp_success','longi_solve_success','lat_solve_success','turn_signal','nudge_counter','speed_scene','planning_scenario','keep_onsite_counter','lane_change_end_point','leader_id','leader_s','leader_v','leader_time','near_leader_id','near_leader_s','near_leader_v','near_leader_time','pre_lane_change_flag','obstacle_tag','lateral_lower_bound','lateral_upper_bound','lateral_search_result','lateral_r_ref','frame_time_string']
  _slot_types = ['std_msgs/Header','uint64','uint32','uint32','uint64','float64','float64[]','float64[]','float64[]','float64[]','float64[]','float64[]','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','bool','bool','bool','bool','uint32','uint32','uint32','uint32','uint32','float64','int32','float64','float64','float64','int32','float64','float64','float64','uint32','string','string','string','string','string','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,timestamp,num,acc_num,predict_timestamp,time_interval,x,y,v,yaw,a,jerk,lateral_d,lateral_v,lateral_a,lateral_jerk,speed_limit,stop_distance,nbo_limit,cutin_limit,velocity,acceleration,longi_dp_success,lat_dp_success,longi_solve_success,lat_solve_success,turn_signal,nudge_counter,speed_scene,planning_scenario,keep_onsite_counter,lane_change_end_point,leader_id,leader_s,leader_v,leader_time,near_leader_id,near_leader_s,near_leader_v,near_leader_time,pre_lane_change_flag,obstacle_tag,lateral_lower_bound,lateral_upper_bound,lateral_search_result,lateral_r_ref,frame_time_string

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PlanningDebug, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.timestamp is None:
        self.timestamp = 0
      if self.num is None:
        self.num = 0
      if self.acc_num is None:
        self.acc_num = 0
      if self.predict_timestamp is None:
        self.predict_timestamp = 0
      if self.time_interval is None:
        self.time_interval = 0.
      if self.x is None:
        self.x = []
      if self.y is None:
        self.y = []
      if self.v is None:
        self.v = []
      if self.yaw is None:
        self.yaw = []
      if self.a is None:
        self.a = []
      if self.jerk is None:
        self.jerk = []
      if self.lateral_d is None:
        self.lateral_d = 0.
      if self.lateral_v is None:
        self.lateral_v = 0.
      if self.lateral_a is None:
        self.lateral_a = 0.
      if self.lateral_jerk is None:
        self.lateral_jerk = 0.
      if self.speed_limit is None:
        self.speed_limit = 0.
      if self.stop_distance is None:
        self.stop_distance = 0.
      if self.nbo_limit is None:
        self.nbo_limit = 0.
      if self.cutin_limit is None:
        self.cutin_limit = 0.
      if self.velocity is None:
        self.velocity = 0.
      if self.acceleration is None:
        self.acceleration = 0.
      if self.longi_dp_success is None:
        self.longi_dp_success = False
      if self.lat_dp_success is None:
        self.lat_dp_success = False
      if self.longi_solve_success is None:
        self.longi_solve_success = False
      if self.lat_solve_success is None:
        self.lat_solve_success = False
      if self.turn_signal is None:
        self.turn_signal = 0
      if self.nudge_counter is None:
        self.nudge_counter = 0
      if self.speed_scene is None:
        self.speed_scene = 0
      if self.planning_scenario is None:
        self.planning_scenario = 0
      if self.keep_onsite_counter is None:
        self.keep_onsite_counter = 0
      if self.lane_change_end_point is None:
        self.lane_change_end_point = 0.
      if self.leader_id is None:
        self.leader_id = 0
      if self.leader_s is None:
        self.leader_s = 0.
      if self.leader_v is None:
        self.leader_v = 0.
      if self.leader_time is None:
        self.leader_time = 0.
      if self.near_leader_id is None:
        self.near_leader_id = 0
      if self.near_leader_s is None:
        self.near_leader_s = 0.
      if self.near_leader_v is None:
        self.near_leader_v = 0.
      if self.near_leader_time is None:
        self.near_leader_time = 0.
      if self.pre_lane_change_flag is None:
        self.pre_lane_change_flag = 0
      if self.obstacle_tag is None:
        self.obstacle_tag = ''
      if self.lateral_lower_bound is None:
        self.lateral_lower_bound = ''
      if self.lateral_upper_bound is None:
        self.lateral_upper_bound = ''
      if self.lateral_search_result is None:
        self.lateral_search_result = ''
      if self.lateral_r_ref is None:
        self.lateral_r_ref = ''
      if self.frame_time_string is None:
        self.frame_time_string = ''
    else:
      self.header = std_msgs.msg.Header()
      self.timestamp = 0
      self.num = 0
      self.acc_num = 0
      self.predict_timestamp = 0
      self.time_interval = 0.
      self.x = []
      self.y = []
      self.v = []
      self.yaw = []
      self.a = []
      self.jerk = []
      self.lateral_d = 0.
      self.lateral_v = 0.
      self.lateral_a = 0.
      self.lateral_jerk = 0.
      self.speed_limit = 0.
      self.stop_distance = 0.
      self.nbo_limit = 0.
      self.cutin_limit = 0.
      self.velocity = 0.
      self.acceleration = 0.
      self.longi_dp_success = False
      self.lat_dp_success = False
      self.longi_solve_success = False
      self.lat_solve_success = False
      self.turn_signal = 0
      self.nudge_counter = 0
      self.speed_scene = 0
      self.planning_scenario = 0
      self.keep_onsite_counter = 0
      self.lane_change_end_point = 0.
      self.leader_id = 0
      self.leader_s = 0.
      self.leader_v = 0.
      self.leader_time = 0.
      self.near_leader_id = 0
      self.near_leader_s = 0.
      self.near_leader_v = 0.
      self.near_leader_time = 0.
      self.pre_lane_change_flag = 0
      self.obstacle_tag = ''
      self.lateral_lower_bound = ''
      self.lateral_upper_bound = ''
      self.lateral_search_result = ''
      self.lateral_r_ref = ''
      self.frame_time_string = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Q2IQd().pack(_x.timestamp, _x.num, _x.acc_num, _x.predict_timestamp, _x.time_interval))
      length = len(self.x)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.x))
      length = len(self.y)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.y))
      length = len(self.v)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.v))
      length = len(self.yaw)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.yaw))
      length = len(self.a)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.a))
      length = len(self.jerk)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.jerk))
      _x = self
      buff.write(_get_struct_10d4B5Idi3di3dI().pack(_x.lateral_d, _x.lateral_v, _x.lateral_a, _x.lateral_jerk, _x.speed_limit, _x.stop_distance, _x.nbo_limit, _x.cutin_limit, _x.velocity, _x.acceleration, _x.longi_dp_success, _x.lat_dp_success, _x.longi_solve_success, _x.lat_solve_success, _x.turn_signal, _x.nudge_counter, _x.speed_scene, _x.planning_scenario, _x.keep_onsite_counter, _x.lane_change_end_point, _x.leader_id, _x.leader_s, _x.leader_v, _x.leader_time, _x.near_leader_id, _x.near_leader_s, _x.near_leader_v, _x.near_leader_time, _x.pre_lane_change_flag))
      _x = self.obstacle_tag
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_lower_bound
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_upper_bound
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_search_result
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_r_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.frame_time_string
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.timestamp, _x.num, _x.acc_num, _x.predict_timestamp, _x.time_interval,) = _get_struct_Q2IQd().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.x = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.y = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.v = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.yaw = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.a = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.jerk = s.unpack(str[start:end])
      _x = self
      start = end
      end += 172
      (_x.lateral_d, _x.lateral_v, _x.lateral_a, _x.lateral_jerk, _x.speed_limit, _x.stop_distance, _x.nbo_limit, _x.cutin_limit, _x.velocity, _x.acceleration, _x.longi_dp_success, _x.lat_dp_success, _x.longi_solve_success, _x.lat_solve_success, _x.turn_signal, _x.nudge_counter, _x.speed_scene, _x.planning_scenario, _x.keep_onsite_counter, _x.lane_change_end_point, _x.leader_id, _x.leader_s, _x.leader_v, _x.leader_time, _x.near_leader_id, _x.near_leader_s, _x.near_leader_v, _x.near_leader_time, _x.pre_lane_change_flag,) = _get_struct_10d4B5Idi3di3dI().unpack(str[start:end])
      self.longi_dp_success = bool(self.longi_dp_success)
      self.lat_dp_success = bool(self.lat_dp_success)
      self.longi_solve_success = bool(self.longi_solve_success)
      self.lat_solve_success = bool(self.lat_solve_success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.obstacle_tag = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.obstacle_tag = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_lower_bound = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_lower_bound = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_upper_bound = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_upper_bound = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_search_result = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_search_result = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_r_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_r_ref = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_time_string = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_time_string = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Q2IQd().pack(_x.timestamp, _x.num, _x.acc_num, _x.predict_timestamp, _x.time_interval))
      length = len(self.x)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.x.tostring())
      length = len(self.y)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.y.tostring())
      length = len(self.v)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.v.tostring())
      length = len(self.yaw)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.yaw.tostring())
      length = len(self.a)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.a.tostring())
      length = len(self.jerk)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.jerk.tostring())
      _x = self
      buff.write(_get_struct_10d4B5Idi3di3dI().pack(_x.lateral_d, _x.lateral_v, _x.lateral_a, _x.lateral_jerk, _x.speed_limit, _x.stop_distance, _x.nbo_limit, _x.cutin_limit, _x.velocity, _x.acceleration, _x.longi_dp_success, _x.lat_dp_success, _x.longi_solve_success, _x.lat_solve_success, _x.turn_signal, _x.nudge_counter, _x.speed_scene, _x.planning_scenario, _x.keep_onsite_counter, _x.lane_change_end_point, _x.leader_id, _x.leader_s, _x.leader_v, _x.leader_time, _x.near_leader_id, _x.near_leader_s, _x.near_leader_v, _x.near_leader_time, _x.pre_lane_change_flag))
      _x = self.obstacle_tag
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_lower_bound
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_upper_bound
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_search_result
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lateral_r_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.frame_time_string
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.timestamp, _x.num, _x.acc_num, _x.predict_timestamp, _x.time_interval,) = _get_struct_Q2IQd().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.x = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.y = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.v = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.yaw = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.a = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.jerk = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 172
      (_x.lateral_d, _x.lateral_v, _x.lateral_a, _x.lateral_jerk, _x.speed_limit, _x.stop_distance, _x.nbo_limit, _x.cutin_limit, _x.velocity, _x.acceleration, _x.longi_dp_success, _x.lat_dp_success, _x.longi_solve_success, _x.lat_solve_success, _x.turn_signal, _x.nudge_counter, _x.speed_scene, _x.planning_scenario, _x.keep_onsite_counter, _x.lane_change_end_point, _x.leader_id, _x.leader_s, _x.leader_v, _x.leader_time, _x.near_leader_id, _x.near_leader_s, _x.near_leader_v, _x.near_leader_time, _x.pre_lane_change_flag,) = _get_struct_10d4B5Idi3di3dI().unpack(str[start:end])
      self.longi_dp_success = bool(self.longi_dp_success)
      self.lat_dp_success = bool(self.lat_dp_success)
      self.longi_solve_success = bool(self.longi_solve_success)
      self.lat_solve_success = bool(self.lat_solve_success)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.obstacle_tag = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.obstacle_tag = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_lower_bound = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_lower_bound = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_upper_bound = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_upper_bound = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_search_result = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_search_result = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lateral_r_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lateral_r_ref = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frame_time_string = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frame_time_string = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10d4B5Idi3di3dI = None
def _get_struct_10d4B5Idi3di3dI():
    global _struct_10d4B5Idi3di3dI
    if _struct_10d4B5Idi3di3dI is None:
        _struct_10d4B5Idi3di3dI = struct.Struct("<10d4B5Idi3di3dI")
    return _struct_10d4B5Idi3di3dI
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_Q2IQd = None
def _get_struct_Q2IQd():
    global _struct_Q2IQd
    if _struct_Q2IQd is None:
        _struct_Q2IQd = struct.Struct("<Q2IQd")
    return _struct_Q2IQd
