# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_prediction_msgs/Prediction.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_prediction_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class Prediction(genpy.Message):
  _md5sum = "ca48ca7a08f41a05f72ebfa484bd5ac5"
  _type = "ad_prediction_msgs/Prediction"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp(last node pub time), and frame_id
std_msgs/Header header

# Timestamp
uint64 prediction_time_ns
uint64 fusion_time_ns

# Objects
PredictionObject[] object_list

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_prediction_msgs/PredictionObject
int32 id
uint8 obstacle_type_enum
uint8 object_label_enum

float32 length_m
float32 width_m
float32 height_m

geometry_msgs/Point[] polygon_contour

geometry_msgs/Point position
geometry_msgs/Point speed
geometry_msgs/Point acceleration
geometry_msgs/Point heading_direction

uint8 info_state_enum
uint8 scene_type_enum
uint8 importance_level_enum
uint16 move_step

uint8 intention_type
string target_road_id
string target_lane_id

PredictionTrajectory[] trajectory_array
geometry_msgs/Point[] history_trajectory_points

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: ad_prediction_msgs/PredictionTrajectory
string predictor_name
string target_road_id
string target_lane_id

uint64 point_interval_time_ns
uint32 num_points
PredictionTrajectoryPoint[] trajectory_point_array

# Info
bool is_abnormal
bool is_collision
bool is_selected
float32 probability
float32 score

================================================================================
MSG: ad_prediction_msgs/PredictionTrajectoryPoint
geometry_msgs/Point[] polygon_contour

geometry_msgs/Point position
geometry_msgs/Point direction
geometry_msgs/Point speed

geometry_msgs/Point variance_position
geometry_msgs/Point variance_speed

float32 covariance_position
float32 covariance_speed
"""
  __slots__ = ['header','prediction_time_ns','fusion_time_ns','object_list']
  _slot_types = ['std_msgs/Header','uint64','uint64','ad_prediction_msgs/PredictionObject[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,prediction_time_ns,fusion_time_ns,object_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Prediction, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.prediction_time_ns is None:
        self.prediction_time_ns = 0
      if self.fusion_time_ns is None:
        self.fusion_time_ns = 0
      if self.object_list is None:
        self.object_list = []
    else:
      self.header = std_msgs.msg.Header()
      self.prediction_time_ns = 0
      self.fusion_time_ns = 0
      self.object_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2Q().pack(_x.prediction_time_ns, _x.fusion_time_ns))
      length = len(self.object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_list:
        _x = val1
        buff.write(_get_struct_i2B3f().pack(_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m))
        length = len(val1.polygon_contour)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygon_contour:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v1 = val1.position
        _x = _v1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v2 = val1.speed
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = val1.acceleration
        _x = _v3
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v4 = val1.heading_direction
        _x = _v4
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_get_struct_3BHB().pack(_x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type))
        _x = val1.target_road_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.target_lane_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.trajectory_array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.trajectory_array:
          _x = val2.predictor_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.target_road_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.target_lane_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2
          buff.write(_get_struct_QI().pack(_x.point_interval_time_ns, _x.num_points))
          length = len(val2.trajectory_point_array)
          buff.write(_struct_I.pack(length))
          for val3 in val2.trajectory_point_array:
            length = len(val3.polygon_contour)
            buff.write(_struct_I.pack(length))
            for val4 in val3.polygon_contour:
              _x = val4
              buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v5 = val3.position
            _x = _v5
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v6 = val3.direction
            _x = _v6
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v7 = val3.speed
            _x = _v7
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v8 = val3.variance_position
            _x = _v8
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v9 = val3.variance_speed
            _x = _v9
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _x = val3
            buff.write(_get_struct_2f().pack(_x.covariance_position, _x.covariance_speed))
          _x = val2
          buff.write(_get_struct_3B2f().pack(_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score))
        length = len(val1.history_trajectory_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.history_trajectory_points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.object_list is None:
        self.object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.prediction_time_ns, _x.fusion_time_ns,) = _get_struct_2Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_list = []
      for i in range(0, length):
        val1 = ad_prediction_msgs.msg.PredictionObject()
        _x = val1
        start = end
        end += 18
        (_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m,) = _get_struct_i2B3f().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygon_contour = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.polygon_contour.append(val2)
        _v10 = val1.position
        _x = _v10
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v11 = val1.speed
        _x = _v11
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v12 = val1.acceleration
        _x = _v12
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v13 = val1.heading_direction
        _x = _v13
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _x = val1
        start = end
        end += 6
        (_x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type,) = _get_struct_3BHB().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_road_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_lane_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.trajectory_array = []
        for i in range(0, length):
          val2 = ad_prediction_msgs.msg.PredictionTrajectory()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.predictor_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.predictor_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.target_road_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.target_lane_id = str[start:end]
          _x = val2
          start = end
          end += 12
          (_x.point_interval_time_ns, _x.num_points,) = _get_struct_QI().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.trajectory_point_array = []
          for i in range(0, length):
            val3 = ad_prediction_msgs.msg.PredictionTrajectoryPoint()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val3.polygon_contour = []
            for i in range(0, length):
              val4 = geometry_msgs.msg.Point()
              _x = val4
              start = end
              end += 24
              (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
              val3.polygon_contour.append(val4)
            _v14 = val3.position
            _x = _v14
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v15 = val3.direction
            _x = _v15
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v16 = val3.speed
            _x = _v16
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v17 = val3.variance_position
            _x = _v17
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v18 = val3.variance_speed
            _x = _v18
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _x = val3
            start = end
            end += 8
            (_x.covariance_position, _x.covariance_speed,) = _get_struct_2f().unpack(str[start:end])
            val2.trajectory_point_array.append(val3)
          _x = val2
          start = end
          end += 11
          (_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score,) = _get_struct_3B2f().unpack(str[start:end])
          val2.is_abnormal = bool(val2.is_abnormal)
          val2.is_collision = bool(val2.is_collision)
          val2.is_selected = bool(val2.is_selected)
          val1.trajectory_array.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.history_trajectory_points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.history_trajectory_points.append(val2)
        self.object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2Q().pack(_x.prediction_time_ns, _x.fusion_time_ns))
      length = len(self.object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_list:
        _x = val1
        buff.write(_get_struct_i2B3f().pack(_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m))
        length = len(val1.polygon_contour)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygon_contour:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v19 = val1.position
        _x = _v19
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v20 = val1.speed
        _x = _v20
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v21 = val1.acceleration
        _x = _v21
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v22 = val1.heading_direction
        _x = _v22
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_get_struct_3BHB().pack(_x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type))
        _x = val1.target_road_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.target_lane_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.trajectory_array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.trajectory_array:
          _x = val2.predictor_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.target_road_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2.target_lane_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
          _x = val2
          buff.write(_get_struct_QI().pack(_x.point_interval_time_ns, _x.num_points))
          length = len(val2.trajectory_point_array)
          buff.write(_struct_I.pack(length))
          for val3 in val2.trajectory_point_array:
            length = len(val3.polygon_contour)
            buff.write(_struct_I.pack(length))
            for val4 in val3.polygon_contour:
              _x = val4
              buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v23 = val3.position
            _x = _v23
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v24 = val3.direction
            _x = _v24
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v25 = val3.speed
            _x = _v25
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v26 = val3.variance_position
            _x = _v26
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _v27 = val3.variance_speed
            _x = _v27
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
            _x = val3
            buff.write(_get_struct_2f().pack(_x.covariance_position, _x.covariance_speed))
          _x = val2
          buff.write(_get_struct_3B2f().pack(_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score))
        length = len(val1.history_trajectory_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.history_trajectory_points:
          _x = val2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.object_list is None:
        self.object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.prediction_time_ns, _x.fusion_time_ns,) = _get_struct_2Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_list = []
      for i in range(0, length):
        val1 = ad_prediction_msgs.msg.PredictionObject()
        _x = val1
        start = end
        end += 18
        (_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m,) = _get_struct_i2B3f().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygon_contour = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.polygon_contour.append(val2)
        _v28 = val1.position
        _x = _v28
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v29 = val1.speed
        _x = _v29
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v30 = val1.acceleration
        _x = _v30
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v31 = val1.heading_direction
        _x = _v31
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _x = val1
        start = end
        end += 6
        (_x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type,) = _get_struct_3BHB().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_road_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_lane_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.trajectory_array = []
        for i in range(0, length):
          val2 = ad_prediction_msgs.msg.PredictionTrajectory()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.predictor_name = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.predictor_name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.target_road_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2.target_lane_id = str[start:end]
          _x = val2
          start = end
          end += 12
          (_x.point_interval_time_ns, _x.num_points,) = _get_struct_QI().unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.trajectory_point_array = []
          for i in range(0, length):
            val3 = ad_prediction_msgs.msg.PredictionTrajectoryPoint()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            val3.polygon_contour = []
            for i in range(0, length):
              val4 = geometry_msgs.msg.Point()
              _x = val4
              start = end
              end += 24
              (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
              val3.polygon_contour.append(val4)
            _v32 = val3.position
            _x = _v32
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v33 = val3.direction
            _x = _v33
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v34 = val3.speed
            _x = _v34
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v35 = val3.variance_position
            _x = _v35
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _v36 = val3.variance_speed
            _x = _v36
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            _x = val3
            start = end
            end += 8
            (_x.covariance_position, _x.covariance_speed,) = _get_struct_2f().unpack(str[start:end])
            val2.trajectory_point_array.append(val3)
          _x = val2
          start = end
          end += 11
          (_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score,) = _get_struct_3B2f().unpack(str[start:end])
          val2.is_abnormal = bool(val2.is_abnormal)
          val2.is_collision = bool(val2.is_collision)
          val2.is_selected = bool(val2.is_selected)
          val1.trajectory_array.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.history_trajectory_points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          val1.history_trajectory_points.append(val2)
        self.object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Q = None
def _get_struct_2Q():
    global _struct_2Q
    if _struct_2Q is None:
        _struct_2Q = struct.Struct("<2Q")
    return _struct_2Q
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_3B2f = None
def _get_struct_3B2f():
    global _struct_3B2f
    if _struct_3B2f is None:
        _struct_3B2f = struct.Struct("<3B2f")
    return _struct_3B2f
_struct_3BHB = None
def _get_struct_3BHB():
    global _struct_3BHB
    if _struct_3BHB is None:
        _struct_3BHB = struct.Struct("<3BHB")
    return _struct_3BHB
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_QI = None
def _get_struct_QI():
    global _struct_QI
    if _struct_QI is None:
        _struct_QI = struct.Struct("<QI")
    return _struct_QI
_struct_i2B3f = None
def _get_struct_i2B3f():
    global _struct_i2B3f
    if _struct_i2B3f is None:
        _struct_i2B3f = struct.Struct("<i2B3f")
    return _struct_i2B3f
