# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_prediction_msgs/PredictionObject.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_prediction_msgs.msg
import geometry_msgs.msg

class PredictionObject(genpy.Message):
  _md5sum = "dd75578f4608d1508e1f46f59015299b"
  _type = "ad_prediction_msgs/PredictionObject"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """int32 id
uint8 obstacle_type_enum
uint8 object_label_enum

float32 length_m
float32 width_m
float32 height_m

geometry_msgs/Point[] polygon_contour

geometry_msgs/Point position
geometry_msgs/Point speed
geometry_msgs/Point acceleration
geometry_msgs/Point heading_direction

uint8 info_state_enum
uint8 scene_type_enum
uint8 importance_level_enum
uint16 move_step

uint8 intention_type
string target_road_id
string target_lane_id

PredictionTrajectory[] trajectory_array
geometry_msgs/Point[] history_trajectory_points

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: ad_prediction_msgs/PredictionTrajectory
string predictor_name
string target_road_id
string target_lane_id

uint64 point_interval_time_ns
uint32 num_points
PredictionTrajectoryPoint[] trajectory_point_array

# Info
bool is_abnormal
bool is_collision
bool is_selected
float32 probability
float32 score

================================================================================
MSG: ad_prediction_msgs/PredictionTrajectoryPoint
geometry_msgs/Point[] polygon_contour

geometry_msgs/Point position
geometry_msgs/Point direction
geometry_msgs/Point speed

geometry_msgs/Point variance_position
geometry_msgs/Point variance_speed

float32 covariance_position
float32 covariance_speed
"""
  __slots__ = ['id','obstacle_type_enum','object_label_enum','length_m','width_m','height_m','polygon_contour','position','speed','acceleration','heading_direction','info_state_enum','scene_type_enum','importance_level_enum','move_step','intention_type','target_road_id','target_lane_id','trajectory_array','history_trajectory_points']
  _slot_types = ['int32','uint8','uint8','float32','float32','float32','geometry_msgs/Point[]','geometry_msgs/Point','geometry_msgs/Point','geometry_msgs/Point','geometry_msgs/Point','uint8','uint8','uint8','uint16','uint8','string','string','ad_prediction_msgs/PredictionTrajectory[]','geometry_msgs/Point[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       id,obstacle_type_enum,object_label_enum,length_m,width_m,height_m,polygon_contour,position,speed,acceleration,heading_direction,info_state_enum,scene_type_enum,importance_level_enum,move_step,intention_type,target_road_id,target_lane_id,trajectory_array,history_trajectory_points

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PredictionObject, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.id is None:
        self.id = 0
      if self.obstacle_type_enum is None:
        self.obstacle_type_enum = 0
      if self.object_label_enum is None:
        self.object_label_enum = 0
      if self.length_m is None:
        self.length_m = 0.
      if self.width_m is None:
        self.width_m = 0.
      if self.height_m is None:
        self.height_m = 0.
      if self.polygon_contour is None:
        self.polygon_contour = []
      if self.position is None:
        self.position = geometry_msgs.msg.Point()
      if self.speed is None:
        self.speed = geometry_msgs.msg.Point()
      if self.acceleration is None:
        self.acceleration = geometry_msgs.msg.Point()
      if self.heading_direction is None:
        self.heading_direction = geometry_msgs.msg.Point()
      if self.info_state_enum is None:
        self.info_state_enum = 0
      if self.scene_type_enum is None:
        self.scene_type_enum = 0
      if self.importance_level_enum is None:
        self.importance_level_enum = 0
      if self.move_step is None:
        self.move_step = 0
      if self.intention_type is None:
        self.intention_type = 0
      if self.target_road_id is None:
        self.target_road_id = ''
      if self.target_lane_id is None:
        self.target_lane_id = ''
      if self.trajectory_array is None:
        self.trajectory_array = []
      if self.history_trajectory_points is None:
        self.history_trajectory_points = []
    else:
      self.id = 0
      self.obstacle_type_enum = 0
      self.object_label_enum = 0
      self.length_m = 0.
      self.width_m = 0.
      self.height_m = 0.
      self.polygon_contour = []
      self.position = geometry_msgs.msg.Point()
      self.speed = geometry_msgs.msg.Point()
      self.acceleration = geometry_msgs.msg.Point()
      self.heading_direction = geometry_msgs.msg.Point()
      self.info_state_enum = 0
      self.scene_type_enum = 0
      self.importance_level_enum = 0
      self.move_step = 0
      self.intention_type = 0
      self.target_road_id = ''
      self.target_lane_id = ''
      self.trajectory_array = []
      self.history_trajectory_points = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_i2B3f().pack(_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m))
      length = len(self.polygon_contour)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon_contour:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_12d3BHB().pack(_x.position.x, _x.position.y, _x.position.z, _x.speed.x, _x.speed.y, _x.speed.z, _x.acceleration.x, _x.acceleration.y, _x.acceleration.z, _x.heading_direction.x, _x.heading_direction.y, _x.heading_direction.z, _x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type))
      _x = self.target_road_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.target_lane_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.trajectory_array)
      buff.write(_struct_I.pack(length))
      for val1 in self.trajectory_array:
        _x = val1.predictor_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.target_road_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.target_lane_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_QI().pack(_x.point_interval_time_ns, _x.num_points))
        length = len(val1.trajectory_point_array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.trajectory_point_array:
          length = len(val2.polygon_contour)
          buff.write(_struct_I.pack(length))
          for val3 in val2.polygon_contour:
            _x = val3
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v1 = val2.position
          _x = _v1
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v2 = val2.direction
          _x = _v2
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v3 = val2.speed
          _x = _v3
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v4 = val2.variance_position
          _x = _v4
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v5 = val2.variance_speed
          _x = _v5
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_get_struct_2f().pack(_x.covariance_position, _x.covariance_speed))
        _x = val1
        buff.write(_get_struct_3B2f().pack(_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score))
      length = len(self.history_trajectory_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.history_trajectory_points:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.polygon_contour is None:
        self.polygon_contour = None
      if self.position is None:
        self.position = geometry_msgs.msg.Point()
      if self.speed is None:
        self.speed = geometry_msgs.msg.Point()
      if self.acceleration is None:
        self.acceleration = geometry_msgs.msg.Point()
      if self.heading_direction is None:
        self.heading_direction = geometry_msgs.msg.Point()
      if self.trajectory_array is None:
        self.trajectory_array = None
      if self.history_trajectory_points is None:
        self.history_trajectory_points = None
      end = 0
      _x = self
      start = end
      end += 18
      (_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m,) = _get_struct_i2B3f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon_contour = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.polygon_contour.append(val1)
      _x = self
      start = end
      end += 102
      (_x.position.x, _x.position.y, _x.position.z, _x.speed.x, _x.speed.y, _x.speed.z, _x.acceleration.x, _x.acceleration.y, _x.acceleration.z, _x.heading_direction.x, _x.heading_direction.y, _x.heading_direction.z, _x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type,) = _get_struct_12d3BHB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_road_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_lane_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.trajectory_array = []
      for i in range(0, length):
        val1 = ad_prediction_msgs.msg.PredictionTrajectory()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.predictor_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.predictor_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_road_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_lane_id = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.point_interval_time_ns, _x.num_points,) = _get_struct_QI().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.trajectory_point_array = []
        for i in range(0, length):
          val2 = ad_prediction_msgs.msg.PredictionTrajectoryPoint()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.polygon_contour = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            val2.polygon_contour.append(val3)
          _v6 = val2.position
          _x = _v6
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v7 = val2.direction
          _x = _v7
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v8 = val2.speed
          _x = _v8
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v9 = val2.variance_position
          _x = _v9
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v10 = val2.variance_speed
          _x = _v10
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _x = val2
          start = end
          end += 8
          (_x.covariance_position, _x.covariance_speed,) = _get_struct_2f().unpack(str[start:end])
          val1.trajectory_point_array.append(val2)
        _x = val1
        start = end
        end += 11
        (_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score,) = _get_struct_3B2f().unpack(str[start:end])
        val1.is_abnormal = bool(val1.is_abnormal)
        val1.is_collision = bool(val1.is_collision)
        val1.is_selected = bool(val1.is_selected)
        self.trajectory_array.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.history_trajectory_points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.history_trajectory_points.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_i2B3f().pack(_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m))
      length = len(self.polygon_contour)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon_contour:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_get_struct_12d3BHB().pack(_x.position.x, _x.position.y, _x.position.z, _x.speed.x, _x.speed.y, _x.speed.z, _x.acceleration.x, _x.acceleration.y, _x.acceleration.z, _x.heading_direction.x, _x.heading_direction.y, _x.heading_direction.z, _x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type))
      _x = self.target_road_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.target_lane_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.trajectory_array)
      buff.write(_struct_I.pack(length))
      for val1 in self.trajectory_array:
        _x = val1.predictor_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.target_road_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.target_lane_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_QI().pack(_x.point_interval_time_ns, _x.num_points))
        length = len(val1.trajectory_point_array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.trajectory_point_array:
          length = len(val2.polygon_contour)
          buff.write(_struct_I.pack(length))
          for val3 in val2.polygon_contour:
            _x = val3
            buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v11 = val2.position
          _x = _v11
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v12 = val2.direction
          _x = _v12
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v13 = val2.speed
          _x = _v13
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v14 = val2.variance_position
          _x = _v14
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _v15 = val2.variance_speed
          _x = _v15
          buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_get_struct_2f().pack(_x.covariance_position, _x.covariance_speed))
        _x = val1
        buff.write(_get_struct_3B2f().pack(_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score))
      length = len(self.history_trajectory_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.history_trajectory_points:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.polygon_contour is None:
        self.polygon_contour = None
      if self.position is None:
        self.position = geometry_msgs.msg.Point()
      if self.speed is None:
        self.speed = geometry_msgs.msg.Point()
      if self.acceleration is None:
        self.acceleration = geometry_msgs.msg.Point()
      if self.heading_direction is None:
        self.heading_direction = geometry_msgs.msg.Point()
      if self.trajectory_array is None:
        self.trajectory_array = None
      if self.history_trajectory_points is None:
        self.history_trajectory_points = None
      end = 0
      _x = self
      start = end
      end += 18
      (_x.id, _x.obstacle_type_enum, _x.object_label_enum, _x.length_m, _x.width_m, _x.height_m,) = _get_struct_i2B3f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon_contour = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.polygon_contour.append(val1)
      _x = self
      start = end
      end += 102
      (_x.position.x, _x.position.y, _x.position.z, _x.speed.x, _x.speed.y, _x.speed.z, _x.acceleration.x, _x.acceleration.y, _x.acceleration.z, _x.heading_direction.x, _x.heading_direction.y, _x.heading_direction.z, _x.info_state_enum, _x.scene_type_enum, _x.importance_level_enum, _x.move_step, _x.intention_type,) = _get_struct_12d3BHB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_road_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_lane_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.trajectory_array = []
      for i in range(0, length):
        val1 = ad_prediction_msgs.msg.PredictionTrajectory()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.predictor_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.predictor_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_road_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_road_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.target_lane_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.target_lane_id = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.point_interval_time_ns, _x.num_points,) = _get_struct_QI().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.trajectory_point_array = []
        for i in range(0, length):
          val2 = ad_prediction_msgs.msg.PredictionTrajectoryPoint()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.polygon_contour = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
            val2.polygon_contour.append(val3)
          _v16 = val2.position
          _x = _v16
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v17 = val2.direction
          _x = _v17
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v18 = val2.speed
          _x = _v18
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v19 = val2.variance_position
          _x = _v19
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _v20 = val2.variance_speed
          _x = _v20
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
          _x = val2
          start = end
          end += 8
          (_x.covariance_position, _x.covariance_speed,) = _get_struct_2f().unpack(str[start:end])
          val1.trajectory_point_array.append(val2)
        _x = val1
        start = end
        end += 11
        (_x.is_abnormal, _x.is_collision, _x.is_selected, _x.probability, _x.score,) = _get_struct_3B2f().unpack(str[start:end])
        val1.is_abnormal = bool(val1.is_abnormal)
        val1.is_collision = bool(val1.is_collision)
        val1.is_selected = bool(val1.is_selected)
        self.trajectory_array.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.history_trajectory_points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.history_trajectory_points.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12d3BHB = None
def _get_struct_12d3BHB():
    global _struct_12d3BHB
    if _struct_12d3BHB is None:
        _struct_12d3BHB = struct.Struct("<12d3BHB")
    return _struct_12d3BHB
_struct_2f = None
def _get_struct_2f():
    global _struct_2f
    if _struct_2f is None:
        _struct_2f = struct.Struct("<2f")
    return _struct_2f
_struct_3B2f = None
def _get_struct_3B2f():
    global _struct_3B2f
    if _struct_3B2f is None:
        _struct_3B2f = struct.Struct("<3B2f")
    return _struct_3B2f
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_QI = None
def _get_struct_QI():
    global _struct_QI
    if _struct_QI is None:
        _struct_QI = struct.Struct("<QI")
    return _struct_QI
_struct_i2B3f = None
def _get_struct_i2B3f():
    global _struct_i2B3f
    if _struct_i2B3f is None:
        _struct_i2B3f = struct.Struct("<i2B3f")
    return _struct_i2B3f
