# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_sensor_msgs/Ins.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class Ins(genpy.Message):
  _md5sum = "a2c4889e773cb00731a595238aa15dc7"
  _type = "ad_sensor_msgs/Ins"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp(last node pub time), and frame_id(sensor model)
std_msgs/Header header

# Frame actual timestamp ns (or closest actual time)
uint64 actual_time_ns

# Sensor quality
uint8 status
# Sensor quality enum
uint8 INVALID=0             # sensor offline
uint8 BAD=1                 # sensor online, but can not use
uint8 DOWNGRADE=2           # have issue, but can work
uint8 PERFECT=3             # running well, nothing happend
# For status debug
string status_info

# Longitude in degrees, ranging from -180 to 180
float64 longitude
# Latitude in degrees, ranging from -90 to 90
float64 latitude
# WGS-84 ellipsoid height in meters
float64 altitude

# Right-handed rotation from local level around y‑axis, in radius.
float64 roll
# Right-handed rotation from local level around x‑axis, in radius.
float64 pitch
# Left-handed rotation around z-axis clockwise from North, in radius.
float64 yaw

# Linear velocity of the IMU in the Vehicle reference frame
# x for Forward, y for Left, z for Up, in meters per second
geometry_msgs/Vector3 linear_velocity

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  # Pseudo-constants
  INVALID = 0
  BAD = 1
  DOWNGRADE = 2
  PERFECT = 3

  __slots__ = ['header','actual_time_ns','status','status_info','longitude','latitude','altitude','roll','pitch','yaw','linear_velocity']
  _slot_types = ['std_msgs/Header','uint64','uint8','string','float64','float64','float64','float64','float64','float64','geometry_msgs/Vector3']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,actual_time_ns,status,status_info,longitude,latitude,altitude,roll,pitch,yaw,linear_velocity

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Ins, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.actual_time_ns is None:
        self.actual_time_ns = 0
      if self.status is None:
        self.status = 0
      if self.status_info is None:
        self.status_info = ''
      if self.longitude is None:
        self.longitude = 0.
      if self.latitude is None:
        self.latitude = 0.
      if self.altitude is None:
        self.altitude = 0.
      if self.roll is None:
        self.roll = 0.
      if self.pitch is None:
        self.pitch = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.linear_velocity is None:
        self.linear_velocity = geometry_msgs.msg.Vector3()
    else:
      self.header = std_msgs.msg.Header()
      self.actual_time_ns = 0
      self.status = 0
      self.status_info = ''
      self.longitude = 0.
      self.latitude = 0.
      self.altitude = 0.
      self.roll = 0.
      self.pitch = 0.
      self.yaw = 0.
      self.linear_velocity = geometry_msgs.msg.Vector3()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_QB().pack(_x.actual_time_ns, _x.status))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9d().pack(_x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.linear_velocity is None:
        self.linear_velocity = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.actual_time_ns, _x.status,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z,) = _get_struct_9d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_QB().pack(_x.actual_time_ns, _x.status))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9d().pack(_x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.linear_velocity is None:
        self.linear_velocity = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.actual_time_ns, _x.status,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      _x = self
      start = end
      end += 72
      (_x.longitude, _x.latitude, _x.altitude, _x.roll, _x.pitch, _x.yaw, _x.linear_velocity.x, _x.linear_velocity.y, _x.linear_velocity.z,) = _get_struct_9d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
_struct_QB = None
def _get_struct_QB():
    global _struct_QB
    if _struct_QB is None:
        _struct_QB = struct.Struct("<QB")
    return _struct_QB
