# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_sensor_msgs/RadarConti.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_sensor_msgs.msg
import std_msgs.msg

class RadarConti(genpy.Message):
  _md5sum = "78220c022b63ded3839bbaf7676bccb3"
  _type = "ad_sensor_msgs/RadarConti"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp(last node pub time), and frame_id(sensor model)
std_msgs/Header header

# Frame actual timestamp ns (first can receive time)
uint64 actual_time_ns

# Sensor fault
uint8 bus_fault
# For status debug
string status_info

# Radar cluster or object array
# Make empty if sensor unsupported
RadarContiCluster[] cluster_list
RadarContiObject[] object_list

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_sensor_msgs/RadarContiCluster
# Basic CAN frame receive timestamp ns
uint64 recv_time_ns

# Radar cluster basic info
uint8 track_id
float32 distance_long           # point of the cluster (in meter)
float32 distance_lat
float32 velocity_long           # velocity of the cluster (in m/s)
float32 velocity_lat
float32 RCS                     # radar cross section (in dBm^2)
uint8 dynamic_prop_enum         # dynamic property of the cluster indicating

# Radar cluster quality info
bool quality_vaild
float32 distance_long_rms       # standard deviation (in meter)
float32 distance_lat_rms
float32 velocity_long_rms       # m/s
float32 velocity_lat_rms
float32 cluster_pdh0            # false alarm probability of cluster (in 0-1)
uint8 ambig_state_enum          # state of doppler (radial velocity) ambiguity solution
uint8 invalid_state_enum        # state of cluster validity state 

================================================================================
MSG: ad_sensor_msgs/RadarContiObject
# Basic CAN frame receive timestamp ns
uint64 recv_time_ns

# Radar object basic info
uint8 track_id
float32 distance_long           # center point of the object (in meter)
float32 distance_lat
float32 velocity_long           # velocity of the object (in m/s)
float32 velocity_lat
float32 RCS                     # radar cross section (in dBm^2)
uint8 dynamic_prop_enum         # dynamic property of the object indicating

# Radar object quality info
bool quality_vaild
float32 distance_long_rms       # standard deviation (in meter)
float32 distance_lat_rms
float32 velocity_long_rms       # m/s
float32 velocity_lat_rms
float32 accel_long_rms          # m/s^2
float32 accel_lat_rms
float32 orientation_rms         # radius
float32 prob_of_exist           # 0-1
uint8 measurement_state_enum

# Radar object extend info
bool extend_vaild
float32 accel_long              # acceleration of the object (in m/s^2)
float32 accel_lat
float32 orientation             # yaw of the object orientation angel (in radius)
float32 length
float32 width
uint8 object_type_enum
"""
  __slots__ = ['header','actual_time_ns','bus_fault','status_info','cluster_list','object_list']
  _slot_types = ['std_msgs/Header','uint64','uint8','string','ad_sensor_msgs/RadarContiCluster[]','ad_sensor_msgs/RadarContiObject[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,actual_time_ns,bus_fault,status_info,cluster_list,object_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarConti, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.actual_time_ns is None:
        self.actual_time_ns = 0
      if self.bus_fault is None:
        self.bus_fault = 0
      if self.status_info is None:
        self.status_info = ''
      if self.cluster_list is None:
        self.cluster_list = []
      if self.object_list is None:
        self.object_list = []
    else:
      self.header = std_msgs.msg.Header()
      self.actual_time_ns = 0
      self.bus_fault = 0
      self.status_info = ''
      self.cluster_list = []
      self.object_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_QB().pack(_x.actual_time_ns, _x.bus_fault))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.cluster_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.cluster_list:
        _x = val1
        buff.write(_get_struct_QB5f2B5f2B().pack(_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.cluster_pdh0, _x.ambig_state_enum, _x.invalid_state_enum))
      length = len(self.object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_list:
        _x = val1
        buff.write(_get_struct_QB5f2B8f2B5fB().pack(_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.cluster_list is None:
        self.cluster_list = None
      if self.object_list is None:
        self.object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.actual_time_ns, _x.bus_fault,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cluster_list = []
      for i in range(0, length):
        val1 = ad_sensor_msgs.msg.RadarContiCluster()
        _x = val1
        start = end
        end += 53
        (_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.cluster_pdh0, _x.ambig_state_enum, _x.invalid_state_enum,) = _get_struct_QB5f2B5f2B().unpack(str[start:end])
        val1.quality_vaild = bool(val1.quality_vaild)
        self.cluster_list.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_list = []
      for i in range(0, length):
        val1 = ad_sensor_msgs.msg.RadarContiObject()
        _x = val1
        start = end
        end += 86
        (_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum,) = _get_struct_QB5f2B8f2B5fB().unpack(str[start:end])
        val1.quality_vaild = bool(val1.quality_vaild)
        val1.extend_vaild = bool(val1.extend_vaild)
        self.object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_QB().pack(_x.actual_time_ns, _x.bus_fault))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.cluster_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.cluster_list:
        _x = val1
        buff.write(_get_struct_QB5f2B5f2B().pack(_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.cluster_pdh0, _x.ambig_state_enum, _x.invalid_state_enum))
      length = len(self.object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_list:
        _x = val1
        buff.write(_get_struct_QB5f2B8f2B5fB().pack(_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.cluster_list is None:
        self.cluster_list = None
      if self.object_list is None:
        self.object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.actual_time_ns, _x.bus_fault,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cluster_list = []
      for i in range(0, length):
        val1 = ad_sensor_msgs.msg.RadarContiCluster()
        _x = val1
        start = end
        end += 53
        (_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.cluster_pdh0, _x.ambig_state_enum, _x.invalid_state_enum,) = _get_struct_QB5f2B5f2B().unpack(str[start:end])
        val1.quality_vaild = bool(val1.quality_vaild)
        self.cluster_list.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_list = []
      for i in range(0, length):
        val1 = ad_sensor_msgs.msg.RadarContiObject()
        _x = val1
        start = end
        end += 86
        (_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum,) = _get_struct_QB5f2B8f2B5fB().unpack(str[start:end])
        val1.quality_vaild = bool(val1.quality_vaild)
        val1.extend_vaild = bool(val1.extend_vaild)
        self.object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_QB = None
def _get_struct_QB():
    global _struct_QB
    if _struct_QB is None:
        _struct_QB = struct.Struct("<QB")
    return _struct_QB
_struct_QB5f2B5f2B = None
def _get_struct_QB5f2B5f2B():
    global _struct_QB5f2B5f2B
    if _struct_QB5f2B5f2B is None:
        _struct_QB5f2B5f2B = struct.Struct("<QB5f2B5f2B")
    return _struct_QB5f2B5f2B
_struct_QB5f2B8f2B5fB = None
def _get_struct_QB5f2B8f2B5fB():
    global _struct_QB5f2B8f2B5fB
    if _struct_QB5f2B8f2B5fB is None:
        _struct_QB5f2B8f2B5fB = struct.Struct("<QB5f2B8f2B5fB")
    return _struct_QB5f2B8f2B5fB
