# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_sensor_msgs/RadarContiObject.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RadarContiObject(genpy.Message):
  _md5sum = "6989f01ecc78bb87ecda169c1ddc21f1"
  _type = "ad_sensor_msgs/RadarContiObject"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Basic CAN frame receive timestamp ns
uint64 recv_time_ns

# Radar object basic info
uint8 track_id
float32 distance_long           # center point of the object (in meter)
float32 distance_lat
float32 velocity_long           # velocity of the object (in m/s)
float32 velocity_lat
float32 RCS                     # radar cross section (in dBm^2)
uint8 dynamic_prop_enum         # dynamic property of the object indicating

# Radar object quality info
bool quality_vaild
float32 distance_long_rms       # standard deviation (in meter)
float32 distance_lat_rms
float32 velocity_long_rms       # m/s
float32 velocity_lat_rms
float32 accel_long_rms          # m/s^2
float32 accel_lat_rms
float32 orientation_rms         # radius
float32 prob_of_exist           # 0-1
uint8 measurement_state_enum

# Radar object extend info
bool extend_vaild
float32 accel_long              # acceleration of the object (in m/s^2)
float32 accel_lat
float32 orientation             # yaw of the object orientation angel (in radius)
float32 length
float32 width
uint8 object_type_enum
"""
  __slots__ = ['recv_time_ns','track_id','distance_long','distance_lat','velocity_long','velocity_lat','RCS','dynamic_prop_enum','quality_vaild','distance_long_rms','distance_lat_rms','velocity_long_rms','velocity_lat_rms','accel_long_rms','accel_lat_rms','orientation_rms','prob_of_exist','measurement_state_enum','extend_vaild','accel_long','accel_lat','orientation','length','width','object_type_enum']
  _slot_types = ['uint64','uint8','float32','float32','float32','float32','float32','uint8','bool','float32','float32','float32','float32','float32','float32','float32','float32','uint8','bool','float32','float32','float32','float32','float32','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       recv_time_ns,track_id,distance_long,distance_lat,velocity_long,velocity_lat,RCS,dynamic_prop_enum,quality_vaild,distance_long_rms,distance_lat_rms,velocity_long_rms,velocity_lat_rms,accel_long_rms,accel_lat_rms,orientation_rms,prob_of_exist,measurement_state_enum,extend_vaild,accel_long,accel_lat,orientation,length,width,object_type_enum

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarContiObject, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.recv_time_ns is None:
        self.recv_time_ns = 0
      if self.track_id is None:
        self.track_id = 0
      if self.distance_long is None:
        self.distance_long = 0.
      if self.distance_lat is None:
        self.distance_lat = 0.
      if self.velocity_long is None:
        self.velocity_long = 0.
      if self.velocity_lat is None:
        self.velocity_lat = 0.
      if self.RCS is None:
        self.RCS = 0.
      if self.dynamic_prop_enum is None:
        self.dynamic_prop_enum = 0
      if self.quality_vaild is None:
        self.quality_vaild = False
      if self.distance_long_rms is None:
        self.distance_long_rms = 0.
      if self.distance_lat_rms is None:
        self.distance_lat_rms = 0.
      if self.velocity_long_rms is None:
        self.velocity_long_rms = 0.
      if self.velocity_lat_rms is None:
        self.velocity_lat_rms = 0.
      if self.accel_long_rms is None:
        self.accel_long_rms = 0.
      if self.accel_lat_rms is None:
        self.accel_lat_rms = 0.
      if self.orientation_rms is None:
        self.orientation_rms = 0.
      if self.prob_of_exist is None:
        self.prob_of_exist = 0.
      if self.measurement_state_enum is None:
        self.measurement_state_enum = 0
      if self.extend_vaild is None:
        self.extend_vaild = False
      if self.accel_long is None:
        self.accel_long = 0.
      if self.accel_lat is None:
        self.accel_lat = 0.
      if self.orientation is None:
        self.orientation = 0.
      if self.length is None:
        self.length = 0.
      if self.width is None:
        self.width = 0.
      if self.object_type_enum is None:
        self.object_type_enum = 0
    else:
      self.recv_time_ns = 0
      self.track_id = 0
      self.distance_long = 0.
      self.distance_lat = 0.
      self.velocity_long = 0.
      self.velocity_lat = 0.
      self.RCS = 0.
      self.dynamic_prop_enum = 0
      self.quality_vaild = False
      self.distance_long_rms = 0.
      self.distance_lat_rms = 0.
      self.velocity_long_rms = 0.
      self.velocity_lat_rms = 0.
      self.accel_long_rms = 0.
      self.accel_lat_rms = 0.
      self.orientation_rms = 0.
      self.prob_of_exist = 0.
      self.measurement_state_enum = 0
      self.extend_vaild = False
      self.accel_long = 0.
      self.accel_lat = 0.
      self.orientation = 0.
      self.length = 0.
      self.width = 0.
      self.object_type_enum = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_QB5f2B8f2B5fB().pack(_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 86
      (_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum,) = _get_struct_QB5f2B8f2B5fB().unpack(str[start:end])
      self.quality_vaild = bool(self.quality_vaild)
      self.extend_vaild = bool(self.extend_vaild)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_QB5f2B8f2B5fB().pack(_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 86
      (_x.recv_time_ns, _x.track_id, _x.distance_long, _x.distance_lat, _x.velocity_long, _x.velocity_lat, _x.RCS, _x.dynamic_prop_enum, _x.quality_vaild, _x.distance_long_rms, _x.distance_lat_rms, _x.velocity_long_rms, _x.velocity_lat_rms, _x.accel_long_rms, _x.accel_lat_rms, _x.orientation_rms, _x.prob_of_exist, _x.measurement_state_enum, _x.extend_vaild, _x.accel_long, _x.accel_lat, _x.orientation, _x.length, _x.width, _x.object_type_enum,) = _get_struct_QB5f2B8f2B5fB().unpack(str[start:end])
      self.quality_vaild = bool(self.quality_vaild)
      self.extend_vaild = bool(self.extend_vaild)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_QB5f2B8f2B5fB = None
def _get_struct_QB5f2B8f2B5fB():
    global _struct_QB5f2B8f2B5fB
    if _struct_QB5f2B8f2B5fB is None:
        _struct_QB5f2B8f2B5fB = struct.Struct("<QB5f2B8f2B5fB")
    return _struct_QB5f2B8f2B5fB
