# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_sensor_msgs/RadarEsr.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_sensor_msgs.msg
import std_msgs.msg

class RadarEsr(genpy.Message):
  _md5sum = "4a8b144849615d93c891bc0410b54271"
  _type = "ad_sensor_msgs/RadarEsr"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp(last node pub time), and frame_id(sensor model)
std_msgs/Header header

# Frame actual timestamp ns (first can receive time)
uint64 actual_time_ns

# Sensor fault
uint8 bus_fault
# For status debug
string status_info

# Radar object array
RadarEsrObject[] object_list

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_sensor_msgs/RadarEsrObject
# CAN frame receive timestamp ns
uint64 recv_time_ns

# CAN frame lost flag
bool object_vaild

# ESR Track Msg
uint8 track_id
float32 track_lat_rate
bool track_group_changed
uint8 track_status
float32 track_angle
float32 track_range
bool track_bridge_object
bool track_rolling_count
float32 track_width
float32 track_range_accel
uint8 track_med_range_mode
float32 track_range_rate

# ESR Track Power
bool movable_fast
bool movable_slow
bool moving
int8 power
"""
  __slots__ = ['header','actual_time_ns','bus_fault','status_info','object_list']
  _slot_types = ['std_msgs/Header','uint64','uint8','string','ad_sensor_msgs/RadarEsrObject[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,actual_time_ns,bus_fault,status_info,object_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarEsr, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.actual_time_ns is None:
        self.actual_time_ns = 0
      if self.bus_fault is None:
        self.bus_fault = 0
      if self.status_info is None:
        self.status_info = ''
      if self.object_list is None:
        self.object_list = []
    else:
      self.header = std_msgs.msg.Header()
      self.actual_time_ns = 0
      self.bus_fault = 0
      self.status_info = ''
      self.object_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_QB().pack(_x.actual_time_ns, _x.bus_fault))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_list:
        _x = val1
        buff.write(_get_struct_Q2Bf2B2f2B2fBf3Bb().pack(_x.recv_time_ns, _x.object_vaild, _x.track_id, _x.track_lat_rate, _x.track_group_changed, _x.track_status, _x.track_angle, _x.track_range, _x.track_bridge_object, _x.track_rolling_count, _x.track_width, _x.track_range_accel, _x.track_med_range_mode, _x.track_range_rate, _x.movable_fast, _x.movable_slow, _x.moving, _x.power))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.object_list is None:
        self.object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.actual_time_ns, _x.bus_fault,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_list = []
      for i in range(0, length):
        val1 = ad_sensor_msgs.msg.RadarEsrObject()
        _x = val1
        start = end
        end += 43
        (_x.recv_time_ns, _x.object_vaild, _x.track_id, _x.track_lat_rate, _x.track_group_changed, _x.track_status, _x.track_angle, _x.track_range, _x.track_bridge_object, _x.track_rolling_count, _x.track_width, _x.track_range_accel, _x.track_med_range_mode, _x.track_range_rate, _x.movable_fast, _x.movable_slow, _x.moving, _x.power,) = _get_struct_Q2Bf2B2f2B2fBf3Bb().unpack(str[start:end])
        val1.object_vaild = bool(val1.object_vaild)
        val1.track_group_changed = bool(val1.track_group_changed)
        val1.track_bridge_object = bool(val1.track_bridge_object)
        val1.track_rolling_count = bool(val1.track_rolling_count)
        val1.movable_fast = bool(val1.movable_fast)
        val1.movable_slow = bool(val1.movable_slow)
        val1.moving = bool(val1.moving)
        self.object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_QB().pack(_x.actual_time_ns, _x.bus_fault))
      _x = self.status_info
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.object_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_list:
        _x = val1
        buff.write(_get_struct_Q2Bf2B2f2B2fBf3Bb().pack(_x.recv_time_ns, _x.object_vaild, _x.track_id, _x.track_lat_rate, _x.track_group_changed, _x.track_status, _x.track_angle, _x.track_range, _x.track_bridge_object, _x.track_rolling_count, _x.track_width, _x.track_range_accel, _x.track_med_range_mode, _x.track_range_rate, _x.movable_fast, _x.movable_slow, _x.moving, _x.power))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.object_list is None:
        self.object_list = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.actual_time_ns, _x.bus_fault,) = _get_struct_QB().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.status_info = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.status_info = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_list = []
      for i in range(0, length):
        val1 = ad_sensor_msgs.msg.RadarEsrObject()
        _x = val1
        start = end
        end += 43
        (_x.recv_time_ns, _x.object_vaild, _x.track_id, _x.track_lat_rate, _x.track_group_changed, _x.track_status, _x.track_angle, _x.track_range, _x.track_bridge_object, _x.track_rolling_count, _x.track_width, _x.track_range_accel, _x.track_med_range_mode, _x.track_range_rate, _x.movable_fast, _x.movable_slow, _x.moving, _x.power,) = _get_struct_Q2Bf2B2f2B2fBf3Bb().unpack(str[start:end])
        val1.object_vaild = bool(val1.object_vaild)
        val1.track_group_changed = bool(val1.track_group_changed)
        val1.track_bridge_object = bool(val1.track_bridge_object)
        val1.track_rolling_count = bool(val1.track_rolling_count)
        val1.movable_fast = bool(val1.movable_fast)
        val1.movable_slow = bool(val1.movable_slow)
        val1.moving = bool(val1.moving)
        self.object_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_Q2Bf2B2f2B2fBf3Bb = None
def _get_struct_Q2Bf2B2f2B2fBf3Bb():
    global _struct_Q2Bf2B2f2B2fBf3Bb
    if _struct_Q2Bf2B2f2B2fBf3Bb is None:
        _struct_Q2Bf2B2f2B2fBf3Bb = struct.Struct("<Q2Bf2B2f2B2fBf3Bb")
    return _struct_Q2Bf2B2f2B2fBf3Bb
_struct_QB = None
def _get_struct_QB():
    global _struct_QB
    if _struct_QB is None:
        _struct_QB = struct.Struct("<QB")
    return _struct_QB
