# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_simulator_msgs/SUMOVehicleStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class SUMOVehicleStatus(genpy.Message):
  _md5sum = "58a91b66299058a75b6aefb3e1bf7c4c"
  _type = "ad_simulator_msgs/SUMOVehicleStatus"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Message to send information about Vehicles in the scene

# id : The idenfification of the vehicle
# pos_x : Vehicle x position
# pos_y : Vehicle y position
# heading : Vehicle heading (Yaw angle)
# velocity : Linear velocity of the vehicle
# max_vel : Maximum velocity

std_msgs/Header header

string  vehicle_id
float32 pos_x
float32 pos_y
float32 heading
float32 velocity
float32 max_vel
int16 lane
int16 signals
float32 height
float32 width
float32 length

float32[] prediction_x
float32[] prediction_y

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','vehicle_id','pos_x','pos_y','heading','velocity','max_vel','lane','signals','height','width','length','prediction_x','prediction_y']
  _slot_types = ['std_msgs/Header','string','float32','float32','float32','float32','float32','int16','int16','float32','float32','float32','float32[]','float32[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,vehicle_id,pos_x,pos_y,heading,velocity,max_vel,lane,signals,height,width,length,prediction_x,prediction_y

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SUMOVehicleStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.vehicle_id is None:
        self.vehicle_id = ''
      if self.pos_x is None:
        self.pos_x = 0.
      if self.pos_y is None:
        self.pos_y = 0.
      if self.heading is None:
        self.heading = 0.
      if self.velocity is None:
        self.velocity = 0.
      if self.max_vel is None:
        self.max_vel = 0.
      if self.lane is None:
        self.lane = 0
      if self.signals is None:
        self.signals = 0
      if self.height is None:
        self.height = 0.
      if self.width is None:
        self.width = 0.
      if self.length is None:
        self.length = 0.
      if self.prediction_x is None:
        self.prediction_x = []
      if self.prediction_y is None:
        self.prediction_y = []
    else:
      self.header = std_msgs.msg.Header()
      self.vehicle_id = ''
      self.pos_x = 0.
      self.pos_y = 0.
      self.heading = 0.
      self.velocity = 0.
      self.max_vel = 0.
      self.lane = 0
      self.signals = 0
      self.height = 0.
      self.width = 0.
      self.length = 0.
      self.prediction_x = []
      self.prediction_y = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vehicle_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5f2h3f().pack(_x.pos_x, _x.pos_y, _x.heading, _x.velocity, _x.max_vel, _x.lane, _x.signals, _x.height, _x.width, _x.length))
      length = len(self.prediction_x)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.prediction_x))
      length = len(self.prediction_y)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.prediction_y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.vehicle_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.vehicle_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.pos_x, _x.pos_y, _x.heading, _x.velocity, _x.max_vel, _x.lane, _x.signals, _x.height, _x.width, _x.length,) = _get_struct_5f2h3f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.prediction_x = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.prediction_y = s.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vehicle_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5f2h3f().pack(_x.pos_x, _x.pos_y, _x.heading, _x.velocity, _x.max_vel, _x.lane, _x.signals, _x.height, _x.width, _x.length))
      length = len(self.prediction_x)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.prediction_x.tostring())
      length = len(self.prediction_y)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.prediction_y.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.vehicle_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.vehicle_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.pos_x, _x.pos_y, _x.heading, _x.velocity, _x.max_vel, _x.lane, _x.signals, _x.height, _x.width, _x.length,) = _get_struct_5f2h3f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.prediction_x = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.prediction_y = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_5f2h3f = None
def _get_struct_5f2h3f():
    global _struct_5f2h3f
    if _struct_5f2h3f is None:
        _struct_5f2h3f = struct.Struct("<5f2h3f")
    return _struct_5f2h3f
