# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_vehicle_msgs/BrakeCmd.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class BrakeCmd(genpy.Message):
  _md5sum = "764a829e07999ae5afb084e5a3f27fed"
  _type = "ad_vehicle_msgs/BrakeCmd"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Brake command
float32 command
uint8 command_type

# Command types
uint8 CMD_NONE=0
uint8 CMD_PEDAL=1     # Unitless, mapping to pedal raw
uint8 CMD_PERCENT=2   # Percent of maximum torque, range 0 to 1
uint8 CMD_TORQUE=3    # Nm
uint8 CMD_DECEL=4     # m/s^2

# Parking Brake (0:release 1:lock)
uint8 parking_brake
"""
  # Pseudo-constants
  CMD_NONE = 0
  CMD_PEDAL = 1
  CMD_PERCENT = 2
  CMD_TORQUE = 3
  CMD_DECEL = 4

  __slots__ = ['command','command_type','parking_brake']
  _slot_types = ['float32','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       command,command_type,parking_brake

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BrakeCmd, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = 0.
      if self.command_type is None:
        self.command_type = 0
      if self.parking_brake is None:
        self.parking_brake = 0
    else:
      self.command = 0.
      self.command_type = 0
      self.parking_brake = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_f2B().pack(_x.command, _x.command_type, _x.parking_brake))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 6
      (_x.command, _x.command_type, _x.parking_brake,) = _get_struct_f2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_f2B().pack(_x.command, _x.command_type, _x.parking_brake))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 6
      (_x.command, _x.command_type, _x.parking_brake,) = _get_struct_f2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_f2B = None
def _get_struct_f2B():
    global _struct_f2B
    if _struct_f2B is None:
        _struct_f2B = struct.Struct("<f2B")
    return _struct_f2B
