# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_vehicle_msgs/BrakeReport.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class BrakeReport(genpy.Message):
  _md5sum = "5c3bf6e5cf56c8cdfeed6ee72a9f040d"
  _type = "ad_vehicle_msgs/BrakeReport"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Brake pedal raw
float32 pedal_input
float32 pedal_command
float32 pedal_actual

# Brake percent (0-1)
float32 percent_command
float32 percent_actual

# Brake torque (Nm)
float32 torque_input
float32 torque_command
float32 torque_actual

# Brake decel (m/s^2)
float32 decel_command
float32 decel_actual

# Wheel torques from sensor (Nm)
float32 sensor_brake_torque
float32 sensor_wheel_torque

# Parking Brake (0:release 1:lock)
bool parking_brake_actual

# Status
bool bus_fault
"""
  __slots__ = ['pedal_input','pedal_command','pedal_actual','percent_command','percent_actual','torque_input','torque_command','torque_actual','decel_command','decel_actual','sensor_brake_torque','sensor_wheel_torque','parking_brake_actual','bus_fault']
  _slot_types = ['float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pedal_input,pedal_command,pedal_actual,percent_command,percent_actual,torque_input,torque_command,torque_actual,decel_command,decel_actual,sensor_brake_torque,sensor_wheel_torque,parking_brake_actual,bus_fault

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BrakeReport, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pedal_input is None:
        self.pedal_input = 0.
      if self.pedal_command is None:
        self.pedal_command = 0.
      if self.pedal_actual is None:
        self.pedal_actual = 0.
      if self.percent_command is None:
        self.percent_command = 0.
      if self.percent_actual is None:
        self.percent_actual = 0.
      if self.torque_input is None:
        self.torque_input = 0.
      if self.torque_command is None:
        self.torque_command = 0.
      if self.torque_actual is None:
        self.torque_actual = 0.
      if self.decel_command is None:
        self.decel_command = 0.
      if self.decel_actual is None:
        self.decel_actual = 0.
      if self.sensor_brake_torque is None:
        self.sensor_brake_torque = 0.
      if self.sensor_wheel_torque is None:
        self.sensor_wheel_torque = 0.
      if self.parking_brake_actual is None:
        self.parking_brake_actual = False
      if self.bus_fault is None:
        self.bus_fault = False
    else:
      self.pedal_input = 0.
      self.pedal_command = 0.
      self.pedal_actual = 0.
      self.percent_command = 0.
      self.percent_actual = 0.
      self.torque_input = 0.
      self.torque_command = 0.
      self.torque_actual = 0.
      self.decel_command = 0.
      self.decel_actual = 0.
      self.sensor_brake_torque = 0.
      self.sensor_wheel_torque = 0.
      self.parking_brake_actual = False
      self.bus_fault = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_12f2B().pack(_x.pedal_input, _x.pedal_command, _x.pedal_actual, _x.percent_command, _x.percent_actual, _x.torque_input, _x.torque_command, _x.torque_actual, _x.decel_command, _x.decel_actual, _x.sensor_brake_torque, _x.sensor_wheel_torque, _x.parking_brake_actual, _x.bus_fault))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 50
      (_x.pedal_input, _x.pedal_command, _x.pedal_actual, _x.percent_command, _x.percent_actual, _x.torque_input, _x.torque_command, _x.torque_actual, _x.decel_command, _x.decel_actual, _x.sensor_brake_torque, _x.sensor_wheel_torque, _x.parking_brake_actual, _x.bus_fault,) = _get_struct_12f2B().unpack(str[start:end])
      self.parking_brake_actual = bool(self.parking_brake_actual)
      self.bus_fault = bool(self.bus_fault)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_12f2B().pack(_x.pedal_input, _x.pedal_command, _x.pedal_actual, _x.percent_command, _x.percent_actual, _x.torque_input, _x.torque_command, _x.torque_actual, _x.decel_command, _x.decel_actual, _x.sensor_brake_torque, _x.sensor_wheel_torque, _x.parking_brake_actual, _x.bus_fault))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 50
      (_x.pedal_input, _x.pedal_command, _x.pedal_actual, _x.percent_command, _x.percent_actual, _x.torque_input, _x.torque_command, _x.torque_actual, _x.decel_command, _x.decel_actual, _x.sensor_brake_torque, _x.sensor_wheel_torque, _x.parking_brake_actual, _x.bus_fault,) = _get_struct_12f2B().unpack(str[start:end])
      self.parking_brake_actual = bool(self.parking_brake_actual)
      self.bus_fault = bool(self.bus_fault)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12f2B = None
def _get_struct_12f2B():
    global _struct_12f2B
    if _struct_12f2B is None:
        _struct_12f2B = struct.Struct("<12f2B")
    return _struct_12f2B
