# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_vehicle_msgs/Chassis.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Chassis(genpy.Message):
  _md5sum = "1aea8f085abaf20276db62daad7c2f8f"
  _type = "ad_vehicle_msgs/Chassis"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Vehicle Speed (m/s)
float32 vehicle_mps

# Wheel Speed (m/s)
float32 wheel_speed_fl
float32 wheel_speed_fr
float32 wheel_speed_rl
float32 wheel_speed_rr

# Encoder (Wheel Pulse)
int32 wheel_pulse_fl
int32 wheel_pulse_fr
int32 wheel_pulse_rl
int32 wheel_pulse_rr

# Real tire pressure (kPa)
float32 tire_pressure_fl
float32 tire_pressure_fr
float32 tire_pressure_rl
float32 tire_pressure_rr

# Real suspension height (mm)
float32 suspension_fl
float32 suspension_fr
float32 suspension_rl
float32 suspension_rr

# Real fuel level in percentage (0-100)
float32 fuel_level
"""
  __slots__ = ['vehicle_mps','wheel_speed_fl','wheel_speed_fr','wheel_speed_rl','wheel_speed_rr','wheel_pulse_fl','wheel_pulse_fr','wheel_pulse_rl','wheel_pulse_rr','tire_pressure_fl','tire_pressure_fr','tire_pressure_rl','tire_pressure_rr','suspension_fl','suspension_fr','suspension_rl','suspension_rr','fuel_level']
  _slot_types = ['float32','float32','float32','float32','float32','int32','int32','int32','int32','float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       vehicle_mps,wheel_speed_fl,wheel_speed_fr,wheel_speed_rl,wheel_speed_rr,wheel_pulse_fl,wheel_pulse_fr,wheel_pulse_rl,wheel_pulse_rr,tire_pressure_fl,tire_pressure_fr,tire_pressure_rl,tire_pressure_rr,suspension_fl,suspension_fr,suspension_rl,suspension_rr,fuel_level

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Chassis, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.vehicle_mps is None:
        self.vehicle_mps = 0.
      if self.wheel_speed_fl is None:
        self.wheel_speed_fl = 0.
      if self.wheel_speed_fr is None:
        self.wheel_speed_fr = 0.
      if self.wheel_speed_rl is None:
        self.wheel_speed_rl = 0.
      if self.wheel_speed_rr is None:
        self.wheel_speed_rr = 0.
      if self.wheel_pulse_fl is None:
        self.wheel_pulse_fl = 0
      if self.wheel_pulse_fr is None:
        self.wheel_pulse_fr = 0
      if self.wheel_pulse_rl is None:
        self.wheel_pulse_rl = 0
      if self.wheel_pulse_rr is None:
        self.wheel_pulse_rr = 0
      if self.tire_pressure_fl is None:
        self.tire_pressure_fl = 0.
      if self.tire_pressure_fr is None:
        self.tire_pressure_fr = 0.
      if self.tire_pressure_rl is None:
        self.tire_pressure_rl = 0.
      if self.tire_pressure_rr is None:
        self.tire_pressure_rr = 0.
      if self.suspension_fl is None:
        self.suspension_fl = 0.
      if self.suspension_fr is None:
        self.suspension_fr = 0.
      if self.suspension_rl is None:
        self.suspension_rl = 0.
      if self.suspension_rr is None:
        self.suspension_rr = 0.
      if self.fuel_level is None:
        self.fuel_level = 0.
    else:
      self.vehicle_mps = 0.
      self.wheel_speed_fl = 0.
      self.wheel_speed_fr = 0.
      self.wheel_speed_rl = 0.
      self.wheel_speed_rr = 0.
      self.wheel_pulse_fl = 0
      self.wheel_pulse_fr = 0
      self.wheel_pulse_rl = 0
      self.wheel_pulse_rr = 0
      self.tire_pressure_fl = 0.
      self.tire_pressure_fr = 0.
      self.tire_pressure_rl = 0.
      self.tire_pressure_rr = 0.
      self.suspension_fl = 0.
      self.suspension_fr = 0.
      self.suspension_rl = 0.
      self.suspension_rr = 0.
      self.fuel_level = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_5f4i9f().pack(_x.vehicle_mps, _x.wheel_speed_fl, _x.wheel_speed_fr, _x.wheel_speed_rl, _x.wheel_speed_rr, _x.wheel_pulse_fl, _x.wheel_pulse_fr, _x.wheel_pulse_rl, _x.wheel_pulse_rr, _x.tire_pressure_fl, _x.tire_pressure_fr, _x.tire_pressure_rl, _x.tire_pressure_rr, _x.suspension_fl, _x.suspension_fr, _x.suspension_rl, _x.suspension_rr, _x.fuel_level))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 72
      (_x.vehicle_mps, _x.wheel_speed_fl, _x.wheel_speed_fr, _x.wheel_speed_rl, _x.wheel_speed_rr, _x.wheel_pulse_fl, _x.wheel_pulse_fr, _x.wheel_pulse_rl, _x.wheel_pulse_rr, _x.tire_pressure_fl, _x.tire_pressure_fr, _x.tire_pressure_rl, _x.tire_pressure_rr, _x.suspension_fl, _x.suspension_fr, _x.suspension_rl, _x.suspension_rr, _x.fuel_level,) = _get_struct_5f4i9f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_5f4i9f().pack(_x.vehicle_mps, _x.wheel_speed_fl, _x.wheel_speed_fr, _x.wheel_speed_rl, _x.wheel_speed_rr, _x.wheel_pulse_fl, _x.wheel_pulse_fr, _x.wheel_pulse_rl, _x.wheel_pulse_rr, _x.tire_pressure_fl, _x.tire_pressure_fr, _x.tire_pressure_rl, _x.tire_pressure_rr, _x.suspension_fl, _x.suspension_fr, _x.suspension_rl, _x.suspension_rr, _x.fuel_level))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 72
      (_x.vehicle_mps, _x.wheel_speed_fl, _x.wheel_speed_fr, _x.wheel_speed_rl, _x.wheel_speed_rr, _x.wheel_pulse_fl, _x.wheel_pulse_fr, _x.wheel_pulse_rl, _x.wheel_pulse_rr, _x.tire_pressure_fl, _x.tire_pressure_fr, _x.tire_pressure_rl, _x.tire_pressure_rr, _x.suspension_fl, _x.suspension_fr, _x.suspension_rl, _x.suspension_rr, _x.fuel_level,) = _get_struct_5f4i9f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_5f4i9f = None
def _get_struct_5f4i9f():
    global _struct_5f4i9f
    if _struct_5f4i9f is None:
        _struct_5f4i9f = struct.Struct("<5f4i9f")
    return _struct_5f4i9f
