# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_vehicle_msgs/VehicleCmd.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_vehicle_msgs.msg
import std_msgs.msg

class VehicleCmd(genpy.Message):
  _md5sum = "79b9b0a55b9064d7164c5085af0eb3fb"
  _type = "ad_vehicle_msgs/VehicleCmd"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp(last node pub time), and frame_id(ignored)
std_msgs/Header header

# Autodrive mode command
ModeCmd mode
# if 'VehicleReport.enable' report disable, canbus will ignore below

# Drive-by-wire units
ThrottleCmd throttle
BrakeCmd brake
SteeringCmd steering
GearCmd gear

# Assist devices
Beam beam

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_vehicle_msgs/ModeCmd
# Master switch, enable all vehicle domain
bool enable

================================================================================
MSG: ad_vehicle_msgs/ThrottleCmd
# Throttle command
float32 command
uint8 command_type

# Command types
uint8 CMD_NONE=0
uint8 CMD_PEDAL=1     # Unitless, mapping to pedal raw
uint8 CMD_PERCENT=2   # Percent of maximum throttle, range 0 to 1

================================================================================
MSG: ad_vehicle_msgs/BrakeCmd
# Brake command
float32 command
uint8 command_type

# Command types
uint8 CMD_NONE=0
uint8 CMD_PEDAL=1     # Unitless, mapping to pedal raw
uint8 CMD_PERCENT=2   # Percent of maximum torque, range 0 to 1
uint8 CMD_TORQUE=3    # Nm
uint8 CMD_DECEL=4     # m/s^2

# Parking Brake (0:release 1:lock)
uint8 parking_brake

================================================================================
MSG: ad_vehicle_msgs/SteeringCmd
# Steering commands
float32 command
uint8 command_type

float32 velocity    # deg/s

# Command types
uint8 CMD_NONE=0
uint8 CMD_ANGLE=1   # clockwise means negative
uint8 CMD_TORQUE=2

================================================================================
MSG: ad_vehicle_msgs/GearCmd
# Gear mode
uint8 command

# Gear enum
uint8 GEAR_NONE=0
uint8 GEAR_PARK=1
uint8 GEAR_REVERSE=2
uint8 GEAR_NEUTRAL=3
uint8 GEAR_DRIVE=4
uint8 GEAR_LOW=5

================================================================================
MSG: ad_vehicle_msgs/Beam
# Brake
bool stop_lamp

# Turn signal
bool turn_left_lamp
bool turn_right_lamp

# Misc
bool[8] reserved_lamp
"""
  __slots__ = ['header','mode','throttle','brake','steering','gear','beam']
  _slot_types = ['std_msgs/Header','ad_vehicle_msgs/ModeCmd','ad_vehicle_msgs/ThrottleCmd','ad_vehicle_msgs/BrakeCmd','ad_vehicle_msgs/SteeringCmd','ad_vehicle_msgs/GearCmd','ad_vehicle_msgs/Beam']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,mode,throttle,brake,steering,gear,beam

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleCmd, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mode is None:
        self.mode = ad_vehicle_msgs.msg.ModeCmd()
      if self.throttle is None:
        self.throttle = ad_vehicle_msgs.msg.ThrottleCmd()
      if self.brake is None:
        self.brake = ad_vehicle_msgs.msg.BrakeCmd()
      if self.steering is None:
        self.steering = ad_vehicle_msgs.msg.SteeringCmd()
      if self.gear is None:
        self.gear = ad_vehicle_msgs.msg.GearCmd()
      if self.beam is None:
        self.beam = ad_vehicle_msgs.msg.Beam()
    else:
      self.header = std_msgs.msg.Header()
      self.mode = ad_vehicle_msgs.msg.ModeCmd()
      self.throttle = ad_vehicle_msgs.msg.ThrottleCmd()
      self.brake = ad_vehicle_msgs.msg.BrakeCmd()
      self.steering = ad_vehicle_msgs.msg.SteeringCmd()
      self.gear = ad_vehicle_msgs.msg.GearCmd()
      self.beam = ad_vehicle_msgs.msg.Beam()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BfBf2BfBf4B().pack(_x.mode.enable, _x.throttle.command, _x.throttle.command_type, _x.brake.command, _x.brake.command_type, _x.brake.parking_brake, _x.steering.command, _x.steering.command_type, _x.steering.velocity, _x.gear.command, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp))
      buff.write(_get_struct_8B().pack(*self.beam.reserved_lamp))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mode is None:
        self.mode = ad_vehicle_msgs.msg.ModeCmd()
      if self.throttle is None:
        self.throttle = ad_vehicle_msgs.msg.ThrottleCmd()
      if self.brake is None:
        self.brake = ad_vehicle_msgs.msg.BrakeCmd()
      if self.steering is None:
        self.steering = ad_vehicle_msgs.msg.SteeringCmd()
      if self.gear is None:
        self.gear = ad_vehicle_msgs.msg.GearCmd()
      if self.beam is None:
        self.beam = ad_vehicle_msgs.msg.Beam()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 25
      (_x.mode.enable, _x.throttle.command, _x.throttle.command_type, _x.brake.command, _x.brake.command_type, _x.brake.parking_brake, _x.steering.command, _x.steering.command_type, _x.steering.velocity, _x.gear.command, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp,) = _get_struct_BfBf2BfBf4B().unpack(str[start:end])
      self.mode.enable = bool(self.mode.enable)
      self.beam.stop_lamp = bool(self.beam.stop_lamp)
      self.beam.turn_left_lamp = bool(self.beam.turn_left_lamp)
      self.beam.turn_right_lamp = bool(self.beam.turn_right_lamp)
      start = end
      end += 8
      self.beam.reserved_lamp = _get_struct_8B().unpack(str[start:end])
      self.beam.reserved_lamp = list(map(bool, self.beam.reserved_lamp))
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BfBf2BfBf4B().pack(_x.mode.enable, _x.throttle.command, _x.throttle.command_type, _x.brake.command, _x.brake.command_type, _x.brake.parking_brake, _x.steering.command, _x.steering.command_type, _x.steering.velocity, _x.gear.command, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp))
      buff.write(self.beam.reserved_lamp.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mode is None:
        self.mode = ad_vehicle_msgs.msg.ModeCmd()
      if self.throttle is None:
        self.throttle = ad_vehicle_msgs.msg.ThrottleCmd()
      if self.brake is None:
        self.brake = ad_vehicle_msgs.msg.BrakeCmd()
      if self.steering is None:
        self.steering = ad_vehicle_msgs.msg.SteeringCmd()
      if self.gear is None:
        self.gear = ad_vehicle_msgs.msg.GearCmd()
      if self.beam is None:
        self.beam = ad_vehicle_msgs.msg.Beam()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 25
      (_x.mode.enable, _x.throttle.command, _x.throttle.command_type, _x.brake.command, _x.brake.command_type, _x.brake.parking_brake, _x.steering.command, _x.steering.command_type, _x.steering.velocity, _x.gear.command, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp,) = _get_struct_BfBf2BfBf4B().unpack(str[start:end])
      self.mode.enable = bool(self.mode.enable)
      self.beam.stop_lamp = bool(self.beam.stop_lamp)
      self.beam.turn_left_lamp = bool(self.beam.turn_left_lamp)
      self.beam.turn_right_lamp = bool(self.beam.turn_right_lamp)
      start = end
      end += 8
      self.beam.reserved_lamp = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=8)
      self.beam.reserved_lamp = list(map(bool, self.beam.reserved_lamp))
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_8B = None
def _get_struct_8B():
    global _struct_8B
    if _struct_8B is None:
        _struct_8B = struct.Struct("<8B")
    return _struct_8B
_struct_BfBf2BfBf4B = None
def _get_struct_BfBf2BfBf4B():
    global _struct_BfBf2BfBf4B
    if _struct_BfBf2BfBf4B is None:
        _struct_BfBf2BfBf4B = struct.Struct("<BfBf2BfBf4B")
    return _struct_BfBf2BfBf4B
