# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ad_vehicle_msgs/VehicleReport.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ad_vehicle_msgs.msg
import std_msgs.msg

class VehicleReport(genpy.Message):
  _md5sum = "4bb9454b337d432ad1aa28e76f07624b"
  _type = "ad_vehicle_msgs/VehicleReport"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Header include seq, timestamp, and frame_id(vehicle_type)
std_msgs/Header header

# Autodrive mode report
ModeReport mode

# Drive-by-wire units report
ThrottleReport throttle
BrakeReport brake
SteeringReport steering
GearReport gear

# Assist devices report
Chassis chassis
Beam beam
Imu imu
Navi navi
Sonar sonar
Misc misc

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ad_vehicle_msgs/ModeReport
# Exit automode will set to false, such as driver override, system fault, etc.
bool enable

# Domain status
bool throttle_enable
bool brake_enable
bool steering_enable
bool gear_enable

================================================================================
MSG: ad_vehicle_msgs/ThrottleReport
# Throttle pedal raw
float32 pedal_input
float32 pedal_command
float32 pedal_actual

# Throttle percent (0-1)
float32 percent_command
float32 percent_actual

# Engine (rpm)
float32 engine_rpm

# Status
bool bus_fault

================================================================================
MSG: ad_vehicle_msgs/BrakeReport
# Brake pedal raw
float32 pedal_input
float32 pedal_command
float32 pedal_actual

# Brake percent (0-1)
float32 percent_command
float32 percent_actual

# Brake torque (Nm)
float32 torque_input
float32 torque_command
float32 torque_actual

# Brake decel (m/s^2)
float32 decel_command
float32 decel_actual

# Wheel torques from sensor (Nm)
float32 sensor_brake_torque
float32 sensor_wheel_torque

# Parking Brake (0:release 1:lock)
bool parking_brake_actual

# Status
bool bus_fault

================================================================================
MSG: ad_vehicle_msgs/SteeringReport
# Steering angle (deg)
float32 angle_command
float32 angle_actual

# Steering torque (Nm)
float32 torque_command
float32 torque_actual

# Status
bool bus_fault

================================================================================
MSG: ad_vehicle_msgs/GearReport
# Gear mode
uint8 command
uint8 actual

# Gear enum
uint8 GEAR_NONE=0
uint8 GEAR_PARK=1
uint8 GEAR_REVERSE=2
uint8 GEAR_NEUTRAL=3
uint8 GEAR_DRIVE=4
uint8 GEAR_LOW=5

# Status
bool bus_fault

================================================================================
MSG: ad_vehicle_msgs/Chassis
# Vehicle Speed (m/s)
float32 vehicle_mps

# Wheel Speed (m/s)
float32 wheel_speed_fl
float32 wheel_speed_fr
float32 wheel_speed_rl
float32 wheel_speed_rr

# Encoder (Wheel Pulse)
int32 wheel_pulse_fl
int32 wheel_pulse_fr
int32 wheel_pulse_rl
int32 wheel_pulse_rr

# Real tire pressure (kPa)
float32 tire_pressure_fl
float32 tire_pressure_fr
float32 tire_pressure_rl
float32 tire_pressure_rr

# Real suspension height (mm)
float32 suspension_fl
float32 suspension_fr
float32 suspension_rl
float32 suspension_rr

# Real fuel level in percentage (0-100)
float32 fuel_level

================================================================================
MSG: ad_vehicle_msgs/Beam
# Brake
bool stop_lamp

# Turn signal
bool turn_left_lamp
bool turn_right_lamp

# Misc
bool[8] reserved_lamp

================================================================================
MSG: ad_vehicle_msgs/Imu
# Vheicle orginal 3-axis Accel (m/s^2)
float32 accel_x
float32 accel_y
float32 accel_z

# Vheicle orginal 3-axis Gyro (rad/s)
float32 gyro_x
float32 gyro_y
float32 gyro_z

================================================================================
MSG: ad_vehicle_msgs/Navi
# Vheicle orginal GPS WGS84
float64 latitude
float64 longitude
float64 altitude

# NMEA
string NMEA_GGA

================================================================================
MSG: ad_vehicle_msgs/Sonar
# Sonar (m)
float32[12] array

================================================================================
MSG: ad_vehicle_msgs/Misc
# Door
bool door_fl
bool door_fr
bool door_rl
bool door_rr
bool door_hood
bool door_trunk

# Button
bool btn_acc_onoff
bool btn_acc_cancel
bool btn_acc_resume
bool btn_acc_set
bool btn_acc_dis_pls
bool btn_acc_dis_mns

# Reserved
bool[8] reserved
"""
  __slots__ = ['header','mode','throttle','brake','steering','gear','chassis','beam','imu','navi','sonar','misc']
  _slot_types = ['std_msgs/Header','ad_vehicle_msgs/ModeReport','ad_vehicle_msgs/ThrottleReport','ad_vehicle_msgs/BrakeReport','ad_vehicle_msgs/SteeringReport','ad_vehicle_msgs/GearReport','ad_vehicle_msgs/Chassis','ad_vehicle_msgs/Beam','ad_vehicle_msgs/Imu','ad_vehicle_msgs/Navi','ad_vehicle_msgs/Sonar','ad_vehicle_msgs/Misc']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,mode,throttle,brake,steering,gear,chassis,beam,imu,navi,sonar,misc

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VehicleReport, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mode is None:
        self.mode = ad_vehicle_msgs.msg.ModeReport()
      if self.throttle is None:
        self.throttle = ad_vehicle_msgs.msg.ThrottleReport()
      if self.brake is None:
        self.brake = ad_vehicle_msgs.msg.BrakeReport()
      if self.steering is None:
        self.steering = ad_vehicle_msgs.msg.SteeringReport()
      if self.gear is None:
        self.gear = ad_vehicle_msgs.msg.GearReport()
      if self.chassis is None:
        self.chassis = ad_vehicle_msgs.msg.Chassis()
      if self.beam is None:
        self.beam = ad_vehicle_msgs.msg.Beam()
      if self.imu is None:
        self.imu = ad_vehicle_msgs.msg.Imu()
      if self.navi is None:
        self.navi = ad_vehicle_msgs.msg.Navi()
      if self.sonar is None:
        self.sonar = ad_vehicle_msgs.msg.Sonar()
      if self.misc is None:
        self.misc = ad_vehicle_msgs.msg.Misc()
    else:
      self.header = std_msgs.msg.Header()
      self.mode = ad_vehicle_msgs.msg.ModeReport()
      self.throttle = ad_vehicle_msgs.msg.ThrottleReport()
      self.brake = ad_vehicle_msgs.msg.BrakeReport()
      self.steering = ad_vehicle_msgs.msg.SteeringReport()
      self.gear = ad_vehicle_msgs.msg.GearReport()
      self.chassis = ad_vehicle_msgs.msg.Chassis()
      self.beam = ad_vehicle_msgs.msg.Beam()
      self.imu = ad_vehicle_msgs.msg.Imu()
      self.navi = ad_vehicle_msgs.msg.Navi()
      self.sonar = ad_vehicle_msgs.msg.Sonar()
      self.misc = ad_vehicle_msgs.msg.Misc()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5B6fB12f2B4f4B5f4i9f3B().pack(_x.mode.enable, _x.mode.throttle_enable, _x.mode.brake_enable, _x.mode.steering_enable, _x.mode.gear_enable, _x.throttle.pedal_input, _x.throttle.pedal_command, _x.throttle.pedal_actual, _x.throttle.percent_command, _x.throttle.percent_actual, _x.throttle.engine_rpm, _x.throttle.bus_fault, _x.brake.pedal_input, _x.brake.pedal_command, _x.brake.pedal_actual, _x.brake.percent_command, _x.brake.percent_actual, _x.brake.torque_input, _x.brake.torque_command, _x.brake.torque_actual, _x.brake.decel_command, _x.brake.decel_actual, _x.brake.sensor_brake_torque, _x.brake.sensor_wheel_torque, _x.brake.parking_brake_actual, _x.brake.bus_fault, _x.steering.angle_command, _x.steering.angle_actual, _x.steering.torque_command, _x.steering.torque_actual, _x.steering.bus_fault, _x.gear.command, _x.gear.actual, _x.gear.bus_fault, _x.chassis.vehicle_mps, _x.chassis.wheel_speed_fl, _x.chassis.wheel_speed_fr, _x.chassis.wheel_speed_rl, _x.chassis.wheel_speed_rr, _x.chassis.wheel_pulse_fl, _x.chassis.wheel_pulse_fr, _x.chassis.wheel_pulse_rl, _x.chassis.wheel_pulse_rr, _x.chassis.tire_pressure_fl, _x.chassis.tire_pressure_fr, _x.chassis.tire_pressure_rl, _x.chassis.tire_pressure_rr, _x.chassis.suspension_fl, _x.chassis.suspension_fr, _x.chassis.suspension_rl, _x.chassis.suspension_rr, _x.chassis.fuel_level, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp))
      buff.write(_get_struct_8B().pack(*self.beam.reserved_lamp))
      _x = self
      buff.write(_get_struct_6f3d().pack(_x.imu.accel_x, _x.imu.accel_y, _x.imu.accel_z, _x.imu.gyro_x, _x.imu.gyro_y, _x.imu.gyro_z, _x.navi.latitude, _x.navi.longitude, _x.navi.altitude))
      _x = self.navi.NMEA_GGA
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(_get_struct_12f().pack(*self.sonar.array))
      _x = self
      buff.write(_get_struct_12B().pack(_x.misc.door_fl, _x.misc.door_fr, _x.misc.door_rl, _x.misc.door_rr, _x.misc.door_hood, _x.misc.door_trunk, _x.misc.btn_acc_onoff, _x.misc.btn_acc_cancel, _x.misc.btn_acc_resume, _x.misc.btn_acc_set, _x.misc.btn_acc_dis_pls, _x.misc.btn_acc_dis_mns))
      buff.write(_get_struct_8B().pack(*self.misc.reserved))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mode is None:
        self.mode = ad_vehicle_msgs.msg.ModeReport()
      if self.throttle is None:
        self.throttle = ad_vehicle_msgs.msg.ThrottleReport()
      if self.brake is None:
        self.brake = ad_vehicle_msgs.msg.BrakeReport()
      if self.steering is None:
        self.steering = ad_vehicle_msgs.msg.SteeringReport()
      if self.gear is None:
        self.gear = ad_vehicle_msgs.msg.GearReport()
      if self.chassis is None:
        self.chassis = ad_vehicle_msgs.msg.Chassis()
      if self.beam is None:
        self.beam = ad_vehicle_msgs.msg.Beam()
      if self.imu is None:
        self.imu = ad_vehicle_msgs.msg.Imu()
      if self.navi is None:
        self.navi = ad_vehicle_msgs.msg.Navi()
      if self.sonar is None:
        self.sonar = ad_vehicle_msgs.msg.Sonar()
      if self.misc is None:
        self.misc = ad_vehicle_msgs.msg.Misc()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 175
      (_x.mode.enable, _x.mode.throttle_enable, _x.mode.brake_enable, _x.mode.steering_enable, _x.mode.gear_enable, _x.throttle.pedal_input, _x.throttle.pedal_command, _x.throttle.pedal_actual, _x.throttle.percent_command, _x.throttle.percent_actual, _x.throttle.engine_rpm, _x.throttle.bus_fault, _x.brake.pedal_input, _x.brake.pedal_command, _x.brake.pedal_actual, _x.brake.percent_command, _x.brake.percent_actual, _x.brake.torque_input, _x.brake.torque_command, _x.brake.torque_actual, _x.brake.decel_command, _x.brake.decel_actual, _x.brake.sensor_brake_torque, _x.brake.sensor_wheel_torque, _x.brake.parking_brake_actual, _x.brake.bus_fault, _x.steering.angle_command, _x.steering.angle_actual, _x.steering.torque_command, _x.steering.torque_actual, _x.steering.bus_fault, _x.gear.command, _x.gear.actual, _x.gear.bus_fault, _x.chassis.vehicle_mps, _x.chassis.wheel_speed_fl, _x.chassis.wheel_speed_fr, _x.chassis.wheel_speed_rl, _x.chassis.wheel_speed_rr, _x.chassis.wheel_pulse_fl, _x.chassis.wheel_pulse_fr, _x.chassis.wheel_pulse_rl, _x.chassis.wheel_pulse_rr, _x.chassis.tire_pressure_fl, _x.chassis.tire_pressure_fr, _x.chassis.tire_pressure_rl, _x.chassis.tire_pressure_rr, _x.chassis.suspension_fl, _x.chassis.suspension_fr, _x.chassis.suspension_rl, _x.chassis.suspension_rr, _x.chassis.fuel_level, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp,) = _get_struct_5B6fB12f2B4f4B5f4i9f3B().unpack(str[start:end])
      self.mode.enable = bool(self.mode.enable)
      self.mode.throttle_enable = bool(self.mode.throttle_enable)
      self.mode.brake_enable = bool(self.mode.brake_enable)
      self.mode.steering_enable = bool(self.mode.steering_enable)
      self.mode.gear_enable = bool(self.mode.gear_enable)
      self.throttle.bus_fault = bool(self.throttle.bus_fault)
      self.brake.parking_brake_actual = bool(self.brake.parking_brake_actual)
      self.brake.bus_fault = bool(self.brake.bus_fault)
      self.steering.bus_fault = bool(self.steering.bus_fault)
      self.gear.bus_fault = bool(self.gear.bus_fault)
      self.beam.stop_lamp = bool(self.beam.stop_lamp)
      self.beam.turn_left_lamp = bool(self.beam.turn_left_lamp)
      self.beam.turn_right_lamp = bool(self.beam.turn_right_lamp)
      start = end
      end += 8
      self.beam.reserved_lamp = _get_struct_8B().unpack(str[start:end])
      self.beam.reserved_lamp = list(map(bool, self.beam.reserved_lamp))
      _x = self
      start = end
      end += 48
      (_x.imu.accel_x, _x.imu.accel_y, _x.imu.accel_z, _x.imu.gyro_x, _x.imu.gyro_y, _x.imu.gyro_z, _x.navi.latitude, _x.navi.longitude, _x.navi.altitude,) = _get_struct_6f3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.navi.NMEA_GGA = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.navi.NMEA_GGA = str[start:end]
      start = end
      end += 48
      self.sonar.array = _get_struct_12f().unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.misc.door_fl, _x.misc.door_fr, _x.misc.door_rl, _x.misc.door_rr, _x.misc.door_hood, _x.misc.door_trunk, _x.misc.btn_acc_onoff, _x.misc.btn_acc_cancel, _x.misc.btn_acc_resume, _x.misc.btn_acc_set, _x.misc.btn_acc_dis_pls, _x.misc.btn_acc_dis_mns,) = _get_struct_12B().unpack(str[start:end])
      self.misc.door_fl = bool(self.misc.door_fl)
      self.misc.door_fr = bool(self.misc.door_fr)
      self.misc.door_rl = bool(self.misc.door_rl)
      self.misc.door_rr = bool(self.misc.door_rr)
      self.misc.door_hood = bool(self.misc.door_hood)
      self.misc.door_trunk = bool(self.misc.door_trunk)
      self.misc.btn_acc_onoff = bool(self.misc.btn_acc_onoff)
      self.misc.btn_acc_cancel = bool(self.misc.btn_acc_cancel)
      self.misc.btn_acc_resume = bool(self.misc.btn_acc_resume)
      self.misc.btn_acc_set = bool(self.misc.btn_acc_set)
      self.misc.btn_acc_dis_pls = bool(self.misc.btn_acc_dis_pls)
      self.misc.btn_acc_dis_mns = bool(self.misc.btn_acc_dis_mns)
      start = end
      end += 8
      self.misc.reserved = _get_struct_8B().unpack(str[start:end])
      self.misc.reserved = list(map(bool, self.misc.reserved))
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5B6fB12f2B4f4B5f4i9f3B().pack(_x.mode.enable, _x.mode.throttle_enable, _x.mode.brake_enable, _x.mode.steering_enable, _x.mode.gear_enable, _x.throttle.pedal_input, _x.throttle.pedal_command, _x.throttle.pedal_actual, _x.throttle.percent_command, _x.throttle.percent_actual, _x.throttle.engine_rpm, _x.throttle.bus_fault, _x.brake.pedal_input, _x.brake.pedal_command, _x.brake.pedal_actual, _x.brake.percent_command, _x.brake.percent_actual, _x.brake.torque_input, _x.brake.torque_command, _x.brake.torque_actual, _x.brake.decel_command, _x.brake.decel_actual, _x.brake.sensor_brake_torque, _x.brake.sensor_wheel_torque, _x.brake.parking_brake_actual, _x.brake.bus_fault, _x.steering.angle_command, _x.steering.angle_actual, _x.steering.torque_command, _x.steering.torque_actual, _x.steering.bus_fault, _x.gear.command, _x.gear.actual, _x.gear.bus_fault, _x.chassis.vehicle_mps, _x.chassis.wheel_speed_fl, _x.chassis.wheel_speed_fr, _x.chassis.wheel_speed_rl, _x.chassis.wheel_speed_rr, _x.chassis.wheel_pulse_fl, _x.chassis.wheel_pulse_fr, _x.chassis.wheel_pulse_rl, _x.chassis.wheel_pulse_rr, _x.chassis.tire_pressure_fl, _x.chassis.tire_pressure_fr, _x.chassis.tire_pressure_rl, _x.chassis.tire_pressure_rr, _x.chassis.suspension_fl, _x.chassis.suspension_fr, _x.chassis.suspension_rl, _x.chassis.suspension_rr, _x.chassis.fuel_level, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp))
      buff.write(self.beam.reserved_lamp.tostring())
      _x = self
      buff.write(_get_struct_6f3d().pack(_x.imu.accel_x, _x.imu.accel_y, _x.imu.accel_z, _x.imu.gyro_x, _x.imu.gyro_y, _x.imu.gyro_z, _x.navi.latitude, _x.navi.longitude, _x.navi.altitude))
      _x = self.navi.NMEA_GGA
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(self.sonar.array.tostring())
      _x = self
      buff.write(_get_struct_12B().pack(_x.misc.door_fl, _x.misc.door_fr, _x.misc.door_rl, _x.misc.door_rr, _x.misc.door_hood, _x.misc.door_trunk, _x.misc.btn_acc_onoff, _x.misc.btn_acc_cancel, _x.misc.btn_acc_resume, _x.misc.btn_acc_set, _x.misc.btn_acc_dis_pls, _x.misc.btn_acc_dis_mns))
      buff.write(self.misc.reserved.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.mode is None:
        self.mode = ad_vehicle_msgs.msg.ModeReport()
      if self.throttle is None:
        self.throttle = ad_vehicle_msgs.msg.ThrottleReport()
      if self.brake is None:
        self.brake = ad_vehicle_msgs.msg.BrakeReport()
      if self.steering is None:
        self.steering = ad_vehicle_msgs.msg.SteeringReport()
      if self.gear is None:
        self.gear = ad_vehicle_msgs.msg.GearReport()
      if self.chassis is None:
        self.chassis = ad_vehicle_msgs.msg.Chassis()
      if self.beam is None:
        self.beam = ad_vehicle_msgs.msg.Beam()
      if self.imu is None:
        self.imu = ad_vehicle_msgs.msg.Imu()
      if self.navi is None:
        self.navi = ad_vehicle_msgs.msg.Navi()
      if self.sonar is None:
        self.sonar = ad_vehicle_msgs.msg.Sonar()
      if self.misc is None:
        self.misc = ad_vehicle_msgs.msg.Misc()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 175
      (_x.mode.enable, _x.mode.throttle_enable, _x.mode.brake_enable, _x.mode.steering_enable, _x.mode.gear_enable, _x.throttle.pedal_input, _x.throttle.pedal_command, _x.throttle.pedal_actual, _x.throttle.percent_command, _x.throttle.percent_actual, _x.throttle.engine_rpm, _x.throttle.bus_fault, _x.brake.pedal_input, _x.brake.pedal_command, _x.brake.pedal_actual, _x.brake.percent_command, _x.brake.percent_actual, _x.brake.torque_input, _x.brake.torque_command, _x.brake.torque_actual, _x.brake.decel_command, _x.brake.decel_actual, _x.brake.sensor_brake_torque, _x.brake.sensor_wheel_torque, _x.brake.parking_brake_actual, _x.brake.bus_fault, _x.steering.angle_command, _x.steering.angle_actual, _x.steering.torque_command, _x.steering.torque_actual, _x.steering.bus_fault, _x.gear.command, _x.gear.actual, _x.gear.bus_fault, _x.chassis.vehicle_mps, _x.chassis.wheel_speed_fl, _x.chassis.wheel_speed_fr, _x.chassis.wheel_speed_rl, _x.chassis.wheel_speed_rr, _x.chassis.wheel_pulse_fl, _x.chassis.wheel_pulse_fr, _x.chassis.wheel_pulse_rl, _x.chassis.wheel_pulse_rr, _x.chassis.tire_pressure_fl, _x.chassis.tire_pressure_fr, _x.chassis.tire_pressure_rl, _x.chassis.tire_pressure_rr, _x.chassis.suspension_fl, _x.chassis.suspension_fr, _x.chassis.suspension_rl, _x.chassis.suspension_rr, _x.chassis.fuel_level, _x.beam.stop_lamp, _x.beam.turn_left_lamp, _x.beam.turn_right_lamp,) = _get_struct_5B6fB12f2B4f4B5f4i9f3B().unpack(str[start:end])
      self.mode.enable = bool(self.mode.enable)
      self.mode.throttle_enable = bool(self.mode.throttle_enable)
      self.mode.brake_enable = bool(self.mode.brake_enable)
      self.mode.steering_enable = bool(self.mode.steering_enable)
      self.mode.gear_enable = bool(self.mode.gear_enable)
      self.throttle.bus_fault = bool(self.throttle.bus_fault)
      self.brake.parking_brake_actual = bool(self.brake.parking_brake_actual)
      self.brake.bus_fault = bool(self.brake.bus_fault)
      self.steering.bus_fault = bool(self.steering.bus_fault)
      self.gear.bus_fault = bool(self.gear.bus_fault)
      self.beam.stop_lamp = bool(self.beam.stop_lamp)
      self.beam.turn_left_lamp = bool(self.beam.turn_left_lamp)
      self.beam.turn_right_lamp = bool(self.beam.turn_right_lamp)
      start = end
      end += 8
      self.beam.reserved_lamp = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=8)
      self.beam.reserved_lamp = list(map(bool, self.beam.reserved_lamp))
      _x = self
      start = end
      end += 48
      (_x.imu.accel_x, _x.imu.accel_y, _x.imu.accel_z, _x.imu.gyro_x, _x.imu.gyro_y, _x.imu.gyro_z, _x.navi.latitude, _x.navi.longitude, _x.navi.altitude,) = _get_struct_6f3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.navi.NMEA_GGA = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.navi.NMEA_GGA = str[start:end]
      start = end
      end += 48
      self.sonar.array = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=12)
      _x = self
      start = end
      end += 12
      (_x.misc.door_fl, _x.misc.door_fr, _x.misc.door_rl, _x.misc.door_rr, _x.misc.door_hood, _x.misc.door_trunk, _x.misc.btn_acc_onoff, _x.misc.btn_acc_cancel, _x.misc.btn_acc_resume, _x.misc.btn_acc_set, _x.misc.btn_acc_dis_pls, _x.misc.btn_acc_dis_mns,) = _get_struct_12B().unpack(str[start:end])
      self.misc.door_fl = bool(self.misc.door_fl)
      self.misc.door_fr = bool(self.misc.door_fr)
      self.misc.door_rl = bool(self.misc.door_rl)
      self.misc.door_rr = bool(self.misc.door_rr)
      self.misc.door_hood = bool(self.misc.door_hood)
      self.misc.door_trunk = bool(self.misc.door_trunk)
      self.misc.btn_acc_onoff = bool(self.misc.btn_acc_onoff)
      self.misc.btn_acc_cancel = bool(self.misc.btn_acc_cancel)
      self.misc.btn_acc_resume = bool(self.misc.btn_acc_resume)
      self.misc.btn_acc_set = bool(self.misc.btn_acc_set)
      self.misc.btn_acc_dis_pls = bool(self.misc.btn_acc_dis_pls)
      self.misc.btn_acc_dis_mns = bool(self.misc.btn_acc_dis_mns)
      start = end
      end += 8
      self.misc.reserved = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=8)
      self.misc.reserved = list(map(bool, self.misc.reserved))
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12B = None
def _get_struct_12B():
    global _struct_12B
    if _struct_12B is None:
        _struct_12B = struct.Struct("<12B")
    return _struct_12B
_struct_12f = None
def _get_struct_12f():
    global _struct_12f
    if _struct_12f is None:
        _struct_12f = struct.Struct("<12f")
    return _struct_12f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_5B6fB12f2B4f4B5f4i9f3B = None
def _get_struct_5B6fB12f2B4f4B5f4i9f3B():
    global _struct_5B6fB12f2B4f4B5f4i9f3B
    if _struct_5B6fB12f2B4f4B5f4i9f3B is None:
        _struct_5B6fB12f2B4f4B5f4i9f3B = struct.Struct("<5B6fB12f2B4f4B5f4i9f3B")
    return _struct_5B6fB12f2B4f4B5f4i9f3B
_struct_6f3d = None
def _get_struct_6f3d():
    global _struct_6f3d
    if _struct_6f3d is None:
        _struct_6f3d = struct.Struct("<6f3d")
    return _struct_6f3d
_struct_8B = None
def _get_struct_8B():
    global _struct_8B
    if _struct_8B is None:
        _struct_8B = struct.Struct("<8B")
    return _struct_8B
