// Auto-generated. Do not edit!

// (in-package ad_hdmap_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RoutingNode = require('./RoutingNode.js');
let RoutingLine = require('./RoutingLine.js');
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Routing {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.process_time_ns = null;
      this.trigger_src = null;
      this.node_list = null;
      this.navigation_line = null;
      this.departure_enu = null;
      this.destination_enu = null;
      this.debug_info = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('process_time_ns')) {
        this.process_time_ns = initObj.process_time_ns
      }
      else {
        this.process_time_ns = 0;
      }
      if (initObj.hasOwnProperty('trigger_src')) {
        this.trigger_src = initObj.trigger_src
      }
      else {
        this.trigger_src = '';
      }
      if (initObj.hasOwnProperty('node_list')) {
        this.node_list = initObj.node_list
      }
      else {
        this.node_list = [];
      }
      if (initObj.hasOwnProperty('navigation_line')) {
        this.navigation_line = initObj.navigation_line
      }
      else {
        this.navigation_line = [];
      }
      if (initObj.hasOwnProperty('departure_enu')) {
        this.departure_enu = initObj.departure_enu
      }
      else {
        this.departure_enu = new geometry_msgs.msg.Point();
      }
      if (initObj.hasOwnProperty('destination_enu')) {
        this.destination_enu = initObj.destination_enu
      }
      else {
        this.destination_enu = new geometry_msgs.msg.Point();
      }
      if (initObj.hasOwnProperty('debug_info')) {
        this.debug_info = initObj.debug_info
      }
      else {
        this.debug_info = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Routing
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [process_time_ns]
    bufferOffset = _serializer.uint64(obj.process_time_ns, buffer, bufferOffset);
    // Serialize message field [trigger_src]
    bufferOffset = _serializer.string(obj.trigger_src, buffer, bufferOffset);
    // Serialize message field [node_list]
    // Serialize the length for message field [node_list]
    bufferOffset = _serializer.uint32(obj.node_list.length, buffer, bufferOffset);
    obj.node_list.forEach((val) => {
      bufferOffset = RoutingNode.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [navigation_line]
    // Serialize the length for message field [navigation_line]
    bufferOffset = _serializer.uint32(obj.navigation_line.length, buffer, bufferOffset);
    obj.navigation_line.forEach((val) => {
      bufferOffset = RoutingLine.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [departure_enu]
    bufferOffset = geometry_msgs.msg.Point.serialize(obj.departure_enu, buffer, bufferOffset);
    // Serialize message field [destination_enu]
    bufferOffset = geometry_msgs.msg.Point.serialize(obj.destination_enu, buffer, bufferOffset);
    // Serialize message field [debug_info]
    bufferOffset = _serializer.string(obj.debug_info, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Routing
    let len;
    let data = new Routing(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [process_time_ns]
    data.process_time_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [trigger_src]
    data.trigger_src = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [node_list]
    // Deserialize array length for message field [node_list]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.node_list = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.node_list[i] = RoutingNode.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [navigation_line]
    // Deserialize array length for message field [navigation_line]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.navigation_line = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.navigation_line[i] = RoutingLine.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [departure_enu]
    data.departure_enu = geometry_msgs.msg.Point.deserialize(buffer, bufferOffset);
    // Deserialize message field [destination_enu]
    data.destination_enu = geometry_msgs.msg.Point.deserialize(buffer, bufferOffset);
    // Deserialize message field [debug_info]
    data.debug_info = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += _getByteLength(object.trigger_src);
    object.node_list.forEach((val) => {
      length += RoutingNode.getMessageSize(val);
    });
    length += 48 * object.navigation_line.length;
    length += _getByteLength(object.debug_info);
    return length + 72;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_hdmap_msgs/Routing';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e7f46f497d0d65259d09484ba48d7a66';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp(last node pub time), and frame_id
    std_msgs/Header header
    
    # Time cost of routing process in nanosecond
    uint64 process_time_ns
    # Name of trigger source for debug
    string trigger_src
    
    # Routing info
    RoutingNode[] node_list
    RoutingLine[] navigation_line
    # Response point info
    geometry_msgs/Point departure_enu
    geometry_msgs/Point destination_enu
    
    # Debug info
    string debug_info
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_hdmap_msgs/RoutingNode
    # Node type and ID
    string node_id
    uint8 node_type
    
    string lane_id
    string road_id
    float64 accu_length
    
    # Section inherit
    string from_section
    string to_section
    
    # Lane inherit
    string from_lane
    string to_lane
    
    ================================================================================
    MSG: ad_hdmap_msgs/RoutingLine
    # LLA coordinate
    MapCoordLLA lla
    
    # ENU points
    geometry_msgs/Point enu
    
    ================================================================================
    MSG: ad_hdmap_msgs/MapCoordLLA
    # LLA coordinate
    float64 longitude
    float64 latitude
    float64 altitude
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Routing(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.process_time_ns !== undefined) {
      resolved.process_time_ns = msg.process_time_ns;
    }
    else {
      resolved.process_time_ns = 0
    }

    if (msg.trigger_src !== undefined) {
      resolved.trigger_src = msg.trigger_src;
    }
    else {
      resolved.trigger_src = ''
    }

    if (msg.node_list !== undefined) {
      resolved.node_list = new Array(msg.node_list.length);
      for (let i = 0; i < resolved.node_list.length; ++i) {
        resolved.node_list[i] = RoutingNode.Resolve(msg.node_list[i]);
      }
    }
    else {
      resolved.node_list = []
    }

    if (msg.navigation_line !== undefined) {
      resolved.navigation_line = new Array(msg.navigation_line.length);
      for (let i = 0; i < resolved.navigation_line.length; ++i) {
        resolved.navigation_line[i] = RoutingLine.Resolve(msg.navigation_line[i]);
      }
    }
    else {
      resolved.navigation_line = []
    }

    if (msg.departure_enu !== undefined) {
      resolved.departure_enu = geometry_msgs.msg.Point.Resolve(msg.departure_enu)
    }
    else {
      resolved.departure_enu = new geometry_msgs.msg.Point()
    }

    if (msg.destination_enu !== undefined) {
      resolved.destination_enu = geometry_msgs.msg.Point.Resolve(msg.destination_enu)
    }
    else {
      resolved.destination_enu = new geometry_msgs.msg.Point()
    }

    if (msg.debug_info !== undefined) {
      resolved.debug_info = msg.debug_info;
    }
    else {
      resolved.debug_info = ''
    }

    return resolved;
    }
};

module.exports = Routing;
