// Auto-generated. Do not edit!

// (in-package ad_hdmap_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let SubMap = require('../msg/SubMap.js');

//-----------------------------------------------------------

class GetSubMapRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.center_position_enu = null;
      this.range_radius_m = null;
    }
    else {
      if (initObj.hasOwnProperty('center_position_enu')) {
        this.center_position_enu = initObj.center_position_enu
      }
      else {
        this.center_position_enu = new geometry_msgs.msg.Point();
      }
      if (initObj.hasOwnProperty('range_radius_m')) {
        this.range_radius_m = initObj.range_radius_m
      }
      else {
        this.range_radius_m = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetSubMapRequest
    // Serialize message field [center_position_enu]
    bufferOffset = geometry_msgs.msg.Point.serialize(obj.center_position_enu, buffer, bufferOffset);
    // Serialize message field [range_radius_m]
    bufferOffset = _serializer.float64(obj.range_radius_m, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetSubMapRequest
    let len;
    let data = new GetSubMapRequest(null);
    // Deserialize message field [center_position_enu]
    data.center_position_enu = geometry_msgs.msg.Point.deserialize(buffer, bufferOffset);
    // Deserialize message field [range_radius_m]
    data.range_radius_m = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 32;
  }

  static datatype() {
    // Returns string type for a service object
    return 'ad_hdmap_msgs/GetSubMapRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '649278f116d97789fc5d1ecf8ea660bc';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Request sub map center point enu
    geometry_msgs/Point center_position_enu
    # Range of request sub map
    float64 range_radius_m
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetSubMapRequest(null);
    if (msg.center_position_enu !== undefined) {
      resolved.center_position_enu = geometry_msgs.msg.Point.Resolve(msg.center_position_enu)
    }
    else {
      resolved.center_position_enu = new geometry_msgs.msg.Point()
    }

    if (msg.range_radius_m !== undefined) {
      resolved.range_radius_m = msg.range_radius_m;
    }
    else {
      resolved.range_radius_m = 0.0
    }

    return resolved;
    }
};

class GetSubMapResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.message = null;
      this.sub_map = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('message')) {
        this.message = initObj.message
      }
      else {
        this.message = '';
      }
      if (initObj.hasOwnProperty('sub_map')) {
        this.sub_map = initObj.sub_map
      }
      else {
        this.sub_map = new SubMap();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetSubMapResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [message]
    bufferOffset = _serializer.string(obj.message, buffer, bufferOffset);
    // Serialize message field [sub_map]
    bufferOffset = SubMap.serialize(obj.sub_map, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetSubMapResponse
    let len;
    let data = new GetSubMapResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [message]
    data.message = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [sub_map]
    data.sub_map = SubMap.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.message);
    length += SubMap.getMessageSize(object.sub_map);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a service object
    return 'ad_hdmap_msgs/GetSubMapResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '0215e747f7431dfd557d933d97e2a735';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Response result info
    bool success
    string message
    # Response sub map
    SubMap sub_map
    
    
    ================================================================================
    MSG: ad_hdmap_msgs/SubMap
    # Header include seq, timestamp(last node pub time), and frame_id
    std_msgs/Header header
    
    # Sub map info
    SubMapMeta info
    # Data buffer used to temporarily store submap
    string data
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_hdmap_msgs/SubMapMeta
    # Time for sub map process
    uint64 map_load_time_ns
    # Current sub map center point (ENU)
    geometry_msgs/Point center_position_enu
    # Range of this sub map
    float64 range_radius_m
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetSubMapResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.message !== undefined) {
      resolved.message = msg.message;
    }
    else {
      resolved.message = ''
    }

    if (msg.sub_map !== undefined) {
      resolved.sub_map = SubMap.Resolve(msg.sub_map)
    }
    else {
      resolved.sub_map = new SubMap()
    }

    return resolved;
    }
};

module.exports = {
  Request: GetSubMapRequest,
  Response: GetSubMapResponse,
  md5sum() { return '3eb278e8ec1cbff3c74fc19540baf240'; },
  datatype() { return 'ad_hdmap_msgs/GetSubMap'; }
};
