// Auto-generated. Do not edit!

// (in-package ad_monitor_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class NodeStateInfo {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.name = null;
      this.status = null;
      this.pid = null;
      this.is_nodelet = null;
      this.wall_time_ns = null;
      this.ext_data = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = 0;
      }
      if (initObj.hasOwnProperty('pid')) {
        this.pid = initObj.pid
      }
      else {
        this.pid = 0;
      }
      if (initObj.hasOwnProperty('is_nodelet')) {
        this.is_nodelet = initObj.is_nodelet
      }
      else {
        this.is_nodelet = false;
      }
      if (initObj.hasOwnProperty('wall_time_ns')) {
        this.wall_time_ns = initObj.wall_time_ns
      }
      else {
        this.wall_time_ns = 0;
      }
      if (initObj.hasOwnProperty('ext_data')) {
        this.ext_data = initObj.ext_data
      }
      else {
        this.ext_data = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type NodeStateInfo
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [status]
    bufferOffset = _serializer.uint8(obj.status, buffer, bufferOffset);
    // Serialize message field [pid]
    bufferOffset = _serializer.uint32(obj.pid, buffer, bufferOffset);
    // Serialize message field [is_nodelet]
    bufferOffset = _serializer.bool(obj.is_nodelet, buffer, bufferOffset);
    // Serialize message field [wall_time_ns]
    bufferOffset = _serializer.uint64(obj.wall_time_ns, buffer, bufferOffset);
    // Serialize message field [ext_data]
    bufferOffset = _arraySerializer.uint8(obj.ext_data, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type NodeStateInfo
    let len;
    let data = new NodeStateInfo(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [status]
    data.status = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [pid]
    data.pid = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [is_nodelet]
    data.is_nodelet = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [wall_time_ns]
    data.wall_time_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [ext_data]
    data.ext_data = _arrayDeserializer.uint8(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += _getByteLength(object.name);
    length += object.ext_data.length;
    return length + 22;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_monitor_msgs/NodeStateInfo';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f0b1bd5125d603381a1b37e01b721c96';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp(last node pub time), and frame_id(sensor model)
    std_msgs/Header header
    
    # name of nodelet or node who sended this msg.
    string name
    
    # nodelet status
    uint8 status
    
    # nodelet status enum
    uint8 WAITING  = 0 # Before Initialization state
    uint8 STARTING = 1 # During the initialization process
    uint8 RUNNING  = 2 # The node is running
    uint8 STOPPING = 3 # The node is stopping
    uint8 STOPPED  = 4 # The node has stopped due to some reason
    uint8 FAILED   = 5 # The node fails due to initialization errors, running errors, etc.
    uint8 READY    = 6 # Indicate whether the system is ready for autonomous driving
    uint8 RESET    = 7 # The node is currently under resetting
    uint8 UNKNOWN  = 9 # The node is currently under an unknown status
    
    # process id of the nodelet.
    uint32 pid
    
    # whether this node is a nodelet or not
    bool is_nodelet
    
    # wall time in ns
    uint64 wall_time_ns
    
    # extra infomation
    uint8[] ext_data
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new NodeStateInfo(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.status !== undefined) {
      resolved.status = msg.status;
    }
    else {
      resolved.status = 0
    }

    if (msg.pid !== undefined) {
      resolved.pid = msg.pid;
    }
    else {
      resolved.pid = 0
    }

    if (msg.is_nodelet !== undefined) {
      resolved.is_nodelet = msg.is_nodelet;
    }
    else {
      resolved.is_nodelet = false
    }

    if (msg.wall_time_ns !== undefined) {
      resolved.wall_time_ns = msg.wall_time_ns;
    }
    else {
      resolved.wall_time_ns = 0
    }

    if (msg.ext_data !== undefined) {
      resolved.ext_data = msg.ext_data;
    }
    else {
      resolved.ext_data = []
    }

    return resolved;
    }
};

// Constants for message
NodeStateInfo.Constants = {
  WAITING: 0,
  STARTING: 1,
  RUNNING: 2,
  STOPPING: 3,
  STOPPED: 4,
  FAILED: 5,
  READY: 6,
  RESET: 7,
  UNKNOWN: 9,
}

module.exports = NodeStateInfo;
