// Auto-generated. Do not edit!

// (in-package ad_perception_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LidarDangerousZone = require('./LidarDangerousZone.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class LidarDangerousZoneFrame {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.frame_timestamp_ns = null;
      this.sensor_id = null;
      this.height = null;
      this.type = null;
      this.dzones = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('frame_timestamp_ns')) {
        this.frame_timestamp_ns = initObj.frame_timestamp_ns
      }
      else {
        this.frame_timestamp_ns = 0;
      }
      if (initObj.hasOwnProperty('sensor_id')) {
        this.sensor_id = initObj.sensor_id
      }
      else {
        this.sensor_id = 0;
      }
      if (initObj.hasOwnProperty('height')) {
        this.height = initObj.height
      }
      else {
        this.height = 0.0;
      }
      if (initObj.hasOwnProperty('type')) {
        this.type = initObj.type
      }
      else {
        this.type = 0;
      }
      if (initObj.hasOwnProperty('dzones')) {
        this.dzones = initObj.dzones
      }
      else {
        this.dzones = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LidarDangerousZoneFrame
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [frame_timestamp_ns]
    bufferOffset = _serializer.uint64(obj.frame_timestamp_ns, buffer, bufferOffset);
    // Serialize message field [sensor_id]
    bufferOffset = _serializer.int16(obj.sensor_id, buffer, bufferOffset);
    // Serialize message field [height]
    bufferOffset = _serializer.float64(obj.height, buffer, bufferOffset);
    // Serialize message field [type]
    bufferOffset = _serializer.int16(obj.type, buffer, bufferOffset);
    // Serialize message field [dzones]
    // Serialize the length for message field [dzones]
    bufferOffset = _serializer.uint32(obj.dzones.length, buffer, bufferOffset);
    obj.dzones.forEach((val) => {
      bufferOffset = LidarDangerousZone.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LidarDangerousZoneFrame
    let len;
    let data = new LidarDangerousZoneFrame(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [frame_timestamp_ns]
    data.frame_timestamp_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [sensor_id]
    data.sensor_id = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [height]
    data.height = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [type]
    data.type = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [dzones]
    // Deserialize array length for message field [dzones]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.dzones = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.dzones[i] = LidarDangerousZone.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.dzones.forEach((val) => {
      length += LidarDangerousZone.getMessageSize(val);
    });
    return length + 24;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_perception_msgs/LidarDangerousZoneFrame';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b9d4ff3c61a9e25ec3e5a1f331030bce';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp, and frame_id
    std_msgs/Header header
    
    uint64 frame_timestamp_ns
    
    # enum SensorID
    int16 sensor_id
    
    float64 height
    
    # enum DangerousZoneType
    int16 type
    
    LidarDangerousZone[] dzones
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_perception_msgs/LidarDangerousZone
    Point2f[] polygon
    
    # enum dangerous zone level
    int16 dangerous_level
    
    uint64 dzone_id
    
    uint64[] pre_dzone_ids
    uint64[] occluder_ids
    uint64[] shadow_ids
    float32 height
    
    # enum DzoneType
    int16 type
    
    ================================================================================
    MSG: ad_perception_msgs/Point2f
    float32 x
    float32 y
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LidarDangerousZoneFrame(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.frame_timestamp_ns !== undefined) {
      resolved.frame_timestamp_ns = msg.frame_timestamp_ns;
    }
    else {
      resolved.frame_timestamp_ns = 0
    }

    if (msg.sensor_id !== undefined) {
      resolved.sensor_id = msg.sensor_id;
    }
    else {
      resolved.sensor_id = 0
    }

    if (msg.height !== undefined) {
      resolved.height = msg.height;
    }
    else {
      resolved.height = 0.0
    }

    if (msg.type !== undefined) {
      resolved.type = msg.type;
    }
    else {
      resolved.type = 0
    }

    if (msg.dzones !== undefined) {
      resolved.dzones = new Array(msg.dzones.length);
      for (let i = 0; i < resolved.dzones.length; ++i) {
        resolved.dzones[i] = LidarDangerousZone.Resolve(msg.dzones[i]);
      }
    }
    else {
      resolved.dzones = []
    }

    return resolved;
    }
};

module.exports = LidarDangerousZoneFrame;
