// Auto-generated. Do not edit!

// (in-package ad_perception_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Object = require('./Object.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class ObjectFrame {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.frame_timestamp_ns = null;
      this.sensor_id = null;
      this.perception_object_list = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('frame_timestamp_ns')) {
        this.frame_timestamp_ns = initObj.frame_timestamp_ns
      }
      else {
        this.frame_timestamp_ns = 0;
      }
      if (initObj.hasOwnProperty('sensor_id')) {
        this.sensor_id = initObj.sensor_id
      }
      else {
        this.sensor_id = 0;
      }
      if (initObj.hasOwnProperty('perception_object_list')) {
        this.perception_object_list = initObj.perception_object_list
      }
      else {
        this.perception_object_list = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ObjectFrame
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [frame_timestamp_ns]
    bufferOffset = _serializer.uint64(obj.frame_timestamp_ns, buffer, bufferOffset);
    // Serialize message field [sensor_id]
    bufferOffset = _serializer.int16(obj.sensor_id, buffer, bufferOffset);
    // Serialize message field [perception_object_list]
    // Serialize the length for message field [perception_object_list]
    bufferOffset = _serializer.uint32(obj.perception_object_list.length, buffer, bufferOffset);
    obj.perception_object_list.forEach((val) => {
      bufferOffset = Object.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ObjectFrame
    let len;
    let data = new ObjectFrame(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [frame_timestamp_ns]
    data.frame_timestamp_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [sensor_id]
    data.sensor_id = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [perception_object_list]
    // Deserialize array length for message field [perception_object_list]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.perception_object_list = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.perception_object_list[i] = Object.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.perception_object_list.forEach((val) => {
      length += Object.getMessageSize(val);
    });
    return length + 14;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_perception_msgs/ObjectFrame';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9f82da4ca3d31860081b6a80ede1d8c2';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp, and frame_id
    std_msgs/Header header
    
    uint64 frame_timestamp_ns
    
    # enum SensorID
    int16 sensor_id
    
    Object[] perception_object_list
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_perception_msgs/Object
    ## BaseObject
    
    # enum SensorID
    int16 sensor_id
    # enum ObjectLabel
    int16 label
    float32 type_confidence
    float32 existence_confidence
    # enum ObjectLabel
    int16 sub_type
    
    # ObjectLabel
    int16 UNKNOWN=0
    int16 PEDESTRIAN=1
    int16 VEHICLE=2
    int16 VEHICLE_CAR=3
    int16 VEHICLE_SUV=4
    int16 VEHICLE_VAN=5
    int16 VEHICLE_TRUCK=6
    int16 VEHICLE_PICKUP_TRUCK=7
    int16 VEHICLE_BUS=8
    int16 VEHICLE_TAXI=9
    int16 VEHICLE_EMERGENCY=10
    int16 VEHICLE_SCHOOL_BUS=11
    int16 VEHICLE_OTHERS=12
    int16 VEHICLE_END=13
    int16 BIKE=14
    int16 NO_PERSON_VEHICLE=15
    int16 BIKE_BICYCLE=16
    int16 BIKE_BIKEBIG=17
    int16 BIKE_BIKESMALL=18
    int16 BIKE_END=19
    int16 TRAFFICLIGHT_ALL=20
    int16 TRAFFICLIGHT_END=64
    int16 TRAFFICSIGN_ALL=65
    int16 TRAFFICSIGN_END=135
    int16 OBSTACLE_ALL=136
    int16 OBSTACLE_END=150
    int16 ROADMARKER_ALL=151
    int16 ROADMARKER_END=162
    
    float32[] sub_type_probs
    int32 track_id
    float32 track_age_time_second
    uint64 last_measure_update_timestamp_ns
    uint64 current_prediction_timestamp_ns
    
    SizeInfo size_info
    PolygonBox polygon_box
    DirectionInfo direction_info
    MotionInfo motion_info
    int16 motion_status
    float32 motion_static_score
    
    # enum MaintenanceStatus
    int16 maintenance_status
    # enum OcclusionStatus
    int16 occlusion_status
    
    # ModelOutputFeatures
    ModelOutputFeature[] feature
    
    # CameraBBox2DInfo
    CameraBBox2DInfo camera_bbox_info
    
    # Derived object type : used only between ros nodes to determine dynamic type of object
    uint8 derived_type
    # Derived types
    uint8 CAMERA_NON_VEHICLE=1
    uint8 CAMERA_PEDESTRIAN=2
    uint8 CAMERA_VEHICLE=3
    uint8 CAMERA_STATIC_OBSTACLE=4
    uint8 LIDAR_OBJECT=5
    uint8 RADAR_OBJECT=6
    uint8 FUSION_OBJECT=7
    
    ## Shared: NonAutomobileVehicle Pedestrian Automobile
    BaseCameraAttribute attribute
    
    ## Shared: Automobile FusionObject
    AutomobileLightStatus automobile_light_status
    
    ## Static Obstacle Specific
    bool is_right_edge_detected
    Vector4i right_edge_line
    
    ## NonAutomobileVehicle Specific
    # enum NonAutomobileVehicleLightStatus
    NonAutomobileVehicleLightStatus non_automobile_vehicle_light_status
    bool is_with_ped
    
    ## Pedestrian Specific
    # action enum AttrBool
    int8 umbrella
    int8 call
    int8 phone
    int8 wave
    int8 standing
    # direction
    Point2f upper_body_direction
    Point2f lower_body_direction
    Point2f face_direction
    # intention
    PedestrianIntention intention
    bool is_on_bike
    
    ## Automobile Specific
    DepthDetPoint depth_point
    
    ## LidarObject Specific
    uint64 point_cloud_timestamp_ns
    
    ## RadarObject Specific
    float64 track_range
    float64 track_range_rate
    float64 track_range_accel_rate
    float64 track_lat_rate
    
    ## FusionObject Specific
    MatchedSensorObjectInfo[] matched_sensor_object_info
    ================================================================================
    MSG: ad_perception_msgs/SizeInfo
    bool is_valid
    
    Vector3f size
    Matrix3f size_uncertainty
    
    ================================================================================
    MSG: ad_perception_msgs/Vector3f
    float32 x
    float32 y
    float32 z
    ================================================================================
    MSG: ad_perception_msgs/Matrix3f
    Vector3f x
    Vector3f y
    Vector3f z
    
    ================================================================================
    MSG: ad_perception_msgs/PolygonBox
    bool is_valid
    Point2f[] polygon_contour
    float32 height_lower_surface
    float32 height_upper_surface
    ================================================================================
    MSG: ad_perception_msgs/Point2f
    float32 x
    float32 y
    ================================================================================
    MSG: ad_perception_msgs/DirectionInfo
    bool is_valid
    
    Vector3f direction_ypr
    Matrix3f direction_ypr_uncertainty
    float32 yaw
    float32 yaw_uncertainty
    float32 yaw_rate
    float32 yaw_rate_uncertainty
    
    ================================================================================
    MSG: ad_perception_msgs/MotionInfo
    bool is_valid
    
    # enum MotionStatus
    int16 motion_status
    
    Vector3d center
    Matrix3f center_uncertainty
    Vector3f velocity
    Matrix3f velocity_uncertainty
    Vector3f acceleration
    Matrix3f acceleration_uncertainty
    Vector3f jerk
    Matrix3f jerk_uncertainty
    float32 velocity_heading
    float32 velocity_heading_uncertainty
    float32 velocity_heading_rate
    float32 velocity_heading_rate_uncertainty
    
    ================================================================================
    MSG: ad_perception_msgs/Vector3d
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: ad_perception_msgs/ModelOutputFeature
    string key
    float32[] value
    ================================================================================
    MSG: ad_perception_msgs/CameraBBox2DInfo
    Bbox2D raw_detection_box
    Bbox2D tracked_box
    ================================================================================
    MSG: ad_perception_msgs/Bbox2D
    bool initialized
    float32 top_left_x
    float32 top_left_y
    float32 bottom_right_x
    float32 bottom_right_y
    float32 confidence
    ================================================================================
    MSG: ad_perception_msgs/BaseCameraAttribute
    bool is_landmark_valid
    Point2f[] landmark
    float32[] landmark_scores
    
    bool is_direction_valid
    Point2f viewport_direction
    
    ================================================================================
    MSG: ad_perception_msgs/AutomobileLightStatus
    int16 left_turn
    int16 right_turn
    int16 hazard
    int16 brake
    ================================================================================
    MSG: ad_perception_msgs/Vector4i
    int32 x
    int32 y
    int32 z
    int32 w
    
    ================================================================================
    MSG: ad_perception_msgs/NonAutomobileVehicleLightStatus
    int16 left_turn
    int16 right_turn
    int16 brake
    ================================================================================
    MSG: ad_perception_msgs/PedestrianIntention
    # enum Intention
    int16 crossing
    # enum AttentionBool
    int16 attention_to_ego_car
    ================================================================================
    MSG: ad_perception_msgs/DepthDetPoint
    float32 nearest_point_x
    float32 depth_point_x
    float32 depth_point_y
    int32 orientation
    # enum DepthFineOriLabel
    int16 label
    ================================================================================
    MSG: ad_perception_msgs/MatchedSensorObjectInfo
    # enum SensorID
    int16 sensor_id
    
    uint64 frame_timestamp_ns
    uint64 object_id
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ObjectFrame(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.frame_timestamp_ns !== undefined) {
      resolved.frame_timestamp_ns = msg.frame_timestamp_ns;
    }
    else {
      resolved.frame_timestamp_ns = 0
    }

    if (msg.sensor_id !== undefined) {
      resolved.sensor_id = msg.sensor_id;
    }
    else {
      resolved.sensor_id = 0
    }

    if (msg.perception_object_list !== undefined) {
      resolved.perception_object_list = new Array(msg.perception_object_list.length);
      for (let i = 0; i < resolved.perception_object_list.length; ++i) {
        resolved.perception_object_list[i] = Object.Resolve(msg.perception_object_list[i]);
      }
    }
    else {
      resolved.perception_object_list = []
    }

    return resolved;
    }
};

module.exports = ObjectFrame;
