// Auto-generated. Do not edit!

// (in-package ad_perception_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RoadStruct = require('./RoadStruct.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class RoadFrame {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.frame_timestamp_ns = null;
      this.sensor_id = null;
      this.road_struct = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('frame_timestamp_ns')) {
        this.frame_timestamp_ns = initObj.frame_timestamp_ns
      }
      else {
        this.frame_timestamp_ns = 0;
      }
      if (initObj.hasOwnProperty('sensor_id')) {
        this.sensor_id = initObj.sensor_id
      }
      else {
        this.sensor_id = 0;
      }
      if (initObj.hasOwnProperty('road_struct')) {
        this.road_struct = initObj.road_struct
      }
      else {
        this.road_struct = new RoadStruct();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RoadFrame
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [frame_timestamp_ns]
    bufferOffset = _serializer.int64(obj.frame_timestamp_ns, buffer, bufferOffset);
    // Serialize message field [sensor_id]
    bufferOffset = _serializer.int16(obj.sensor_id, buffer, bufferOffset);
    // Serialize message field [road_struct]
    bufferOffset = RoadStruct.serialize(obj.road_struct, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RoadFrame
    let len;
    let data = new RoadFrame(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [frame_timestamp_ns]
    data.frame_timestamp_ns = _deserializer.int64(buffer, bufferOffset);
    // Deserialize message field [sensor_id]
    data.sensor_id = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [road_struct]
    data.road_struct = RoadStruct.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += RoadStruct.getMessageSize(object.road_struct);
    return length + 10;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_perception_msgs/RoadFrame';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '31fdfda2d9470693f9de40d3cb68f67f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp, and frame_id
    std_msgs/Header header
    
    int64 frame_timestamp_ns
    
    # enum SensorID
    int16 sensor_id
    
    RoadStruct road_struct
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_perception_msgs/RoadStruct
    LaneLine[] laneline_results
    StopLine[] stopline_results
    Boundary[] boundary_results
    Freespace[] freespace_results
    
    ================================================================================
    MSG: ad_perception_msgs/LaneLine
    Point2f[] image_points
    Point2f[] world_points
    Point2f[] world_points_reproj
    float32 lane_confidence
    float32 color_confidence
    float32 line_confidence
    float32 edge_confidence
    bool fitting_on_img_plane
    # enum LaneType
    int16 id
    int32 track_id
    int32 track_age
    float32 distance_to_left_bumper
    float32 distance_to_right_bumper
    # enum LaneCategory
    int16 lane_category
    # enum ColorType
    int16 color_id
    # enum LineType
    int16 line_id
    # enum EdgeType
    int16 edge_id
    
    ================================================================================
    MSG: ad_perception_msgs/Point2f
    float32 x
    float32 y
    ================================================================================
    MSG: ad_perception_msgs/StopLine
    Point2f[] image_points
    Point2f[] world_points
    float32[] confidence
    int32 id
    ================================================================================
    MSG: ad_perception_msgs/Boundary
    Point2f[] image_points
    Point2f[] world_points
    
    float32 direction_x
    float32 direction_y
    
    float32 confidence
    
    bool is_line
    int32 id
    ================================================================================
    MSG: ad_perception_msgs/Freespace
    int32 id
    
    Point2f[] image_points
    Point2f[] world_points
    
    uint16 width
    uint16 height
    
    bool[] bit_map
    
    float32[] confidence
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RoadFrame(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.frame_timestamp_ns !== undefined) {
      resolved.frame_timestamp_ns = msg.frame_timestamp_ns;
    }
    else {
      resolved.frame_timestamp_ns = 0
    }

    if (msg.sensor_id !== undefined) {
      resolved.sensor_id = msg.sensor_id;
    }
    else {
      resolved.sensor_id = 0
    }

    if (msg.road_struct !== undefined) {
      resolved.road_struct = RoadStruct.Resolve(msg.road_struct)
    }
    else {
      resolved.road_struct = new RoadStruct()
    }

    return resolved;
    }
};

module.exports = RoadFrame;
