// Auto-generated. Do not edit!

// (in-package ad_perception_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LaneLine = require('./LaneLine.js');
let StopLine = require('./StopLine.js');
let Boundary = require('./Boundary.js');
let Freespace = require('./Freespace.js');

//-----------------------------------------------------------

class RoadStruct {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.laneline_results = null;
      this.stopline_results = null;
      this.boundary_results = null;
      this.freespace_results = null;
    }
    else {
      if (initObj.hasOwnProperty('laneline_results')) {
        this.laneline_results = initObj.laneline_results
      }
      else {
        this.laneline_results = [];
      }
      if (initObj.hasOwnProperty('stopline_results')) {
        this.stopline_results = initObj.stopline_results
      }
      else {
        this.stopline_results = [];
      }
      if (initObj.hasOwnProperty('boundary_results')) {
        this.boundary_results = initObj.boundary_results
      }
      else {
        this.boundary_results = [];
      }
      if (initObj.hasOwnProperty('freespace_results')) {
        this.freespace_results = initObj.freespace_results
      }
      else {
        this.freespace_results = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RoadStruct
    // Serialize message field [laneline_results]
    // Serialize the length for message field [laneline_results]
    bufferOffset = _serializer.uint32(obj.laneline_results.length, buffer, bufferOffset);
    obj.laneline_results.forEach((val) => {
      bufferOffset = LaneLine.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [stopline_results]
    // Serialize the length for message field [stopline_results]
    bufferOffset = _serializer.uint32(obj.stopline_results.length, buffer, bufferOffset);
    obj.stopline_results.forEach((val) => {
      bufferOffset = StopLine.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [boundary_results]
    // Serialize the length for message field [boundary_results]
    bufferOffset = _serializer.uint32(obj.boundary_results.length, buffer, bufferOffset);
    obj.boundary_results.forEach((val) => {
      bufferOffset = Boundary.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [freespace_results]
    // Serialize the length for message field [freespace_results]
    bufferOffset = _serializer.uint32(obj.freespace_results.length, buffer, bufferOffset);
    obj.freespace_results.forEach((val) => {
      bufferOffset = Freespace.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RoadStruct
    let len;
    let data = new RoadStruct(null);
    // Deserialize message field [laneline_results]
    // Deserialize array length for message field [laneline_results]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.laneline_results = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.laneline_results[i] = LaneLine.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [stopline_results]
    // Deserialize array length for message field [stopline_results]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.stopline_results = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.stopline_results[i] = StopLine.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [boundary_results]
    // Deserialize array length for message field [boundary_results]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.boundary_results = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.boundary_results[i] = Boundary.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [freespace_results]
    // Deserialize array length for message field [freespace_results]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.freespace_results = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.freespace_results[i] = Freespace.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.laneline_results.forEach((val) => {
      length += LaneLine.getMessageSize(val);
    });
    object.stopline_results.forEach((val) => {
      length += StopLine.getMessageSize(val);
    });
    object.boundary_results.forEach((val) => {
      length += Boundary.getMessageSize(val);
    });
    object.freespace_results.forEach((val) => {
      length += Freespace.getMessageSize(val);
    });
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_perception_msgs/RoadStruct';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '17e6bd3455576324c10f73cc65f79d06';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    LaneLine[] laneline_results
    StopLine[] stopline_results
    Boundary[] boundary_results
    Freespace[] freespace_results
    
    ================================================================================
    MSG: ad_perception_msgs/LaneLine
    Point2f[] image_points
    Point2f[] world_points
    Point2f[] world_points_reproj
    float32 lane_confidence
    float32 color_confidence
    float32 line_confidence
    float32 edge_confidence
    bool fitting_on_img_plane
    # enum LaneType
    int16 id
    int32 track_id
    int32 track_age
    float32 distance_to_left_bumper
    float32 distance_to_right_bumper
    # enum LaneCategory
    int16 lane_category
    # enum ColorType
    int16 color_id
    # enum LineType
    int16 line_id
    # enum EdgeType
    int16 edge_id
    
    ================================================================================
    MSG: ad_perception_msgs/Point2f
    float32 x
    float32 y
    ================================================================================
    MSG: ad_perception_msgs/StopLine
    Point2f[] image_points
    Point2f[] world_points
    float32[] confidence
    int32 id
    ================================================================================
    MSG: ad_perception_msgs/Boundary
    Point2f[] image_points
    Point2f[] world_points
    
    float32 direction_x
    float32 direction_y
    
    float32 confidence
    
    bool is_line
    int32 id
    ================================================================================
    MSG: ad_perception_msgs/Freespace
    int32 id
    
    Point2f[] image_points
    Point2f[] world_points
    
    uint16 width
    uint16 height
    
    bool[] bit_map
    
    float32[] confidence
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RoadStruct(null);
    if (msg.laneline_results !== undefined) {
      resolved.laneline_results = new Array(msg.laneline_results.length);
      for (let i = 0; i < resolved.laneline_results.length; ++i) {
        resolved.laneline_results[i] = LaneLine.Resolve(msg.laneline_results[i]);
      }
    }
    else {
      resolved.laneline_results = []
    }

    if (msg.stopline_results !== undefined) {
      resolved.stopline_results = new Array(msg.stopline_results.length);
      for (let i = 0; i < resolved.stopline_results.length; ++i) {
        resolved.stopline_results[i] = StopLine.Resolve(msg.stopline_results[i]);
      }
    }
    else {
      resolved.stopline_results = []
    }

    if (msg.boundary_results !== undefined) {
      resolved.boundary_results = new Array(msg.boundary_results.length);
      for (let i = 0; i < resolved.boundary_results.length; ++i) {
        resolved.boundary_results[i] = Boundary.Resolve(msg.boundary_results[i]);
      }
    }
    else {
      resolved.boundary_results = []
    }

    if (msg.freespace_results !== undefined) {
      resolved.freespace_results = new Array(msg.freespace_results.length);
      for (let i = 0; i < resolved.freespace_results.length; ++i) {
        resolved.freespace_results[i] = Freespace.Resolve(msg.freespace_results[i]);
      }
    }
    else {
      resolved.freespace_results = []
    }

    return resolved;
    }
};

module.exports = RoadStruct;
