// Auto-generated. Do not edit!

// (in-package ad_perception_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let TrafficSign = require('./TrafficSign.js');
let TrafficLightGroup = require('./TrafficLightGroup.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class TrafficLightSignFrame {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.frame_timestamp_ns = null;
      this.sensor_id = null;
      this.traffic_sign = null;
      this.traffic_light_group_list = null;
      this.camera_name_list = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('frame_timestamp_ns')) {
        this.frame_timestamp_ns = initObj.frame_timestamp_ns
      }
      else {
        this.frame_timestamp_ns = 0;
      }
      if (initObj.hasOwnProperty('sensor_id')) {
        this.sensor_id = initObj.sensor_id
      }
      else {
        this.sensor_id = 0;
      }
      if (initObj.hasOwnProperty('traffic_sign')) {
        this.traffic_sign = initObj.traffic_sign
      }
      else {
        this.traffic_sign = [];
      }
      if (initObj.hasOwnProperty('traffic_light_group_list')) {
        this.traffic_light_group_list = initObj.traffic_light_group_list
      }
      else {
        this.traffic_light_group_list = [];
      }
      if (initObj.hasOwnProperty('camera_name_list')) {
        this.camera_name_list = initObj.camera_name_list
      }
      else {
        this.camera_name_list = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TrafficLightSignFrame
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [frame_timestamp_ns]
    bufferOffset = _serializer.int64(obj.frame_timestamp_ns, buffer, bufferOffset);
    // Serialize message field [sensor_id]
    bufferOffset = _serializer.int16(obj.sensor_id, buffer, bufferOffset);
    // Serialize message field [traffic_sign]
    // Serialize the length for message field [traffic_sign]
    bufferOffset = _serializer.uint32(obj.traffic_sign.length, buffer, bufferOffset);
    obj.traffic_sign.forEach((val) => {
      bufferOffset = TrafficSign.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [traffic_light_group_list]
    // Serialize the length for message field [traffic_light_group_list]
    bufferOffset = _serializer.uint32(obj.traffic_light_group_list.length, buffer, bufferOffset);
    obj.traffic_light_group_list.forEach((val) => {
      bufferOffset = TrafficLightGroup.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [camera_name_list]
    bufferOffset = _arraySerializer.string(obj.camera_name_list, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TrafficLightSignFrame
    let len;
    let data = new TrafficLightSignFrame(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [frame_timestamp_ns]
    data.frame_timestamp_ns = _deserializer.int64(buffer, bufferOffset);
    // Deserialize message field [sensor_id]
    data.sensor_id = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [traffic_sign]
    // Deserialize array length for message field [traffic_sign]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.traffic_sign = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.traffic_sign[i] = TrafficSign.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [traffic_light_group_list]
    // Deserialize array length for message field [traffic_light_group_list]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.traffic_light_group_list = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.traffic_light_group_list[i] = TrafficLightGroup.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [camera_name_list]
    data.camera_name_list = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.traffic_sign.forEach((val) => {
      length += TrafficSign.getMessageSize(val);
    });
    object.traffic_light_group_list.forEach((val) => {
      length += TrafficLightGroup.getMessageSize(val);
    });
    object.camera_name_list.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 22;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_perception_msgs/TrafficLightSignFrame';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '733f986f43ced8c9d7a1a8cd9cc1a1e0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp, and frame_id
    std_msgs/Header header
    
    int64 frame_timestamp_ns
    
    # enum SensorID
    int16 sensor_id
    
    # traffic sign
    TrafficSign[] traffic_sign
    
    # traffic light
    TrafficLightGroup[] traffic_light_group_list
    string[] camera_name_list
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_perception_msgs/TrafficSign
    ## BaseObject
    
    # enum SensorID
    int16 sensor_id
    # enum ObjectLabel
    int16 label
    float32 type_confidence
    float32 existence_confidence
    # enum ObjectLabel
    int16 sub_type
    
    float32[] sub_type_probs
    int32 track_id
    float32 track_age_time_second
    uint64 last_measure_update_timestamp_ns
    uint64 current_prediction_timestamp_ns
    
    SizeInfo size_info
    PolygonBox polygon_box
    DirectionInfo direction_info
    MotionInfo motion_info
    int16 motion_status
    float32 motion_static_score
    
    # enum MaintenanceStatus
    int16 maintenance_status
    # enum OcclusionStatus
    int16 occlusion_status
    
    # ModelOutputFeatures
    ModelOutputFeature[] feature
    
    ## TrafficSign Specific
    
    # CameraBBox2DInfo
    CameraBBox2DInfo camera_bbox_info
    
    ================================================================================
    MSG: ad_perception_msgs/SizeInfo
    bool is_valid
    
    Vector3f size
    Matrix3f size_uncertainty
    
    ================================================================================
    MSG: ad_perception_msgs/Vector3f
    float32 x
    float32 y
    float32 z
    ================================================================================
    MSG: ad_perception_msgs/Matrix3f
    Vector3f x
    Vector3f y
    Vector3f z
    
    ================================================================================
    MSG: ad_perception_msgs/PolygonBox
    bool is_valid
    Point2f[] polygon_contour
    float32 height_lower_surface
    float32 height_upper_surface
    ================================================================================
    MSG: ad_perception_msgs/Point2f
    float32 x
    float32 y
    ================================================================================
    MSG: ad_perception_msgs/DirectionInfo
    bool is_valid
    
    Vector3f direction_ypr
    Matrix3f direction_ypr_uncertainty
    float32 yaw
    float32 yaw_uncertainty
    float32 yaw_rate
    float32 yaw_rate_uncertainty
    
    ================================================================================
    MSG: ad_perception_msgs/MotionInfo
    bool is_valid
    
    # enum MotionStatus
    int16 motion_status
    
    Vector3d center
    Matrix3f center_uncertainty
    Vector3f velocity
    Matrix3f velocity_uncertainty
    Vector3f acceleration
    Matrix3f acceleration_uncertainty
    Vector3f jerk
    Matrix3f jerk_uncertainty
    float32 velocity_heading
    float32 velocity_heading_uncertainty
    float32 velocity_heading_rate
    float32 velocity_heading_rate_uncertainty
    
    ================================================================================
    MSG: ad_perception_msgs/Vector3d
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: ad_perception_msgs/ModelOutputFeature
    string key
    float32[] value
    ================================================================================
    MSG: ad_perception_msgs/CameraBBox2DInfo
    Bbox2D raw_detection_box
    Bbox2D tracked_box
    ================================================================================
    MSG: ad_perception_msgs/Bbox2D
    bool initialized
    float32 top_left_x
    float32 top_left_y
    float32 bottom_right_x
    float32 bottom_right_y
    float32 confidence
    ================================================================================
    MSG: ad_perception_msgs/TrafficLightGroup
    TrafficLight[] traffic_lights
    
    string group_id
    
    # TrafficSignal
    TrafficSignal color_label
    
    # TurnType
    TurnType turn_type
    
    float32 during_time
    ================================================================================
    MSG: ad_perception_msgs/TrafficLight
    uint64 timestamp_ns
    
    Bbox2D detected_bbox
    Bbox2D projected_bbox
    
    string id
    string group_id
    
    # TrafficSignal
    TrafficSignal color_label
    
    # TurnType
    TurnType turn_type
    
    float32 during_time
    ================================================================================
    MSG: ad_perception_msgs/TrafficSignal
    # enum TrafficSignal
    uint8 data
    
    uint8 SIGNAL_NONE=0           #0x00
    uint8 SIGNAL_GREEN=2          #0x02
    uint8 SIGNAL_YELLOW=4         #0x04
    uint8 SIGNAL_RED=8            #0x08
    uint8 SIGNAL_GREEN_FLASH=16   #0x10
    uint8 SIGNAL_YELLOW_FLASH=32  #0x20
    uint8 SIGNAL_BLACK=48         #0x40
    uint8 SIGNAL_GREEN_NUMBER=128 #0x80
    
    ================================================================================
    MSG: ad_perception_msgs/TurnType
    # enum TurnType
    uint16 data
    
    uint16 TURNTYPE_FREE=65535        #0xffff
    uint16 TURNTYPE_TURN_LEFT=1       #0x0001
    uint16 TURNTYPE_TURN_RIGHT=2      #0x0002
    uint16 TURNTYPE_LEFT_AROUND=4     #0x0004
    uint16 TURNTYPE_RIGHT_AROUND=8    #0x0008
    uint16 TURNTYPE_STRAIGHT=16       #0x0010
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TrafficLightSignFrame(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.frame_timestamp_ns !== undefined) {
      resolved.frame_timestamp_ns = msg.frame_timestamp_ns;
    }
    else {
      resolved.frame_timestamp_ns = 0
    }

    if (msg.sensor_id !== undefined) {
      resolved.sensor_id = msg.sensor_id;
    }
    else {
      resolved.sensor_id = 0
    }

    if (msg.traffic_sign !== undefined) {
      resolved.traffic_sign = new Array(msg.traffic_sign.length);
      for (let i = 0; i < resolved.traffic_sign.length; ++i) {
        resolved.traffic_sign[i] = TrafficSign.Resolve(msg.traffic_sign[i]);
      }
    }
    else {
      resolved.traffic_sign = []
    }

    if (msg.traffic_light_group_list !== undefined) {
      resolved.traffic_light_group_list = new Array(msg.traffic_light_group_list.length);
      for (let i = 0; i < resolved.traffic_light_group_list.length; ++i) {
        resolved.traffic_light_group_list[i] = TrafficLightGroup.Resolve(msg.traffic_light_group_list[i]);
      }
    }
    else {
      resolved.traffic_light_group_list = []
    }

    if (msg.camera_name_list !== undefined) {
      resolved.camera_name_list = msg.camera_name_list;
    }
    else {
      resolved.camera_name_list = []
    }

    return resolved;
    }
};

module.exports = TrafficLightSignFrame;
