
"use strict";

let Bbox2D = require('./Bbox2D.js');
let Vector4i = require('./Vector4i.js');
let Matrix3f = require('./Matrix3f.js');
let Boundary = require('./Boundary.js');
let MatchedSensorObjectInfo = require('./MatchedSensorObjectInfo.js');
let Point3f = require('./Point3f.js');
let Polygon3D = require('./Polygon3D.js');
let AutomobileLightStatus = require('./AutomobileLightStatus.js');
let Polygon2D = require('./Polygon2D.js');
let Vector3d = require('./Vector3d.js');
let RoadStruct = require('./RoadStruct.js');
let PedestrianIntention = require('./PedestrianIntention.js');
let PolygonBox = require('./PolygonBox.js');
let DirectionInfo = require('./DirectionInfo.js');
let NonAutomobileVehicleLightStatus = require('./NonAutomobileVehicleLightStatus.js');
let LidarDangerousZoneFrame = require('./LidarDangerousZoneFrame.js');
let ModelOutputFeature = require('./ModelOutputFeature.js');
let DepthDetPoint = require('./DepthDetPoint.js');
let StopLine = require('./StopLine.js');
let TrafficLightGroup = require('./TrafficLightGroup.js');
let CameraBBox2DInfo = require('./CameraBBox2DInfo.js');
let Object = require('./Object.js');
let Freespace = require('./Freespace.js');
let LidarDangerousZone = require('./LidarDangerousZone.js');
let TurnType = require('./TurnType.js');
let BaseCameraAttribute = require('./BaseCameraAttribute.js');
let VecPoint2f = require('./VecPoint2f.js');
let Point2f = require('./Point2f.js');
let LaneLine = require('./LaneLine.js');
let Vector3f = require('./Vector3f.js');
let RoadFrame = require('./RoadFrame.js');
let SizeInfo = require('./SizeInfo.js');
let ObjectFrame = require('./ObjectFrame.js');
let TrafficSignal = require('./TrafficSignal.js');
let TrafficLightSignFrame = require('./TrafficLightSignFrame.js');
let TrafficSign = require('./TrafficSign.js');
let MotionInfo = require('./MotionInfo.js');
let TrafficLight = require('./TrafficLight.js');

module.exports = {
  Bbox2D: Bbox2D,
  Vector4i: Vector4i,
  Matrix3f: Matrix3f,
  Boundary: Boundary,
  MatchedSensorObjectInfo: MatchedSensorObjectInfo,
  Point3f: Point3f,
  Polygon3D: Polygon3D,
  AutomobileLightStatus: AutomobileLightStatus,
  Polygon2D: Polygon2D,
  Vector3d: Vector3d,
  RoadStruct: RoadStruct,
  PedestrianIntention: PedestrianIntention,
  PolygonBox: PolygonBox,
  DirectionInfo: DirectionInfo,
  NonAutomobileVehicleLightStatus: NonAutomobileVehicleLightStatus,
  LidarDangerousZoneFrame: LidarDangerousZoneFrame,
  ModelOutputFeature: ModelOutputFeature,
  DepthDetPoint: DepthDetPoint,
  StopLine: StopLine,
  TrafficLightGroup: TrafficLightGroup,
  CameraBBox2DInfo: CameraBBox2DInfo,
  Object: Object,
  Freespace: Freespace,
  LidarDangerousZone: LidarDangerousZone,
  TurnType: TurnType,
  BaseCameraAttribute: BaseCameraAttribute,
  VecPoint2f: VecPoint2f,
  Point2f: Point2f,
  LaneLine: LaneLine,
  Vector3f: Vector3f,
  RoadFrame: RoadFrame,
  SizeInfo: SizeInfo,
  ObjectFrame: ObjectFrame,
  TrafficSignal: TrafficSignal,
  TrafficLightSignFrame: TrafficLightSignFrame,
  TrafficSign: TrafficSign,
  MotionInfo: MotionInfo,
  TrafficLight: TrafficLight,
};
