// Auto-generated. Do not edit!

// (in-package ad_prediction_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PredictionObject = require('./PredictionObject.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Prediction {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.prediction_time_ns = null;
      this.fusion_time_ns = null;
      this.object_list = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('prediction_time_ns')) {
        this.prediction_time_ns = initObj.prediction_time_ns
      }
      else {
        this.prediction_time_ns = 0;
      }
      if (initObj.hasOwnProperty('fusion_time_ns')) {
        this.fusion_time_ns = initObj.fusion_time_ns
      }
      else {
        this.fusion_time_ns = 0;
      }
      if (initObj.hasOwnProperty('object_list')) {
        this.object_list = initObj.object_list
      }
      else {
        this.object_list = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Prediction
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [prediction_time_ns]
    bufferOffset = _serializer.uint64(obj.prediction_time_ns, buffer, bufferOffset);
    // Serialize message field [fusion_time_ns]
    bufferOffset = _serializer.uint64(obj.fusion_time_ns, buffer, bufferOffset);
    // Serialize message field [object_list]
    // Serialize the length for message field [object_list]
    bufferOffset = _serializer.uint32(obj.object_list.length, buffer, bufferOffset);
    obj.object_list.forEach((val) => {
      bufferOffset = PredictionObject.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Prediction
    let len;
    let data = new Prediction(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [prediction_time_ns]
    data.prediction_time_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [fusion_time_ns]
    data.fusion_time_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [object_list]
    // Deserialize array length for message field [object_list]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.object_list = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.object_list[i] = PredictionObject.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.object_list.forEach((val) => {
      length += PredictionObject.getMessageSize(val);
    });
    return length + 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_prediction_msgs/Prediction';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ca48ca7a08f41a05f72ebfa484bd5ac5';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp(last node pub time), and frame_id
    std_msgs/Header header
    
    # Timestamp
    uint64 prediction_time_ns
    uint64 fusion_time_ns
    
    # Objects
    PredictionObject[] object_list
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_prediction_msgs/PredictionObject
    int32 id
    uint8 obstacle_type_enum
    uint8 object_label_enum
    
    float32 length_m
    float32 width_m
    float32 height_m
    
    geometry_msgs/Point[] polygon_contour
    
    geometry_msgs/Point position
    geometry_msgs/Point speed
    geometry_msgs/Point acceleration
    geometry_msgs/Point heading_direction
    
    uint8 info_state_enum
    uint8 scene_type_enum
    uint8 importance_level_enum
    uint16 move_step
    
    uint8 intention_type
    string target_road_id
    string target_lane_id
    
    PredictionTrajectory[] trajectory_array
    geometry_msgs/Point[] history_trajectory_points
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: ad_prediction_msgs/PredictionTrajectory
    string predictor_name
    string target_road_id
    string target_lane_id
    
    uint64 point_interval_time_ns
    uint32 num_points
    PredictionTrajectoryPoint[] trajectory_point_array
    
    # Info
    bool is_abnormal
    bool is_collision
    bool is_selected
    float32 probability
    float32 score
    
    ================================================================================
    MSG: ad_prediction_msgs/PredictionTrajectoryPoint
    geometry_msgs/Point[] polygon_contour
    
    geometry_msgs/Point position
    geometry_msgs/Point direction
    geometry_msgs/Point speed
    
    geometry_msgs/Point variance_position
    geometry_msgs/Point variance_speed
    
    float32 covariance_position
    float32 covariance_speed
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Prediction(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.prediction_time_ns !== undefined) {
      resolved.prediction_time_ns = msg.prediction_time_ns;
    }
    else {
      resolved.prediction_time_ns = 0
    }

    if (msg.fusion_time_ns !== undefined) {
      resolved.fusion_time_ns = msg.fusion_time_ns;
    }
    else {
      resolved.fusion_time_ns = 0
    }

    if (msg.object_list !== undefined) {
      resolved.object_list = new Array(msg.object_list.length);
      for (let i = 0; i < resolved.object_list.length; ++i) {
        resolved.object_list[i] = PredictionObject.Resolve(msg.object_list[i]);
      }
    }
    else {
      resolved.object_list = []
    }

    return resolved;
    }
};

module.exports = Prediction;
