// Auto-generated. Do not edit!

// (in-package ad_sensor_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class DualAntennaHeading {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.actual_time_ns = null;
      this.status = null;
      this.status_info = null;
      this.heading = null;
      this.heading_std_dev = null;
      this.pitch = null;
      this.pitch_std_dev = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('actual_time_ns')) {
        this.actual_time_ns = initObj.actual_time_ns
      }
      else {
        this.actual_time_ns = 0;
      }
      if (initObj.hasOwnProperty('status')) {
        this.status = initObj.status
      }
      else {
        this.status = 0;
      }
      if (initObj.hasOwnProperty('status_info')) {
        this.status_info = initObj.status_info
      }
      else {
        this.status_info = '';
      }
      if (initObj.hasOwnProperty('heading')) {
        this.heading = initObj.heading
      }
      else {
        this.heading = 0.0;
      }
      if (initObj.hasOwnProperty('heading_std_dev')) {
        this.heading_std_dev = initObj.heading_std_dev
      }
      else {
        this.heading_std_dev = 0.0;
      }
      if (initObj.hasOwnProperty('pitch')) {
        this.pitch = initObj.pitch
      }
      else {
        this.pitch = 0.0;
      }
      if (initObj.hasOwnProperty('pitch_std_dev')) {
        this.pitch_std_dev = initObj.pitch_std_dev
      }
      else {
        this.pitch_std_dev = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DualAntennaHeading
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [actual_time_ns]
    bufferOffset = _serializer.uint64(obj.actual_time_ns, buffer, bufferOffset);
    // Serialize message field [status]
    bufferOffset = _serializer.uint8(obj.status, buffer, bufferOffset);
    // Serialize message field [status_info]
    bufferOffset = _serializer.string(obj.status_info, buffer, bufferOffset);
    // Serialize message field [heading]
    bufferOffset = _serializer.float32(obj.heading, buffer, bufferOffset);
    // Serialize message field [heading_std_dev]
    bufferOffset = _serializer.float32(obj.heading_std_dev, buffer, bufferOffset);
    // Serialize message field [pitch]
    bufferOffset = _serializer.float32(obj.pitch, buffer, bufferOffset);
    // Serialize message field [pitch_std_dev]
    bufferOffset = _serializer.float32(obj.pitch_std_dev, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DualAntennaHeading
    let len;
    let data = new DualAntennaHeading(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [actual_time_ns]
    data.actual_time_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [status]
    data.status = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [status_info]
    data.status_info = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [heading]
    data.heading = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [heading_std_dev]
    data.heading_std_dev = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [pitch]
    data.pitch = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [pitch_std_dev]
    data.pitch_std_dev = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += _getByteLength(object.status_info);
    return length + 29;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_sensor_msgs/DualAntennaHeading';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a6a459798f1f8ea36a5417d45bba0297';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp(last node pub time), and frame_id(sensor model)
    std_msgs/Header header
    
    # Frame actual timestamp ns (or closest actual time)
    uint64 actual_time_ns
    
    # Sensor quality
    uint8 status
    # Sensor quality enum
    uint8 INVALID=0             # sensor offline
    uint8 BAD=1                 # sensor online, but can not use
    uint8 DOWNGRADE=2           # have issue, but can work
    uint8 PERFECT=3             # running well, nothing happend
    # For status debug
    string status_info
    
    # The heading is the angle from True North of the primary antenna to
    # secondary antenna vector in clockwise direction, in degrees (0 to 359.999)
    float32 heading
    # heading standard deviation in degrees
    float32 heading_std_dev
    
    # pitch angle in degrees (+-90)
    float32 pitch
    # pitch standard deviation in degrees
    float32 pitch_std_dev
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DualAntennaHeading(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.actual_time_ns !== undefined) {
      resolved.actual_time_ns = msg.actual_time_ns;
    }
    else {
      resolved.actual_time_ns = 0
    }

    if (msg.status !== undefined) {
      resolved.status = msg.status;
    }
    else {
      resolved.status = 0
    }

    if (msg.status_info !== undefined) {
      resolved.status_info = msg.status_info;
    }
    else {
      resolved.status_info = ''
    }

    if (msg.heading !== undefined) {
      resolved.heading = msg.heading;
    }
    else {
      resolved.heading = 0.0
    }

    if (msg.heading_std_dev !== undefined) {
      resolved.heading_std_dev = msg.heading_std_dev;
    }
    else {
      resolved.heading_std_dev = 0.0
    }

    if (msg.pitch !== undefined) {
      resolved.pitch = msg.pitch;
    }
    else {
      resolved.pitch = 0.0
    }

    if (msg.pitch_std_dev !== undefined) {
      resolved.pitch_std_dev = msg.pitch_std_dev;
    }
    else {
      resolved.pitch_std_dev = 0.0
    }

    return resolved;
    }
};

// Constants for message
DualAntennaHeading.Constants = {
  INVALID: 0,
  BAD: 1,
  DOWNGRADE: 2,
  PERFECT: 3,
}

module.exports = DualAntennaHeading;
