// Auto-generated. Do not edit!

// (in-package ad_sensor_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RadarContiCluster = require('./RadarContiCluster.js');
let RadarContiObject = require('./RadarContiObject.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class RadarConti {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.actual_time_ns = null;
      this.bus_fault = null;
      this.status_info = null;
      this.cluster_list = null;
      this.object_list = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('actual_time_ns')) {
        this.actual_time_ns = initObj.actual_time_ns
      }
      else {
        this.actual_time_ns = 0;
      }
      if (initObj.hasOwnProperty('bus_fault')) {
        this.bus_fault = initObj.bus_fault
      }
      else {
        this.bus_fault = 0;
      }
      if (initObj.hasOwnProperty('status_info')) {
        this.status_info = initObj.status_info
      }
      else {
        this.status_info = '';
      }
      if (initObj.hasOwnProperty('cluster_list')) {
        this.cluster_list = initObj.cluster_list
      }
      else {
        this.cluster_list = [];
      }
      if (initObj.hasOwnProperty('object_list')) {
        this.object_list = initObj.object_list
      }
      else {
        this.object_list = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RadarConti
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [actual_time_ns]
    bufferOffset = _serializer.uint64(obj.actual_time_ns, buffer, bufferOffset);
    // Serialize message field [bus_fault]
    bufferOffset = _serializer.uint8(obj.bus_fault, buffer, bufferOffset);
    // Serialize message field [status_info]
    bufferOffset = _serializer.string(obj.status_info, buffer, bufferOffset);
    // Serialize message field [cluster_list]
    // Serialize the length for message field [cluster_list]
    bufferOffset = _serializer.uint32(obj.cluster_list.length, buffer, bufferOffset);
    obj.cluster_list.forEach((val) => {
      bufferOffset = RadarContiCluster.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [object_list]
    // Serialize the length for message field [object_list]
    bufferOffset = _serializer.uint32(obj.object_list.length, buffer, bufferOffset);
    obj.object_list.forEach((val) => {
      bufferOffset = RadarContiObject.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RadarConti
    let len;
    let data = new RadarConti(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [actual_time_ns]
    data.actual_time_ns = _deserializer.uint64(buffer, bufferOffset);
    // Deserialize message field [bus_fault]
    data.bus_fault = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [status_info]
    data.status_info = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [cluster_list]
    // Deserialize array length for message field [cluster_list]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.cluster_list = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.cluster_list[i] = RadarContiCluster.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [object_list]
    // Deserialize array length for message field [object_list]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.object_list = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.object_list[i] = RadarContiObject.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += _getByteLength(object.status_info);
    length += 53 * object.cluster_list.length;
    length += 86 * object.object_list.length;
    return length + 21;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_sensor_msgs/RadarConti';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '78220c022b63ded3839bbaf7676bccb3';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp(last node pub time), and frame_id(sensor model)
    std_msgs/Header header
    
    # Frame actual timestamp ns (first can receive time)
    uint64 actual_time_ns
    
    # Sensor fault
    uint8 bus_fault
    # For status debug
    string status_info
    
    # Radar cluster or object array
    # Make empty if sensor unsupported
    RadarContiCluster[] cluster_list
    RadarContiObject[] object_list
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_sensor_msgs/RadarContiCluster
    # Basic CAN frame receive timestamp ns
    uint64 recv_time_ns
    
    # Radar cluster basic info
    uint8 track_id
    float32 distance_long           # point of the cluster (in meter)
    float32 distance_lat
    float32 velocity_long           # velocity of the cluster (in m/s)
    float32 velocity_lat
    float32 RCS                     # radar cross section (in dBm^2)
    uint8 dynamic_prop_enum         # dynamic property of the cluster indicating
    
    # Radar cluster quality info
    bool quality_vaild
    float32 distance_long_rms       # standard deviation (in meter)
    float32 distance_lat_rms
    float32 velocity_long_rms       # m/s
    float32 velocity_lat_rms
    float32 cluster_pdh0            # false alarm probability of cluster (in 0-1)
    uint8 ambig_state_enum          # state of doppler (radial velocity) ambiguity solution
    uint8 invalid_state_enum        # state of cluster validity state 
    
    ================================================================================
    MSG: ad_sensor_msgs/RadarContiObject
    # Basic CAN frame receive timestamp ns
    uint64 recv_time_ns
    
    # Radar object basic info
    uint8 track_id
    float32 distance_long           # center point of the object (in meter)
    float32 distance_lat
    float32 velocity_long           # velocity of the object (in m/s)
    float32 velocity_lat
    float32 RCS                     # radar cross section (in dBm^2)
    uint8 dynamic_prop_enum         # dynamic property of the object indicating
    
    # Radar object quality info
    bool quality_vaild
    float32 distance_long_rms       # standard deviation (in meter)
    float32 distance_lat_rms
    float32 velocity_long_rms       # m/s
    float32 velocity_lat_rms
    float32 accel_long_rms          # m/s^2
    float32 accel_lat_rms
    float32 orientation_rms         # radius
    float32 prob_of_exist           # 0-1
    uint8 measurement_state_enum
    
    # Radar object extend info
    bool extend_vaild
    float32 accel_long              # acceleration of the object (in m/s^2)
    float32 accel_lat
    float32 orientation             # yaw of the object orientation angel (in radius)
    float32 length
    float32 width
    uint8 object_type_enum
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RadarConti(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.actual_time_ns !== undefined) {
      resolved.actual_time_ns = msg.actual_time_ns;
    }
    else {
      resolved.actual_time_ns = 0
    }

    if (msg.bus_fault !== undefined) {
      resolved.bus_fault = msg.bus_fault;
    }
    else {
      resolved.bus_fault = 0
    }

    if (msg.status_info !== undefined) {
      resolved.status_info = msg.status_info;
    }
    else {
      resolved.status_info = ''
    }

    if (msg.cluster_list !== undefined) {
      resolved.cluster_list = new Array(msg.cluster_list.length);
      for (let i = 0; i < resolved.cluster_list.length; ++i) {
        resolved.cluster_list[i] = RadarContiCluster.Resolve(msg.cluster_list[i]);
      }
    }
    else {
      resolved.cluster_list = []
    }

    if (msg.object_list !== undefined) {
      resolved.object_list = new Array(msg.object_list.length);
      for (let i = 0; i < resolved.object_list.length; ++i) {
        resolved.object_list[i] = RadarContiObject.Resolve(msg.object_list[i]);
      }
    }
    else {
      resolved.object_list = []
    }

    return resolved;
    }
};

module.exports = RadarConti;
