// Auto-generated. Do not edit!

// (in-package ad_vehicle_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ModeCmd = require('./ModeCmd.js');
let ThrottleCmd = require('./ThrottleCmd.js');
let BrakeCmd = require('./BrakeCmd.js');
let SteeringCmd = require('./SteeringCmd.js');
let GearCmd = require('./GearCmd.js');
let Beam = require('./Beam.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class VehicleCmd {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.mode = null;
      this.throttle = null;
      this.brake = null;
      this.steering = null;
      this.gear = null;
      this.beam = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('mode')) {
        this.mode = initObj.mode
      }
      else {
        this.mode = new ModeCmd();
      }
      if (initObj.hasOwnProperty('throttle')) {
        this.throttle = initObj.throttle
      }
      else {
        this.throttle = new ThrottleCmd();
      }
      if (initObj.hasOwnProperty('brake')) {
        this.brake = initObj.brake
      }
      else {
        this.brake = new BrakeCmd();
      }
      if (initObj.hasOwnProperty('steering')) {
        this.steering = initObj.steering
      }
      else {
        this.steering = new SteeringCmd();
      }
      if (initObj.hasOwnProperty('gear')) {
        this.gear = initObj.gear
      }
      else {
        this.gear = new GearCmd();
      }
      if (initObj.hasOwnProperty('beam')) {
        this.beam = initObj.beam
      }
      else {
        this.beam = new Beam();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VehicleCmd
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [mode]
    bufferOffset = ModeCmd.serialize(obj.mode, buffer, bufferOffset);
    // Serialize message field [throttle]
    bufferOffset = ThrottleCmd.serialize(obj.throttle, buffer, bufferOffset);
    // Serialize message field [brake]
    bufferOffset = BrakeCmd.serialize(obj.brake, buffer, bufferOffset);
    // Serialize message field [steering]
    bufferOffset = SteeringCmd.serialize(obj.steering, buffer, bufferOffset);
    // Serialize message field [gear]
    bufferOffset = GearCmd.serialize(obj.gear, buffer, bufferOffset);
    // Serialize message field [beam]
    bufferOffset = Beam.serialize(obj.beam, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VehicleCmd
    let len;
    let data = new VehicleCmd(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [mode]
    data.mode = ModeCmd.deserialize(buffer, bufferOffset);
    // Deserialize message field [throttle]
    data.throttle = ThrottleCmd.deserialize(buffer, bufferOffset);
    // Deserialize message field [brake]
    data.brake = BrakeCmd.deserialize(buffer, bufferOffset);
    // Deserialize message field [steering]
    data.steering = SteeringCmd.deserialize(buffer, bufferOffset);
    // Deserialize message field [gear]
    data.gear = GearCmd.deserialize(buffer, bufferOffset);
    // Deserialize message field [beam]
    data.beam = Beam.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 33;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ad_vehicle_msgs/VehicleCmd';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '79b9b0a55b9064d7164c5085af0eb3fb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Header include seq, timestamp(last node pub time), and frame_id(ignored)
    std_msgs/Header header
    
    # Autodrive mode command
    ModeCmd mode
    # if 'VehicleReport.enable' report disable, canbus will ignore below
    
    # Drive-by-wire units
    ThrottleCmd throttle
    BrakeCmd brake
    SteeringCmd steering
    GearCmd gear
    
    # Assist devices
    Beam beam
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ad_vehicle_msgs/ModeCmd
    # Master switch, enable all vehicle domain
    bool enable
    
    ================================================================================
    MSG: ad_vehicle_msgs/ThrottleCmd
    # Throttle command
    float32 command
    uint8 command_type
    
    # Command types
    uint8 CMD_NONE=0
    uint8 CMD_PEDAL=1     # Unitless, mapping to pedal raw
    uint8 CMD_PERCENT=2   # Percent of maximum throttle, range 0 to 1
    
    ================================================================================
    MSG: ad_vehicle_msgs/BrakeCmd
    # Brake command
    float32 command
    uint8 command_type
    
    # Command types
    uint8 CMD_NONE=0
    uint8 CMD_PEDAL=1     # Unitless, mapping to pedal raw
    uint8 CMD_PERCENT=2   # Percent of maximum torque, range 0 to 1
    uint8 CMD_TORQUE=3    # Nm
    uint8 CMD_DECEL=4     # m/s^2
    
    # Parking Brake (0:release 1:lock)
    uint8 parking_brake
    
    ================================================================================
    MSG: ad_vehicle_msgs/SteeringCmd
    # Steering commands
    float32 command
    uint8 command_type
    
    float32 velocity    # deg/s
    
    # Command types
    uint8 CMD_NONE=0
    uint8 CMD_ANGLE=1   # clockwise means negative
    uint8 CMD_TORQUE=2
    
    ================================================================================
    MSG: ad_vehicle_msgs/GearCmd
    # Gear mode
    uint8 command
    
    # Gear enum
    uint8 GEAR_NONE=0
    uint8 GEAR_PARK=1
    uint8 GEAR_REVERSE=2
    uint8 GEAR_NEUTRAL=3
    uint8 GEAR_DRIVE=4
    uint8 GEAR_LOW=5
    
    ================================================================================
    MSG: ad_vehicle_msgs/Beam
    # Brake
    bool stop_lamp
    
    # Turn signal
    bool turn_left_lamp
    bool turn_right_lamp
    
    # Misc
    bool[8] reserved_lamp
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VehicleCmd(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.mode !== undefined) {
      resolved.mode = ModeCmd.Resolve(msg.mode)
    }
    else {
      resolved.mode = new ModeCmd()
    }

    if (msg.throttle !== undefined) {
      resolved.throttle = ThrottleCmd.Resolve(msg.throttle)
    }
    else {
      resolved.throttle = new ThrottleCmd()
    }

    if (msg.brake !== undefined) {
      resolved.brake = BrakeCmd.Resolve(msg.brake)
    }
    else {
      resolved.brake = new BrakeCmd()
    }

    if (msg.steering !== undefined) {
      resolved.steering = SteeringCmd.Resolve(msg.steering)
    }
    else {
      resolved.steering = new SteeringCmd()
    }

    if (msg.gear !== undefined) {
      resolved.gear = GearCmd.Resolve(msg.gear)
    }
    else {
      resolved.gear = new GearCmd()
    }

    if (msg.beam !== undefined) {
      resolved.beam = Beam.Resolve(msg.beam)
    }
    else {
      resolved.beam = new Beam()
    }

    return resolved;
    }
};

module.exports = VehicleCmd;
