# General Binary Release Toolkits

## Introduction
The general_binary_release folder provide a new method of managing binary release objects used in the saffron project. It provide several tools, as well as some developpable APIs.

## Overview of the binaries management system
The general binaries management system of saffron project has several parts: 
- AWS S3 bucket `s3://ad_binary_release` as remote storage platform.
- `XXX_manifest.xml` as a configuration and list of binaries released and tested in the project.
- `XXX_binary_release.json` as a configuration of the binaries management policy configuration file.
- `system/scripts/binary_release/general_binary_release/XXX_interface.py` as the interface of different operations.

## Usage
- `XXX_interface.py synchronize` synchronize local objects according to the XXX_manifest.xml in the project. It will check if the objects in the XXX_manifest.xml exist. If not, it will download the missing objects from AWS.
- `XXX_interface.py upload` upload local test objects that does not exist on the AWS. It will check the commit id of the git defined in `XXX_binary_release.json` and use it to differentiate local objects with remote objects.
- `XXX_interface.py release` change all test objects in the XXX_manifest.xml into release mode. That is, it will move listed objects from test path of aws defined in `XXX_binary_release.json` to release path and show the SHA256 checksum of the object. The releaser need to modify the manifest manually and then commit and push it on to remote git and merge.
- `XXX_interface.py query` provide some APIs to query and list the remote objects, to upload, download and move a remote file.

## Process

### To test a new object
- add new object to test in the test folder defined in `XXX_binary_release.json`.
- modify `XXX_manifest.xml`, change the name and mode of existing item, or add a new item if necessary
- (important) commit and push the `XXX_manifest.xml` to gerrit
- run `XXX_interface.py upload` to upload your test object

### To release a new object
- run `XXX_interface.py synchronize` to synchronize objects according to XXX_manifest.xml
- run `XXX_interface.py release` to release all test objects
- change `XXX_manifest.xml`, change mode from *test* to *release*, add *sha256* printed on the screen
- commit and push the `XXX_manifest.xml` to gerrit
- run ci if necessary
- merge the commit of `XXX_manifest.xml`

## Currently supported projects
- map
