#!/usr/bin/env bash

# shell script to get aws-endpoint-url from server
# will return 1 and write default endpoint-url to stdout if failed
# will return 0 and write currently configured endpoint-url to stdout if succeeded

# Usage(python) :
# from subprocess import Popen
# child = Popen("/path/to/this/script", stdout=sp.PIPE)
# endpoint_url = child.communicate()[0].decode('utf-8').strip('\n')
# rc = child.returncode 

# Usage(shell) :
# endpoint_url=`bash "/path/to/this/script"`
# rc = $?

curl_result=`curl -fsS http://10.151.176.42:8888/root/configs/AWS_config/endpoint_url`
if [[ $? -ne 0 ]];
then
  echo -e "\033[1;31m[ERROR]\033[0m failed to get current aws endpoint, will use the default one." >&2
  export AWS_CURRENT_ENDPOINT="http://10.5.41.234:80"
  echo $AWS_CURRENT_ENDPOINT
  exit 1
else
  export AWS_CURRENT_ENDPOINT=`echo $curl_result | head -n 1`
  echo $AWS_CURRENT_ENDPOINT
fi
