#pragma once

#include "ad_common/config_utils/macros.hpp"
#include "cereal/archives/binary.hpp"
#include "cereal/archives/json.hpp"
#include "cereal/archives/xml.hpp"
#include "cereal/archives/portable_binary.hpp"
namespace saffron {
namespace hdm {
struct HDMapParam {
    float64_t query_radius = 300;
    int32_t query_hdmap_hz = 1;
    float64_t scale_factor = 0.25;
};

REGISTER_CEREAL_SERIALIZE(HDMapParam& param) {  // NOLINT
    CEREAL_PAIR(param, query_radius);
    CEREAL_PAIR(param, query_hdmap_hz);
    CEREAL_PAIR(param, scale_factor);
}
}  // namespace hdm
}  // namespace saffron
