#pragma once
#include <string>
#include <vector>
#include <memory>
#include <unordered_map>

#include "map/data_type/hdmap_data.hpp"

namespace saffron {
namespace hdm {
class GroupTrafficLight {
 public:
    using ConstPtr = std::shared_ptr<const GroupTrafficLight>;
    using Ptr = std::shared_ptr<GroupTrafficLight>;
    using Table = std::unordered_map<std::string, Ptr>;
    using Vector = std::vector<ConstPtr>;

 public:
    GroupTrafficLight() = default;
    explicit GroupTrafficLight(GroupTrafficLightData &&data);
    explicit GroupTrafficLight(const GroupTrafficLightData &data);
    const GroupTrafficLightData &GetData() const;
    const std::vector<std::string> &GetTrafficLightIds() const;
    const std::string &GetId() const;
    uint16_t GetTurnType() const;
    bool ContainTurnLeft() const;
    bool ContainTurnRight() const;
    bool ContainLeftAround() const;
    bool ContainRightAround() const;
    bool ContainGoStraight() const;

 private:
    GroupTrafficLightData data_;
};
}  // namespace hdm
}  // namespace saffron
